<?php
/*======================================================
 * %%%%%%%%%%%%%PHPArdea CORE 2.0%%%%%%%%%%%%%%%%%%%%%%%
 * =====================================================
 * Author  : Maulana Al Matien.
 * Email   : ardea.core.php@gmail.com
 * Name    : ardeaCore.php
 * Date    :
 * Used for: Main library of ArdeaCore
 * ======================================================
 * Copyright Ardea Workshop. http://ardea-workshop.co.cc/ardeaCore.php
 * You allowed to use this component or parts of it under LGPLv3 terms
 * To use it on other terms or get Professional edition of the component
 * please contact us at ardea.core.php@gmail.com
*/
loadLib("lib.core.ardeaJs");
loadLib("lib.core.ardeaCss");
loadLib("lib.core.ardeaDebug");
loadLib("lib.core.ardeaURL");
loadLib("lib.core.ardeaProperty");
loadLib("lib.core.ardeaExtendProperty");
loadLib("lib.core.ardeaThemes");
loadLib("lib.core.db.ardeaDB");
loadLib("object.plugin.ardeaSmarty");
loadLib("lib.core.ardeaObject");
/**
 * @version		2.0
 * @package		lib
 * @subpackage	core
 * @author	Maulana al matien
 * @copyright Ardea-Workshop/Maulana Al Matien (2008-2009). All rights reserved.
 * @license http://www.gnu.org/licenses/lgpl-3.0.txt GNU Lesser General Public License (LGPLv3)
 */
class _ardeaCore {
    public $useThemes;
    public $autoJsEventHandler=false;
    protected $ardeaJs;
    protected $ardeaCss;
    protected $ardeaDebug;
    protected $ardeaURL;
    protected $ardeaKM;
    //protected $testString="DEFAULT";
    protected $useSmarty;
    protected $smarty;
    protected $strHTML;
    protected $themes;
    //protected $test;
    protected $Db;
    protected $recordSet;
    protected $activeForm;
    public $titlePage;
    protected $property;
    protected $typeRun;
    protected $jsFile=array();
    protected $xmlFile=array();
    protected $cssFile=array();
    protected $initUseObject="N";
    protected $tooltip=null;
    protected $menu=null;
    protected $scriptXMLTmp;
    protected $scriptCssTmp;
    protected $scriptJsTmp;
    protected $dataArray;
    protected $isStillConstruct=false;
    //var $initUseBuildObject="N";
    /**
     * Constructor
     *
     * @param string $id nama id;
     * automatically searches through the template paths.      *
     */
    function _ardeaCore() {
        $this->ardeaJs=new ardeaJs();
        $this->ardeaCss=new ardeaCss();
        $this->ardeaDebug=new ardeaDebug("Ardea Core");
        $this->ardeaURL=new ardeaURL();
        // $this->ardeaKM=new ardea
        $this->themes=new ardeaThemes();
        $this->useSmarty=true;
        //die("A");
        $this->Db=new ardeaDB('mysql',ARDEA_DB_DBNM);

        $this->titlePage="ARDEA CORE PAGE";
        if(LOAD_THEMES_FROM_FILE) {
            $this->themes->openXMLThemes();
        }
        $this->property=new property();
        $this->property->property["ardea_core_main"]=array();
        $this->property->property["ardea_core_main"]["background"]=null;
        $this->property->property["ardea_core_main"]["background_image"]=null;
    }
    //menu
    function addMenu($menuId,$caption) {
        if($this->menu==null) {
            loadLib("object.core.ardeaMenu");
            $this->menu=new menu("_ardea_menu_");
        }
        $this->menu->addMenu($menuId,$caption);
    }
    function pageStillConstruct() {
        $this->isStillConstruct=true;
    }
    function isPageStillConstruct() {
        return $this->isStillConstruct;
    }
    function addMenuItem($parentId,$itemId,$caption) {
        if($this->menu==null) {
            loadLib("object.core.ardeaMenu");
            $this->menu=new menu("_ardea_menu_");
        }
        $option=argToOption(func_get_args(),"onclick,icon_a,icon_b");
        $onclick=getOption($option,"onclick",3);
        $icon_a=getOption($option,"icon_a",4);
        $icon_b=getOption($option,"icon_b",5);
        $this->menu->addItem($parentId,$itemId,$caption,$onclick,$icon_a,$icon_b);
    }
    function info() {
        loadLib("lib.core.ardeaAbout");
        $abt=new ardeaAbout();
        $abt->build();
    }
    //URL
    function getURL($opt="all") {
        return $this->ardeaURL->getURL($opt);
    }
    function getPublicPath() {
        return ARDEA_CORE_DOMAIN."www";
    }
    //for init script css or xml
    function init($opt="all") {
        if($this->initUseObject!="N") {
            return false;
        }
        if($this->typeRun=='default')
            return true;
        switch($opt) {
            case "all":
                return true;
                break;
            case "xml":
                if($this->typeRun=='xml')
                    return true;
                break;
            case "jsxml":
                if($this->typeRun=='xml'||$this->typeRun=='cJs')
                    return true;
            case "js":
                if($this->typeRun=='cJs')
                    return true;
                break;
            case "css":
                if($this->typeRun=='cCss')
                    return true;
                break;
        }
    }
    function initContain($opt="all") {
        if($this->initUseObject!="N") {
            return false;
        }

        switch($opt) {
            case "default":
                if(!($this->typeRun=="default"))
                    return false;
                break;
            case "all":
                if(!($this->typeRun=='cJs'||$this->typeRun=='cCss'||$this->typeRun=='xml'))
                    return false;
                break;
            case "xml":
                if(!($this->typeRun=='xml'))
                    return false;
                break;
            case "js":
                if(!($this->typeRun=='cJs'))
                    return false;
                break;
            case "css":
                if(!($this->typeRun=='cCss'))
                    return false;
                break;
            case "pdf":
                if(!($this->typeRun=='pdf'))
                    return false;
                break;
        }
        return true;
    }
    function setInitUseObject($opt) {
        if($opt=="")
            $opt="N";
        $this->initUseObject=$opt;
    }
    function addTooltip($id,$cap) {
        if($this->tooltip==null) {
            loadLib("object.core.ardeaTooltip");
            $this->addJsPath($this->getURLJS("ardeaTimer.js"));
            $this->tooltip=new tooltip();
        }
        $this->tooltip->addTooltip($id,$cap);
    }
    function getInitUseObject() {
        return $this->initUseObject;
    }
    /*
    function setInitUseBuildObject($opt){
        if($opt=="")
            $opt="N";
       $this->initUseBuildObject=$opt;
    }
    function getInitUseBuildObject(){
        return $this->initUseBuildObject;
    }
     *
    */
    //create
    function createJsFile($fileName,$withSecurity=false) {
        if($this->typeRun)
            global $ardeaKM;
        return $this->jsFile[$fileName]=new jsFile($fileName,$withSecurity);
    }
    function setJsFileScriptTmp($script) {
        $this->scriptJsTmp=$script;
    }
    function getJsFileScriptTmp() {
        return $this->scriptJsTmp;
    }
    function createCssFile($fileName) {
        return  $this->cssFile[$fileName]=new cssFile($fileName,$withSecurity);
    }
    function setCssFileScriptTmp($script) {
        $this->scriptCssTmp=$script;
    }
    function getCssFileScriptTmp() {
        return $this->scriptCssTmp;
    }
    function createXMLFile($fileName) {
        return  $this->xmlFile[$fileName]=new xmlFile($fileName);
    }
    function setXMLFileScriptTmp($script) {
        $this->scriptXMLTmp=$script;
    }
    function getXMLFileScriptTmp() {
        return $this->scriptXMLTmp;
    }

    //for process
    function setTypeRun($newType) {
        if($newType=="") {
            $this->typeRun='default';
        }else {
            $this->typeRun=$newType;
        }
    }

    function getTypeRun() {
        return $this->typeRun;
    }

    function ardeaCorePipeProcess() {
        global $ardeaVar;
        //echo("form branch=".$this->typeRun);
        if($this->initUseObject!="N") {
            return false;
        }
        $run=$this->typeRun;
        //echo $run;
        switch($run) {
            case "cJs":
                $flName=$ardeaVar->getVar("fl","var_get",true);
                if($flName=='ardeaBaseInit')
                    return;
                $this->jsFile[$flName]->create();
                die();
                break;
            case "xml":
                $flName=$ardeaVar->getVar("fl","var_get",true);
                $this->xmlFile[$flName]->create();
                die();
                break;
            case "cCss":
                $flName=$ardeaVar->getVar("fl","var_get",true);
                //echo $flName;
                $this->cssFile[$flName]->create();
                die();
                break;
        }
    }

    function getRunType() {
        return $this->typeRun;
    }
    //for db
    function setSQL($sqlString) {
        $this->Db->setSQL($sqlString);
    }
    function getSQL() {
        return $this->Db->getSQL();
    }

    function goDB($inputArr=false) {
        $this->recordSet=$this->Db->execute('auto',$inputArr);
        $this->dataArray=$this->recordSet->fields;
    }
    function dbInsert($tableName,$arrayRecord) {
        $this->Db->autoExecute($tableName,'INSERT',$arrayRecord);
    }
    function dbUpdate($tableName, $arrayRecord,$extendQuery) {
        $this->Db->autoExecute($tableName,'update',$arrayRecord,$extendQuery);
    }
    function executeSQL($sqlString,$fetchMode=3,$inputArr=false) {
        $this->Db->setResultMode($fetchMode);
        return $this->Db->execute($sqlString,$inputArr);
    }
    /*
     * For ADODB
    function setSQL($sqlString){
        $this->Db->setSQL($sqlString);
    }
    function getSQL(){
        return $this->Db->getSQL();
    }
    function executeSQL($sqlString,$fetchMode=2,$inputArr=false){
        //echo $sqlString;
        return $this->Db->executeSQL($sqlString,$fetchMode,$inputArr);
    }
    function goDB($inputArr=false){
       $this->recordSet= $this->Db->getRecordset($inputArr);
    }
    function dbInsert($tableName,$arrayRecord){
        $this->Db->insertData($tableName,$arrayRecord);
    }
    function dbUpdate($tableName, $arrayRecord,$whereString){
        $this->Db->updateData($tableName,$arrayRecord,$whereString);
    }
    function setDBDebugOn(){
        $this->Db->setDebugOn();
    }
     *
    */
    function setDataArray($newArray) {
        //unset($this->recordSet);
        $this->dataArray=$newArray;
    }
    function getDataFormArray($fldName) {
        return $this->dataArray[$fldName];
    }
    function getData($field,$inputArr=false) {
        return $this->Db->getData($field,$inputArr);
    }
    function & getDB($ardeaDBConfClass=null) {
        if($ardeaDBConfClass==null) {
            return $this->Db;
        }else {
            if(is_object($ardeaDBConfClass)) {
                //var_dump($ardeaDBConfClass);
                //echo $ardeaDBConfClass->host. $ardeaDBConfClass->user. $ardeaDBConfClass->pass. $ardeaDBConfClass->dbname;
                $db=new ardeaDB('mysql');
                $db->connect($ardeaDBConfClass->host, $ardeaDBConfClass->user, $ardeaDBConfClass->pass, $ardeaDBConfClass->dbname);
                //die("CCC") ;
                return $db;
            }
        }

    }
    //for themes
    function getThemes() {
        return clone $this->themes;
    }
    function getString() {
        die($this->themes->toString());
    }

    function setThemes($newThemes) {
        $this->themes=$newThemes;
    }
    function loadThemesFromXML($themesName="defaultThemes") {
        $this->themes->openXMLThemes($themesName);
        $this->useThemes=true;
    }

    //for title
    function setTitlePage($newTitlePage) {
        $this->titlePage=$newTitlePage;
    }
    function setTitle($newTitlePage) {
        $this->titlePage=$newTitlePage;
    }
    function setBackgroundColor($colorHex) {
        $this->property->property["ardea_core_main"]["background"]=$colorHex;
    }
    function setBackground($urlImage) {
        $this->property->property["ardea_core_main"]["background_image"]=$urlImage;
    }
    //property area
    function exportProperty() {
        return $this->property->export();
    }
    function isPropertyHasExist($propertyName,$parentName="property") {
        return $this->property->isPropertyHasExist($propertyName,$parentName);
    }
    function importProperty($propertyObject) {
        global $ardeaCore;
        if(compareClassName("property",$propertyObject) or compareClassName("ardeaExtendProperty",$propertyObject)) {
            $this->property=$propertyObject;
        }else {
            $ardeaCore->setError("importObjectProperty","Object not initialized","objectObject/ardeaObject.php");
        }


    }

    function setProperty($propertyName,$value="",$parentProperty="property") {
        $this->property->setProperty($propertyName,$value,$parentProperty);
    }
    function addParentProperty($ParentPropertyName,$PropertyArray) {
        $this->property->addParentProperty($ParentPropertyName,$PropertyArray);
    }

    function getParentProperty($ParentPropertyName) {
        return $this->property->getParentProperty($ParentPropertyName);
    }

    function getProperty($propertyName,$parentName="property") {
        return $this->property->getProperty($propertyName,$parentName);
    }
    function deleteProperty($propertyName,$parentName="property") {
        $this->property->deleteProperty($propertyName,$parentName);
    }
    function buildProperty($option="style,property") {
        return $this->property->buildProperty($option);
    }
    //for JS

    function addInitScript($whatToInit,$isVbs='javascript') {
        if($this->typeRun=='default') {
            $isVbs=($isVbs=='vbscript')?true:false;
            $this->ardeaJs->addInitScript($whatToInit,$isVbs);
        }
    }
    function addScript($whatScript,$isVbs='javascript') {
        if($this->typeRun=='default') {
            $isVbs=($isVbs=='vbscript')?true:false;
            $this->ardeaJs->addScript($whatScript,$isVbs);
        }
    }
    function addScriptTmp($whatScript) {
        if($this->typeRun=='cJs') {
            //echo($_VAR_FILE_);
            global $_VAR_FILE_;
            if($_VAR_FILE_=='ardeaBaseInit') {
                global $_funcLoad;
                $_funcLoad->addScriptTmp($whatScript);
            }
        }
    }
    function addEventOnBody($eventName,$func) {
        if(!$this->property->isPropertyHasExist($eventName,"eventBody")) {
            $this->setProperty($eventName,$func.";","eventBody");
        }else {
            $this->setProperty($eventName,$this->getProperty($eventName,"eventBody").$func.";","eventBody");
        }
    }

    function getInitJs() {
        return $this->ardeaJs->getInitJs();
    }

    function regFunctionScript($functionName,$value,$type="javascript",$ver="default") {
        $this->ardeaJs->regScript($functionName,$value,$type,$ver);
    }
    function addJsFunction($functionName) {
        return $this->ardeaJs->addJsFunction($functionName);
    }
    function getJsFunction($functionName) {
        return $this->ardeaJs->getJsFunction($functionName);
    }
    function addJsPath($whatJsPath,$useCorePath=false) {
        if($useCorePath) {
            $this->ardeaJs->addJsPath(ARDEA_CORE_JS."/".$whatJsPath);
        }else {
            $this->ardeaJs->addJsPath($whatJsPath);
        }
    }
    function getJsPath() {
        return $this->ardeaJs->getJsPath();
    }
    function  getJs() {
        return $this->ardeaJs;
    }
    function & getJsFile($jsName=null) {
        if($jsName==null) {
            return $this->jsFile;
        }else {
            if(array_key_exists($jsName,$this->jsFile)) {
                return $this->jsFile[$jsName];
            }else {
                $tmp=array();
                return $tmp;
            }
        }
    }
    function & getTooltip() {
        return $this->tooltip;
    }
    function & getMenu() {
        return $this->menu;
    }
    //for css
    function addStyle($whatScript) {
        $this->ardeaCss->addStyle($whatScript);
    }
    function addStyleClass($ClassName,$value,$optionClass) {
        $this->ardeaCss->regCss($functionName,$value,$optionClass);
    }
    function addCssPath($whatJsPath,$useCorePath=false) {
        if($useCorePath) {
            $this->ardeaCss->addCssPath(ARDEA_CORE_CSS."/".$whatJsPath);
        }else {
            $this->ardeaCss->addCssPath($whatJsPath);
        }

    }
    function getCssPath() {
        return $this->ardeaCss->getCssPath();
    }
    function getCss() {
        return $this->ardeaCss;
    }
    function & getCssFile() {
        return $this->cssFile;
    }
    //for info
    function toString() {
        return "Ardea core Ver ".ARDEA_CORE_VER;
    }
    function testString($newValue) {
        $this->testString=$newValue;
    }
    function getTestString() {
        return $this->testString;
    }
    //for debug
    function setDebugOn() {
        $this->ardeaDebug->setDebug();
    }
    function setError($functionName,$whatMessage,$className="") {
        $this->ardeaDebug->setError($functionName,$whatMessage,$className);
    }
    //for path
    function setDefaultPathForThemes($newPath) {
        $this->ardeaURL->changeThemesURL($newPath);
    }
    function getURLJS($fileOfJS,$isPlugin=false) {
        return  $this->ardeaURL->getURLJS($fileOfJS,$isPlugin);
    }
    function getURLPDF($fileName) {
        global $ardeaKM;
        global $ardeaKM;
        global $_ARDEA_CONFIG;
        if($_ARDEA_CONFIG["security_on"]) {
            $key=$ardeaKM->getKey($this->getURL('name'),'pdf',false);
            return $this->getURL()."?optsc=a_s_c_r_".$key."&fl=".$fileName."&ob=Y&fl_ty=inline";
        }else {
            return $this->getURL()."?optsc=pdf"."&fl=".$fileName."&ob=Y&fl_ty=inline";
        }
    }
    function getURLCSS($fileOfCss,$isPlugin=false) {
        return $this->ardeaURL->getURLCSS($fileOfCss,$isPlugin);
    }
    function getURLIMAGE($fileOfImage='',$isPlugin=false) {
        return $this->ardeaURL->getURLIMAGE($fileOfImage,$isPlugin);
    }
    //for smarty
    function setUseSmarty($boolUseSmarty) {
        $this->useSmarty=$boolUseSmarty;
    }
    function isUseSmarty() {
        return $this->useSmarty;
    }
    //for HTML need
    function clearContain() {
        $this->strHTML="";
    }
    function getDebugResult() {
        return $this->ardeaDebug->showError();
    }

    function addContain($containHTML) {
        //var_dump($containHTML);
        $this->strHTML.=$containHTML."\n";
    }
    function addObject($ardeaObject) {
        $ardeaObject->build();
        $this->strHTML.=$ardeaObject->getHTML()."\n";
    }
    function getURLARG() {
        foreach($_GET as $key=>$value) {
            $str.="&".$key."=".$value;
        }
        return $str;
    }
    function setContain($containHTML) {
        $this->strHTML=$containHTML;
    }
    //for building
    function createHTML($containHTML=null) {
        global $_pdf;
        global $_initJs;
        global $_ARDEA_CONFIG;
        global $ardeaVar;
        global $_VAR_FILE_;
        global  $_funcLoad;
        if($containHTML!=null)
            $this->strHTML.=$containHTML;
        //die(var_dump($this->strHTML));
        if($this->typeRun=="cCss"||$this->typeRun=="cJs"||$this->typeRun=="xml") {
            if($this->initUseObject!="N") {
                die();
            }
            if($this->typeRun=="xml") {
                return;
            }
            if($this->typeRun=="cCss") {
                $fl_Name=$ardeaVar->getVar("fl","var_get",true);
                if(array_key_exists($fl_Name,$this->cssFile))
                    $this->cssFile[$fl_Name]->create();
                die();
            }
            if($this->typeRun=="cJs") {
                if($_VAR_FILE_=='ardeaBaseInit') {
                    if($this->tooltip!=null) {
                        $this->tooltip->build();
                    }
                    if($this->menu!=null)
                        $this->menu->build();
                    $allVar=  $this->property->property["ardea_core_main"];
                    //var_dump($allVar);
                    if($allVar["background"]!=null)
                        $_funcLoad->addScript("document.body.style.backgroundColor='".$allVar["background"]."';");
                    if($allVar["background_image"]!=null)
                        $_funcLoad->addScript("document.body.style.backgroundImage='url(".$allVar["background_image"].")';");
                    if($this->autoJsEventHandler) {
                        $_funcLoad->addScriptTmp("ardeaObject.init();");
                        $_funcLoad->addScriptTmp("ardeaInitObject();");
                    }
                }
                $fl_Name=$ardeaVar->getVar("fl","var_get",true);

                if(array_key_exists($fl_Name,$this->jsFile))
                    $this->jsFile[$fl_Name]->create();
                die();
            }
        }
        if($_ARDEA_CONFIG["load_init_js"]) {
            if($_ARDEA_CONFIG["security_on"])
                $this->createJsFile('ardeaBaseInit',true);
            else
                $this->createJsFile('ardeaBaseInit');
        }

        $this->smarty=new ardeaSmarty();

        if($this->typeRun!="pdf") {
            $this->smarty->assign('title',$this->titlePage);
            $this->smarty->assign('jsPath',$this->getJsPath());
            $this->ardeaJs->buildJs();
            //die(var_dump($this->ardeaJs));
            $this->smarty->assign('error',$this->getDebugResult());
            $this->smarty->assign('initVer',$this->ardeaJs->getVersion());
            $this->smarty->assign('initScript',$this->ardeaJs->getScriptName());
            $this->smarty->assign('initValue',$this->ardeaJs->getValue());
            $this->smarty->assign('initJs',$this->getInitJs());
            $this->smarty->assign('initVbs',$this->ardeaJs->getInitVbs());

            $this->smarty->assign('initStyle',$this->ardeaCss->buildStyle());
            $this->smarty->assign('initStylePrint',$this->ardeaCss->buildStyleForPrint());
            $this->smarty->assign('eventonbody',$this->buildProperty("eventBody"));
        }
        $this->smarty->assign('cssPath',$this->getCssPath());
        //$this->smarty->assign('initCss',$this->ardeaCss->buildStyle());

        //$this->smarty->assign('contain',$this->strHTML);
        //    if($this->typeRun=="pdf"){
        //        //echo $this->smarty->fetch('default.tpl');
        //            $_pdf->addPage();
        //            $_pdf->WriteHTML($this->smarty->fetch('default.tpl'));
        //    }else{
        //    $this->smarty->display('default.tpl');
        //    }
        $this->smarty->assign('contain',"<#ardeacore#contain#>");
        if($this->typeRun=="pdf") {
            //echo $this->smarty->fetch('default.tpl');
            $_pdf->addPage();
            $htmlComplete=$this->smarty->fetch('default.tpl');
            $htmlComplete=str_replace("<#ardeacore#contain#>",$this->strHTML,$htmlComplete);
            $_pdf->WriteHTML($htmlComplete);
        }else {
            $htmlComplete=$this->smarty->fetch('default.tpl');
            $htmlComplete=str_replace("<#ardeacore#contain#>",$this->strHTML,$htmlComplete);
            echo $htmlComplete;
        }
    }
    //for form
    function getSmarty() {
        return  $this->smarty;
    }
    function setActiveForm($newFormName) {
        $this->activeForm=$newFormName;
    }
    function getActiveForm() {
        return $this->activeForm;
    }
}

?>
