<?php
/*======================================================
 * %%%%%%%%%%%%%PHPArdea CORE 2.0%%%%%%%%%%%%%%%%%%%%%%%
 * =====================================================
 * Author  : Maulana Al Matien.
 * Email   : ardea.core.php@gmail.com
 * Name    : ardeaCss.php
 * Date    : 
 * Used for: library for Css
 * ======================================================
 * Copyright Ardea Workshop. http://ardea-workshop.co.cc/ardeaCore.php
 * You allowed to use this component or parts of it under LGPLv3 terms
 * To use it on other terms or get Professional edition of the component 
 * please contact us at ardea.core.php@gmail.com
*/   
/**
 * @version		2.0
 * @package		lib
 * @subpackage	core
 * @author	Maulana al matien
 * @copyright Ardea-Workshop/Maulana Al Matien (2008-2009). All rights reserved.
 * @license http://www.gnu.org/licenses/lgpl-3.0.txt GNU Lesser General Public License (LGPLv3)
 */
class ardeaCss {
    private $CssPath=array();
    private $regStyle=array();
    private $regStyleNotPrinted=array();
    private $cssStr=array();
    function ardeaCss() {
    }
    function toString() {
        return "Ardea Css";
    }

    function addCssPath($whatJsPath) {
        if(!$this->isCssPathHasLoad($whatJsPath))
            $this->CssPath[count($this->CssPath)]=$whatJsPath;
    }
    function addStyle($script) {
        $this->cssStr[]=$script."\n";
    }
    function isCssPathHasLoad($whatCssPath) {
        $boolResult=false;
        foreach($this->CssPath as $val ) {
            if(strtolower($whatCssPath)==strtolower($val)) {
                $boolResult=true;
                break;
            }
        }
        return $boolResult;
    }
    function getCssPath() {
        return $this->CssPath;
    }
    function regStyle($className,$value,$optionClass="id") {
        $value=str_replace("style=","",$value);
        $value=str_replace("\"","",$value);
        $value=str_replace(";",";\n",$value);
        if($optionClass=="id") {
            $value="#".$className."{\n".$value."}\n";
        }else if($optionClass=="class") {
            $value=".".$className."{\n".$value."}\n";
        }else if($optionClass=="tag") {
            $value=$className."{\n".$value."}\n";
        }
        if(!array_key_exists($className,$this->regStyle)) {
            $this->regStyle[$className]=$value;
        }
    }
    function buildStyle() {
        $tmpbuildStyle="";
        foreach($this->cssStr as $value) {
            $tmpbuildStyle.=$value."\n";
        }

        if(count($this->regStyle)) {
            foreach($this->regStyle as $value) {
                $tmpbuildStyle.=$value;
            }
        }

        return $tmpbuildStyle;
    }
    function regNotPrinted($idElement,$type="id") {
        if(!array_key_exists($idElement,$this->regStyleNotPrinted)) {
            if($type=="id") {
                $this->regStyleNotPrinted[$idElement]="#".$idElement."{display:none};\n";
            }else if($type=="class") {
                $this->regStyleNotPrinted[$idElement]=".".$idElement."{display:none};\n";
            }else {
                $this->regStyleNotPrinted[$idElement]=$idElement."{display:none};\n";
            }
        }
    }
    function buildStyleForPrint() {
        $tmpbuildStyle="";
        if(count($this->regStyle)) {
            foreach($this->regStyleNotPrinted as $value) {
                $tmpbuildStyle.=$value;
            }
        }
        return $tmpbuildStyle;
    }
}    
class css {
    private $cssStr=array();
    private $type="";
    private $className="";
    function css($name,$type="class") {
        $this->type=$type;
        $this->className=$name;
    }
    function addStyle($script) {
        $this->cssStr[]=$script."\n";
    }
    function build() {
        $tmpBuild="";
        foreach($this->cssStr as $value) {
            $tmpBuild.=$value."\n";
        }
        if($this->type=="id") {
            return "#".$this->className."{\n".$tmpBuild."}\n";
        }else if($this->type=="class") {
            return ".".$this->className."{\n".$tmpBuild."}\n";
        }else if($this->type=="tag") {
            return $this->className."{\n".$tmpBuild."}\n";
        }
    }
}

class cssFile {
    var $cssClass=array();
    var $name="";
    var $css=array();
    private $fromFile=false;
    private $urlFile="";
    function setDataFromFile($urlFile) {
        $this->fromFile=true;
        $this->urlFile=$urlFile;
    }
    function cssFile($fileName) {
        global $ardeaCore;
        global $ardeaKM;
        $this->name=$fileName;
        if($withSecurity) {
            $key=$ardeaKM->getKey($ardeaCore->getURL('name'),'cCss',false);
            $ardeaCore->addCssPath($ardeaCore->getURL()."?optsc=a_s_c_r_".$key."&fl=".$fileName);
        }else {
            $ardeaCore->addCssPath($ardeaCore->getURL()."?optsc=cCss&fl=".$fileName);
        }
    }
    function addStyle($style) {
        $this->css[]=$style;
    }
    function getName() {
        return $this->name;
    }
    function create() {
        global $ardeaCore;
        $data="";
        if(!$this->fromFile) {
            foreach($this->css as $value) {
                $data.=$value."\n";
            }
            //var_dump($this->cssClass);
            foreach($this->cssClass as $value) {
                $data.=$value->build()."\n";
            }
            $ardeaCore->setCssFileScriptTmp($data);
        }else {

            if($this->$urlFile=="") {
                //die("ERROR path not defined");
            }
            if ( file_exists( $this->$urlFile) ) {
                ob_start();
                include( $this->$urlFile);
                $data = ob_get_contents();
                ob_end_clean();
            }
        }
        echo $data;
    }
    function addClass($className,$type="class") {
        return $this->cssClass[$className]=new css($className,$type);
    }
}
?>
