<?php
/*======================================================
 * %%%%%%%%%%%%%PHPArdea CORE 2.0%%%%%%%%%%%%%%%%%%%%%%%
 * =====================================================
 * Author  : Maulana Al Matien.
 * Email   : ardea.core.php@gmail.com
 * Name    : ardeaDOM.php
 * Date    :
 * Used for: library for Manage XML
 * ======================================================
 * Copyright Ardea Workshop. http://ardea-workshop.co.cc/ardeaCore.php
 * You allowed to use this component or parts of it under LGPLv3 terms
 * To use it on other terms or get Professional edition of the component
 * please contact us at ardea.core.php@gmail.com
*/
/**
 * @version		2.0
 * @package		lib
 * @subpackage	core
 * @author	Maulana al matien
 * @copyright Ardea-Workshop/Maulana Al Matien (2008-2009). All rights reserved.
 * @license http://www.gnu.org/licenses/lgpl-3.0.txt GNU Lesser General Public License (LGPLv3)
 */
class ardeaDOM {
    private $DOM="";
    private $tmptoArray=array();
    private $version="";
    private $DOMPATH="";
    function ardeaDOM() {
        $option=argToOption(func_get_args(),"filename,ver,encode");
        $ver=getOption($option,"ver");
        $encode=getOption($option,"encode",1);
        $this->init("ver=".$ver,"encode=".$encode);
    }
    private function init() {
        $option=argToOption(func_get_args(),"ver,encode");
        $ver=getOption($option,"ver");
        $encode=getOption($option,"encode",1);
        if($ver&&$ver!=""&&$encode&&$encode!="") {
            $this->DOM=new DOMDocument($ver,$encode);
        }else if($ver&&$ver!="") {
            $this->DOM=new DOMDocument($ver);
        }else {
            $this->DOM=new DOMDocument();
        }
        $this->version=$ver;
        $this->DOM->formatOutput = true;
    }
    function setDOMPATH() {
        $this->DOMPATH=new DOMXPath($this->DOM);
    }
    function setHeader($fl="default",$type='inline') {
        header('Content-type: application/xml');
        header('Content-Disposition: '.$type.'; filename="'.$fl.'.xml"');
    }
    function createElement() {
        $option=argToOption(func_get_args(),"parent,key,attribute,text");
        $parent=getOption($option,"parent");
        $key=getOption($option,"key",1);
        $attribute=getOption($option,"attribute",2);
        $text=getOption($option,"text",3);
        //var_dump($key);
        $elem=$this->DOM->createElement($key);
        if($text&&$text!="") {
            $text=$this->DOM->createTextNode($text);
            $elem->appendChild($text);
            //echo "MASUK TEXT";
        }
        if($attribute) {
            if(is_array($attribute)) {
                foreach($attribute as $key => $value) {
                    // echo "MASUK ATT";
                    //if(is_array($value))
                    $elem->setAttribute($key,$value);
                }
            }
        }
        if($parent) {
            if($parent=="root") {
                //echo "MASUK ROOOT";
                $this->DOM->appendChild($elem);

            }else {
                if(compareClassName("DOMElement",$parent))
                    $parent->appendChild($elem);
            }
        }
        return $elem;
    }
    function open() {
        $option=argToOption(func_get_args(),"as");
        $as=getOption($option,"as",1);
        $fl=getOption($option,"fl");
        if($as=="")
            $as="xmlfile";
        if($fl=="")
            return ;
        $this->DOM->validateOnParse = true;
        if($this->version=="")
            $tmpDoc=new DOMDocument();
        else {
            $tmpDoc=new DOMDocument($this->version);
        }
        if($as) {
            switch($as) {
                case "xml":
                    $tmpDoc->loadXML($fl);
                    $this->DOM=& $tmpDoc;
                    //$this->DOM->loadXML($fl);
                    break;
                case "xmlfile":
                    $tmpDoc->load($fl);
                    $this->DOM=& $tmpDoc;
                    //$this->DOM->load($fl);
                    break;
                case "html":
                    $tmpDoc->loadHTML($fl);
                    $this->DOM=& $tmpDoc;
                    //$this->DOM->loadHTML($fl);
                    break;
                case "htmlfile":
                    $tmpDoc->loadHTMLFile($fl);
                    $this->DOM=& $tmpDoc;
                    //$this->DOM->loadHTMLFile($fl);
                    break;
            }
        }
        //die(var_dump($this->DOM->documentElement));
    }
    function write() {
        global $ardeaCore;
        $option=argToOption(func_get_args(),"as,filename,type,dispos");
        $as=getOption($option,"as");
        $fileName=getOption($option,"filename",1);
        $type=getOption($option,"type",2);
        $dispos=getOption($option,"dispos",3);
        if($as=="")
            $as="xml";
        switch(strtolower($as)) {
            case "xmlfile":
                $this->DOM->save();
                break;
            case "xml":
                $data=$this->DOM->saveXML();
                $ardeaCore->setXMLFileScriptTmp($data);
                echo $data;//$this->DOM->saveXML();
                break;
            case "xml+header":
                if($type=="")
                    $type="application/xml";
                if($dispos=="")
                    $dispos="inline";
                //echo 'Content-type: '.$type;
                //echo 'Content-Disposition:'.$dispos.'; filename="'.fileName.'.xml"';
                header('Content-type: '.$type);
                header('Content-Disposition:'.$dispos.'; filename="'.$fileName.'.xml"');
                $data=$this->DOM->saveXML();
                $ardeaCore->setXMLFileScriptTmp($data);
                echo $data;//$this->DOM->saveXML();
                //echo $this->DOM->saveXML();
                break;
            case "html":
                echo $this->DOM->saveHTML();
                break;
            case "htmlfile":
                $this->DOM->saveHTMLFile();
                break;

        }
    }
    function append() {
        $option=argToOption(func_get_args(),"parent,key,attribute,text");
        $parent=getOption($option,"parent");
        $key=getOption($option,"key",1);
        if($parent&&$key) {
            if(!compareClassName("DOMElement",$parent))
                $parent=$this->DOM->getElementById($parent);
            if(!compareClassName("DOMElement",$elem))
                $elem=$this->DOM->getElementById($elem);
            if($parent!=NULL&&$elem!=NULL)
                $parent->appendChild($elem);
        }
    }
    function toArray() {
        $tmpArray=array();
        $items=$this->DOM->documentElement;
        if($items==NULL)
            return;
        $this->tmptoArray[$items->nodeName]=array();
        $this->getAtt($items,$this->tmptoArray[$items->nodeName]);
        $this->_toArray($items->childNodes,$this->tmptoArray[$items->nodeName]);
        if($items->nextSibling!=NULL) {
            do {
                $items=$items->nextSibling;
                $this->tmptoArray[$items->nodeName]=array();
                $this->getAtt($items,$this->tmptoArray[$items->nodeName]);
                $this->_toArray($items->childNodes,$this->tmptoArray[$items->nodeName]);

            }while ($items->nextSibling!=NULL);
        }
        //print_r($this->tmptoArray);
        return $this->tmptoArray;
    }
    function getAtt($child,& $tmpArr) {
        $i_toArray=0;
        $tmp_toArray=array();
        if($child->attributes!=NULL) {
            $tmp_toArray=$child->attributes;
            do {
                $x=$tmp_toArray->item($i_toArray);
                if($x->name!=NULL) {
                    if(!is_array($tmpArr['attribute'])) {
                        $tmpArr['attribute']=array();
                    }
                    $tmpArr['attribute'][$x->name]=$x->value;
                    //$tmpArr['attribute'][]=array($x->name,$x->value);
                }
                $i_toArray++;
            }while($tmp_toArray->item($i_toArray)!=NULL);

        }
    }
    private function _toArray($domnode,& $tmpArr) {
        $i_toArray=0;
        $childCount=0;
        $boolNext=false;
        $boolLebihSatuNode=false;
        $posLebihSatuNode=0;
        if($domnode==NULL)
            return;

        foreach($domnode as $child) {
            if($child->nodeName=="#text") {
                $strTmp=trim(str_replace("\n","",$child->nodeValue));
                if(strlen($strTmp)>0)
                    $tmpArr['text']=$strTmp;
            }else {
                if($child->hasChildNodes()) {

                    if($childCount==0)
                        $tmpArr["child"]=array();
                    if($this->countNodeTag($child->nodeName,$child->parentNode->nodeValue)>1) {
                        if($childCount==0)
                            $tmpArr["child"][$child->nodeName]=array();
                        $tmpArr["child"][$child->nodeName][$childCount]=array();
                        $boolLebihSatuNode=true;
                        $posLebihSatuNode=$childCount;
                        $this->getAtt($child,$tmpArr["child"][$child->nodeName][$childCount]);
                    }else {
                        $tmpArr["child"][$child->nodeName]=array();
                        $this->getAtt($child,$tmpArr["child"][$child->nodeName]);
                    }
                    $boolNext=true;
                    $childCount++;

                }

            }

            if($child->hasChildNodes()) {
                if(!$boolNext) {
                    $tmpArr['child']=array();
                    $this->_toArray($child->childNodes,$tmpArr['child']);
                }else {
                    if(!$boolLebihSatuNode) {
                        $this->_toArray($child->childNodes,$tmpArr["child"][$child->nodeName]);
                    }else {
                        $this->_toArray($child->childNodes,$tmpArr["child"][$child->nodeName][$posLebihSatuNode]);
                    }
                }

            }
        }

    }
    private function countNodeTag($nodeName,$parentValue) {
        $tmpcountNodeTag=$this->DOM->getElementsByTagName($nodeName);
        $jmlNode=0;
        foreach($tmpcountNodeTag as $c) {
            if($c->parentNode->nodeValue==$parentValue)
                $jmlNode++;
        }
        return $jmlNode;
    }
    function toXML($arrayXML) {
        if(!compareClassName('node',$arrayXML)) {
            $attr="";
            $chld="";
            $text="";
            $keyChild="";
            foreach($arrayXML  as $key => $valueToXml) {
                $this->getStdPropFormArray($valueToXml,$attr,$text,$chld,$keyChild);
                $node=$this->createElement("root",$key,$attr,$text);
                if(is_array($chld))
                    $this->_toXML($chld,$node,$key);
            }
        }else {
            if(!is_array($arrayXML)) {
                $root=$this->createElement('root',$arrayXML->name,$arrayXML->attribute,$arrayXML->text);
                if($arrayXML->child!=null) {
                    //die(var_dump($arrayXML->child));
                    foreach($arrayXML->child as $value) {
                        $this->_toXmlNode($value,$root);
                    }
                }
                if(is_array($arrayXML->arr2D)) {
                    $this->_toXmlNode2D($arrayXML->arr2D,$root);
                }
                /*
               if(is_array($arrayXML->arr2D)){

                   foreach($arrayXML->arr2D as $key => $value){
                        //$nodeA=$this->createElement($root,$arrayXML->arr2D[$key]->name,$arrayXML->arr2D[$key]->attribute,$arrayXML->arr2D[$key]->text);
                        //$nodeSA=$this->createElement($nodeA,$value->name,$value->attribute,$value->text);
                        if(is_array($arrayXML->arr2D[$key]->arr2D)){
                            $this->_toXmlNode2D($arrayXML->arr2D[$key],$arrayXML->arr2D[$key]->arr2D,$root);
                        }
                        if($value->child!=null){
                             foreach($node->child as $value){
                                $this->_toXmlNode($value,$nodeSA);
                             }
                        }
                   }
               }
                *
                */
            }else {

            }

        }
    }
    private function _toXmlNode2D($node2D,$parent) {
        //$nodeA=$this->createElement($parent,$node->name,$node->attribute,$node->text);
        foreach($node2D as $value) {
            $nodeSA=$this->createElement($parent,$value->name,$value->attribute,$value->text);
            if($value->arr2D!=null) {
                $this->_toXmlNode2D($value->arr2D,$nodeSA);
            }
            if($value->child!=null) {
                foreach($value->child as $value_child) {
                    $this->_toXmlNode($value_child,$nodeSA);
                }
            }
        }
    }
    private function _toXmlNode($node,$parent,$moreNode=false) {
        //if($node->arr2D==null)
        $nodeA=$this->createElement($parent,$node->name,$node->attribute,$node->text);
        if($node->arr2D!=null) {
            //if(is_array($node->arr2D)){
            //$nodeA=$this->createElement($parent,$node->arr2D[0]->name,$node->arr2D[0]->attribute,$node->arr2D[0]->text);
            $this->_toXmlNode2D($node->arr2D,$nodeA);
            //$nodeA=$this->createElement($parent,$node->name,$node->attribute,$node->text);
            //foreach($node->arr2D as $value){
            //  $this->_toXmlNode2D($value,$nodeA);
            //$this->createElement($nodeA,$value->name,$value->attribute,$value->text);
//         }
            //}
        }
        if($node->child!=null) {
            //if(is_array($node->child)){
            foreach($node->child as $value) {
                $this->_toXmlNode($value,$nodeA);
            }
            //}
        }
    }
    private function _toXML($arr,$node,$parent) {
        foreach($arr  as $key => $value_ToXml) {
            $attr="";
            $chld="";
            $text="";
            $keyChild="";
            $this->getStdPropFormArray($value_ToXml,$attr,$text,$chld,$keyChild);
            if($keyChild=="BANYAK") {
                $arr=$chld;
                $keyChild="";
                for($i=0;$i<count($arr);$i++) {
                    $attr="";
                    $chld="";
                    $text="";
                    $chld="";
                    $this->getStdPropFormArray($arr[$i],$attr,$text,$chld,$keyChild);
                    $nodeA=$this->createElement($node,$key,$attr,$text);
                    if(is_array($chld))
                        $this->_toXML($chld,$nodeA,$key);
                }
            }else {
                $nodeA=$this->createElement($node,$key,$attr,$text);
                if(is_array($chld))
                    $this->_toXML($chld,$nodeA,$key);
            }
        }
    }
    private function getStdPropFormArray($arr, & $attr,& $text, & $chld, & $keyChild) {
        if(is_array($arr)) {
            if(array_key_exists(0,$arr)) {
                $keyChild="BANYAK";
                $chld=$arr;
            }else {
                foreach($arr as $key => $value) {
                    if(strtolower($key)=="attribute") {
                        $attr=$value;
                    }elseif(strtolower($key)=="text") {
                        $text=$value;
                    }elseif(strtolower($key)=="child") {
                        $chld=$value;
                    }
                }
            }
        }else {
            //echo "S";
        }
    }
}

class xmlFile extends ardeaDOM {
    var $name="";
    function xmlFile() {
        $option=argToOption(func_get_args(),"filename,ver,encode");
        $fl=getOption($option,"filename");
        $ver=getOption($option,"ver",1);
        $encode=getOption($option,"encode",2);
        $this->name=$fl;
        $this->init("ver=".$ver,"encode=".$encode);
    }
    function create() {
        $this->write();
    }
    function getFileName() {
        global $ardeaCore;
        global $ardeaKM;
        return $ardeaCore->getURL()."?opt=".$ardeaKM->key("xml")."&fl=".$this->name;
    }
}

class node {
    public $name;
    public $attribute;
    public $child=null;
    public $text;
    public $arr2D=null;
    public function __construct($name=null) {
        if($name!=null)
            $this->name=$name;
    }
    function addMore($objArrayDom) {
        if(!is_array($this->arr2D))
            $this->arr2D=array();
        $this->arr2D[]=$objArrayDom;
    }
    function addAttribute($newAttibute,$value) {
        //$this->attribute[]=array($newAttibute,$value);
        $this->attribute[$newAttibute]=$value;
    }
    function addChild($newChild) {
        if(!is_array($this->child))
            $this->child=array();
        $this->child[$newChild->name]=$newChild;
        /*
        if(!array_key_exists($newChild->name,$this->child)){
          $this->child[$newChild->name]=$newChild;
        }else{
           if(!is_array($this->child[$newChild->name])){
               $tmpArr=$this->child[$newChild->name];
               $this->child[$newChild->name]=array();
               $this->child[$newChild->name][]=$tmpArr;
           }
           $this->child[$newChild->name][]=$newChild;
        }
         *
        */
    }
}
function generateNode2Array($arrayDOM,&$recValue=null,$fromMore=false,$valueMore=-1) {


    if(!$fromMore) {
        $nameNode=$arrayDOM->name;
        //$recValue=array();
        $recValue[$nameNode]=array();
        $recValue=&$recValue[$nameNode];
    }
    else {
        $nameNode=$valueMore;
    }


    if(count($arrayDOM->attribute)>0) {
        $recValue['attribute']=array();
        foreach($arrayDOM->attribute as $key =>$value) {
            $recValue['attribute'][$key]=$value;
        }
    }
    if($arrayDOM->text!=null) {
        $recValue['text']=$arrayDOM->text;
    }
    if($arrayDOM->arr2D!=null) {
        $recValue['child']==array();
        $recValue['child'][$arrayDOM->arr2D[0]->name]=array();
        $recValue=& $recValue['child'][$arrayDOM->arr2D[0]->name];
        //if(count($arrayDOM->arr2D[0]->attribute)>0){
        //  foreach($arrayDOM->arr2D[0]->attribute as $value){
        //  $recValue['attribute']=$value;
        // }
        //}
        foreach($arrayDOM->arr2D as $key => $value) {
            generateNode2Array($value,$recValue[$key],true,$key);
        }
    }
    if($arrayDOM->child!=null) {
        foreach($arrayDOM->child as $key =>$value) {
            generateNode2Array($arrayDOM->child[$key],$recValue['child']);
        }
    }


}
/*
function fixAttValue($val,$type=null){
    if($type==null){
        $type=gettype($type);
    }
    switch($type){
        case "string":
        case "boolean":
        return
    }
}
 *
*/
?>
