<?php
/*======================================================
 * %%%%%%%%%%%%%PHPArdea CORE 2.0%%%%%%%%%%%%%%%%%%%%%%%
 * =====================================================
 * Author  : Maulana Al Matien.
 * Email   : ardea.core.php@gmail.com
 * Name    : ardeaDateLib.php
 * Date    : 
 * Used for: library for Date
 * ======================================================
 * Copyright Ardea Workshop. http://ardea-workshop.co.cc/ardeaCore.php
 * You allowed to use this component or parts of it under LGPLv3 terms
 * To use it on other terms or get Professional edition of the component 
 * please contact us at ardea.core.php@gmail.com
*/
/**
 * @version		2.0
 * @package		lib
 * @subpackage	core
 * @author	Maulana al matien
 * @copyright Ardea-Workshop/Maulana Al Matien (2008-2009). All rights reserved.
 * @license http://www.gnu.org/licenses/lgpl-3.0.txt GNU Lesser General Public License (LGPLv3)
 */
class ardeaDateLib {
    public static function ambilTanggal($format="Y-m-d") {
        return date($format);
    }
    public static function ambilTime() {
        return time();
    }
    public static function tanggaAwalMinggu($strDate) {
        $crHr=date('d',strtotime($strDate));
        $crBl=date('m',strtotime($strDate));
        $crTh=date('Y',strtotime($strDate));
        $harike=hariKe('w',$strDate);
        return  date("Y-m-d",mktime(0, 0, 0,  $crBl,$crHr-$harike, $crTh));
    }
    public static function tanggalAkhirMinggu($strDate) {
        $crHr=date('d',strtotime($strDate));
        $crBl=date('m',strtotime($strDate));
        $crTh=date('Y',strtotime($strDate));
        $harike=6-hariKe('w',$strDate);
        return  date("Y-m-d",mktime(0, 0, 0,  $crBl,$crHr+$harike, $crTh));
    }
    public static function tanggalAwalBulan($strDate) {

    }
    public static function tanggalAkhirBulan($strDate) {

    }
    public static function tanggaAwalTahun($strDate) {


    }
    public static function tanggalAkhirTahun($strDate) {


    }
    public static function pecahDate($date) {
        if(gettype($date)=="string")
            $date=strtotime($date);
        $arrDate=array();
        $arrDate['hr']=date('d',$date);
        $arrDate['bl']=date('m',$date);
        $arrDate['yr']=date('Y',$date);
        return $arrDate;
    }
    public static function dateDiff($strDate1,$strDate2) {
        $arrDate=array();
        $arrDate['th']=ardeaDateLib::dateDiffTh($strDate1,$strDate2);
        $arrDate['bl']=ardeaDateLib::dateDiffBl($strDate1,$strDate2);
        $strDate1=strtotime($strDate1);
        $strDate2=strtotime($strDate2);
        $dif =  $strDate2 - $strDate1;
        $arrDate['mg']=bcdiv($dif,604800);
        $arrDate['hr']=bcdiv($dif,86400);
        $arrDate['jm']=bcdiv($dif,3600);
        $arrDate['mn']=bcdiv($dif,60);
        $arrDate['dt']=$dif;
        return $arrDate;
    }
    public static function dateDiffBl($strDate1,$strDate2) {
        $crBl1=date('m',strtotime($strDate1));
        $crTh1=date('Y',strtotime($strDate1));
        $crBl2=date('m',strtotime($strDate2));
        $crTh2=date('Y',strtotime($strDate2));
        $difTh=$crTh2-$crTh1;
        if($difTh==0) {
            $ret=$crBl2-$crBl1;
        }else if($difTh>0) {
            $ret=(12-$crBl1)+($crBl2);
            if($difTh>0) {
                $ret=($ret-12)+($difTh*12);
            }
        }else if($difTh<0) {
            $ret=($crBl1)+(13-$crBl2);
            if($difTh<0) {
                $ret=-($ret-12)+($difTh*12);
            }
        }
        return $ret;
    }
    public static function dateDiffTh($strDate1,$strDate2) {
        $crTh1=date('Y',strtotime($strDate1));
        $crTh2=date('Y',strtotime($strDate2));
        $ret=$crTh2-$crTh1;
        return $ret;
    }
    public static function dateAdd($opsi,  $number, $date) {
        $date_time_array  = getdate($date);
        $hours =  $date_time_array["hours"];
        $minutes =  $date_time_array["minutes"];
        $seconds =  $date_time_array["seconds"];
        $month =  $date_time_array["mon"];
        $day =  $date_time_array["mday"];
        $year =  $date_time_array["year"];

        switch ($opsi) {

            case "yyyy":
                $year +=$number;
                break;
            case "q":
                $year +=($number*3);
                break;
            case "m":
                $month +=$number;
                break;
            case "y":
            case "d":
            case "w":
                $day+=$number;
                break;
            case "ww":
                $day+=($number*7);
                break;
            case "h":
                $hours+=$number;
                break;
            case "n":
                $minutes+=$number;
                break;
            case "s":
                $seconds+=$number;
                break;

        }
        $timestamp =  mktime($hours ,$minutes, $seconds,$month ,$day, $year);
        return $timestamp;
    }
    public static function oneDay() {
        return 24*60*60;
    }
    public static function dateFormat($dateTime,$dateFormat="Y-m-d") {
        return date($dateFormat,$dateTime);
    }
    public static function hariKe($opsi,$dateStr) {
        $dt=strtotime($dateStr);
        //die("AAA". $dt);
        $ret=0;
        switch($opsi) {
            case "y":
                $ret=getdate($dt);
                $ret=$ret['yday'];
                break ;
            case "w":
                $ret=getdate($dt);
                $ret=$ret['wday'];
                break;
            case "m":
                $ret=getdate($dt);
                $ret=$ret['mday'];
                break;
        }
        //print_r(getdate($dt));
        return $ret;

    }
    public static function isTahunKabisat($intYear) {
        if(($intYear%4==0&&$intYear%100!=0)||$intYear%100==0)
            return 1;
    }
    public static function getJmlMonth($intMonth,$intYear) {
        if($intMonth==4||$intMonth==6||$intMonth==9||$intMonth==11)
            return 30;
        if($intMonth==1||$intMonth==3||$intMonth==5||$intMonth==7||$intMonth==8||$intMonth==10||$intMonth==12)
            return 31;
        if($intMonth==2)
            return (isTahunKabisat($intYear))?29:28;
    }
    public static function makeDate($dayInt,$monthInt,$yearInt,$formatStr="Y-m-d") {
        return date($formatStr, mktime(0, 0, 0, $monthInt, $dayInt, $yearInt));
    }
    public static function makeDateStr($strDate,$formatStr="Y-m-d") {
        return date($formatStr, strtotime($strDate));
    }
    public static function getDate($format="Y-m-d") {
        return ardeaDateLib::ambilTanggal($format);
    }
    public static function getTime() {
        return ardeaDateLib::ambilTime();
    }
}



?>
