<?php
/*======================================================
 * %%%%%%%%%%%%%PHPArdea CORE 2.0%%%%%%%%%%%%%%%%%%%%%%%
 * =====================================================
 * Author  : Maulana Al Matien.
 * Email   : ardea.core.php@gmail.com
 * Name    : ardeaInit.php
 * Date    : 
 * Used for: library for initializing ArdeaCore Engine
 * ======================================================
 * Copyright Ardea Workshop. http://ardea-workshop.co.cc/ardeaCore.php
 * You allowed to use this component or parts of it under LGPLv3 terms
 * To use it on other terms or get Professional edition of the component 
 * please contact us at ardea.core.php@gmail.com
*/
//die($_GET["optex"]);
global $_ARDEA_CONFIG;
global  $_initJs;
global  $_funcLoad;
include($pathForArdeaCore."lib/core/ardeaLibrary.php") ;

initVar();
initConfig();
//initArdeaCore();
$current_lib_Path=array(); 
//init path
setRootPath("lib",ARDEA_CORE_PATH."lib/");
setRootPath("object",ARDEA_CORE_PATH."object/");
setRootPath("xml",ARDEA_CORE_PATH."xml/");
setRootPath("tmp",ARDEA_CORE_PATH."tmp/");
setRootPath("template",ARDEA_CORE_PATH."template/");
setRootPath("friend",ARDEA_CORE_ROOT."friend/");
setRootPath("webtools",ARDEA_CORE_PATH."webtools/");
setRootPath("tools",ARDEA_CORE_PATH."webtools/");

loadLib("lib.core.ardeaCore");
loadLib("lib.core.ardeaVar");
loadLib("lib.core.ardeaKM");

if(!is_object($ardeaCore))
    $ardeaCore=new _ardeaCore();



if(!is_object($ardeaVar))
    $ardeaVar=new _ardeaVar();

if(!is_object($ardeaSession))
    $ardeaSession=new _ardeaSession();


if($_ARDEA_CONFIG["init_var"]) 
    $ardeaVar->init();

$_VAR_LOAD_=$ardeaVar->getVar("optsc","var_get",true);
$_VAR_FILE_=$ardeaVar->getVar("fl","var_get",true);
$_VAR_OPT_=$ardeaVar->getVar("optex","var_get",true);
$_VAR_LOAD_OBJECT_=$ardeaVar->getVar("ob","var_get",true);
$_VAR_LOAD_OBJECT_WITH_CHILD=$ardeaVar->getVar("cld","var_get",true);
if($_VAR_LOAD_OBJECT_=='')
    $_VAR_LOAD_OBJECT_=false;
if($_VAR_LOAD_OBJECT_WITH_CHILD=='')
    $_VAR_LOAD_OBJECT_WITH_CHILD=false;


//$ardeaCore->setInitUseObject($_VAR_LOAD_OBJECT_);

if($_VAR_LOAD_=='')
    $_VAR_LOAD_='default';

if(!is_object($ardeaKM))
    $ardeaKM=new _ardeaKM();

//setting run branch 
if(strpos($_VAR_LOAD_,"a_s_c_r_")>-1) {
    $_VAR_LOAD_=str_replace("a_s_c_r_","",$_VAR_LOAD_);
    $key=$ardeaKM->keyFor($_VAR_LOAD_);
    if($key)
        $_VAR_LOAD_=$key;
}

switch($_VAR_LOAD_) {
    case "cJs":
    //header('Content-type: text/js');
    //header('Content-Disposition: attachment; filename="'.$_VAR_FILE_.'.js"');
        break;
    case "cCss":
    //header('Content-type: text/css');
    //header('Content-Disposition: attachment; filename="'.$_VAR_FILE_.'.css"');
        break;
    case "xml":
        switch($_VAR_OPT_) {
            case "":

                break;
            case "xml_1":
                header('Content-type: text/xml');
                header('Content-Disposition: inline; filename="'.$_VAR_FILE_.'.xml"');
                break;
            case "xml_2":
                header('Content-type: application/xml');
                header('Content-Disposition: inline; filename="'.$_VAR_FILE_.'.xml"');
                break;
            case "xml_3":
                header('Content-type: application/xml');
                header('Content-Disposition: attachment; filename="'.$_VAR_FILE_.'.xml"');
                break;

        }
        break;
    case "pdf":
        header('Content-type: application/pdf');
        if($ardeaVar->getVar("fl_ty","var_get",true)=="inline") {
            header('Content-Disposition: inline; filename="'.$_VAR_FILE_.'.pdf"');
        }else {
            header('Content-Disposition: attachment; filename="'.$_VAR_FILE_.'.pdf"');
        }
        loadLib("object.plugin.ardeaHTML2PDF");
        $_pdf=new ardeaHTMLTOPDF();
        break;
}

$ardeaCore->setTypeRun($_VAR_LOAD_);

if($_VAR_LOAD_=='default') {
    $ardeaCore->addJsPath($ardeaCore->getURLJS("ardeaLib.js"));
    $ardeaCore->addJsPath($ardeaCore->getURLJS("ardeaFunction.js"));
    $ardeaCore->addCssPath($ardeaCore->getURLCSS("default.css"));
}
//basic init JS for ardeaCore


if($_VAR_FILE_=='ardeaBaseInit') {
    $_initJs=$ardeaCore->createJsFile('ardeaBaseInit');
    $_initJs->addScript("var ardeaVar=[];");
    $_initJs->addScript("window.onload=ardeaLoad");
    $_funcLoad=$_initJs->addFunction('ardeaLoad');
    $_ardeaInitObject=$_initJs->addFunction('ardeaInitObject');
    if($_ARDEA_CONFIG["security_on"]) {
        $fl_Name=$ardeaCore->getURL('name');
        $key_pdf=$ardeaKM->getKey($fl_Name,'pdf',false);
        $key_exc=$ardeaKM->getKey($fl_Name,'exc',false);
    }else {
        $key_pdf="pdf";
        $key_exc="exc";
    }
    $imagePath=ARDEA_CORE_DOMAIN.ARDEA_CORE_PATH_IMAGE_ROOT;

//javascript default for ardeaCore 
    $funcLoadScript=<<<FUNCLOAD
chkBrowser();
checkSize();
ardeaVar['pdf']=$key_pdf;
ardeaVar['exc']=$key_exc;
imagePath="$imagePath";
FUNCLOAD;
    $_funcLoad->addScript($funcLoadScript);
}




//functions for init , config, var

function initConfigOld() {
    global $ardeaCore;
    foreach(getPropertyOnFolder(ARDEA_CORE_PATH_CONFIG_ROOT) as $namaFile) {
        include(ARDEA_CORE_PATH_CONFIG_ROOT.$namaFile);
    }
}
function initConfig() {
    include(ARDEA_CORE_PATH_CONFIG_ROOT."ardeaConfig.php");
}
function initPluginConfig() {
    global $ardeaCore;
    foreach(getPropertyOnFolder(ARDEA_CORE_PATH_PLUGIN_CONFIG) as $namaFile) {
        include(ARDEA_CORE_PATH_PLUGIN_CONFIG.$namaFile);
    }
}
function initArdeaCore() {
    global $ardeaCore;
    foreach(getPropertyOnFolder(ARDEA_CORE_PATH_INIT_ROOT) as $namaFile) {
        include(ARDEA_CORE_PATH_INIT_ROOT.$namaFile);
    }
}
function initArdeaCorePugin() {
    global $ardeaCore;
    foreach(getPropertyOnFolder(ARDEA_CORE_PATH_PLUGIN_INIT) as $namaFile) {
        include(ARDEA_CORE_PATH_PLUGIN_INIT.$namaFile);
    }
}
function initVar() {
    global $pathForArdeaCore;
    global $rootPathForThemes;
    global $pathForRoot;
    //global $ardeaCore;
    global $ardeaCoreinitVar;
    include($pathForArdeaCore."var/___initVarArdeaCoreMain.php");
    include($pathForArdeaCore."var/ardeaCore.php");
}
function initVarOld() {
    global $pathForArdeaCore;
    global $rootPathForThemes;
    global $pathForRoot;
    global $ardeaCore;
    global $ardeaCoreinitVar;
    $arrFile=getPropertyOnFolder($pathForArdeaCore."var");
    include($pathForArdeaCore."var/___initVarArdeaCoreMain.php");
    foreach($arrFile as $namaFile) {
        $namaFile=$pathForArdeaCore."var/".$namaFile;
        if($namaFile!="___initVarArdeaCoreMain.php")
            include($namaFile);
    }
}
function initPluginVar() {
    global $pathForArdeaCore;
    global $ardeaCoreinitVar;
    $arrFile=getPropertyOnFolder($pathForArdeaCore."var/plugin");
    foreach($arrFile as $namaFile) {
        $namaFile=$pathForArdeaCore."var/plugin/".$namaFile;
        //echo  $namaFile;
        include($namaFile);
    }

}
?>
