<?php
/*======================================================
 * %%%%%%%%%%%%%PHPArdea CORE 2.0%%%%%%%%%%%%%%%%%%%%%%%
 * =====================================================
 * Author  : Maulana Al Matien.
 * Email   : ardea.core.php@gmail.com
 * Name    : ardeaObject.php
 * Date    :
 * Used for: Basic library for object in ardeaCore
 * ======================================================
 * Copyright Ardea Workshop. http://ardea-workshop.co.cc/ardeaCore.php
 * You allowed to use this component or parts of it under LGPLv3 terms
 * To use it on other terms or get Professional edition of the component
 * please contact us at ardea.core.php@gmail.com
*/
loadLib("lib.core.ardeaThemes");
loadLib("lib.core.ardeaProperty");
loadLib("object.plugin.ardeaSmarty");
/**
 * @version		2.0
 * @package		lib
 * @subpackage	core
 * @author	Maulana al matien
 * @copyright Ardea-Workshop/Maulana Al Matien (2008-2009). All rights reserved.
 * @license http://www.gnu.org/licenses/lgpl-3.0.txt GNU Lesser General Public License (LGPLv3)
 */
class objectObject {
    public $name='';
    //protected $objectName='';
    // if have data
    protected $data=array();
    // main string HTML
    protected $strHTML="";

    //property
    protected $property="";
    //smarty
    protected $useSmarty=true;
    protected $smarty;
    protected $secondLoop=false;
    //for themes
    protected $themes=""; //???????
    protected $layerProperty;
    protected $labelProperty;
    protected $textProperty;
    protected $buttonProperty;
    //for Database
    protected $recordSet;
    protected $fieldName;
    //validation
    protected $useValidation;
    protected $minCharValidation=-1;
    //for debug
    protected $isDebugObject;
    //for form
    protected $formParent;
    //for building methode
    protected $buildOnHome=true;
    protected $styleOnObject=false;
    //for process
    protected $typeRun;
    //for
    protected $objectType='ARDEA_CORE_NONE';
    //
    protected $noUseBuild=false;
    protected $noUseBuildProperty=false;
    //
    protected $JsScriptToTmp=false;
    //
    protected $jsOnObject=false;
    //
    protected $buidJsOnBody=true;
    //
    protected $fileJs=array();
    protected $fileJsName=array();
    protected $jsChildOf="_ARDEA_CORE_NONE_";
    protected $cssChildOf="_ARDEA_CORE_NONE_";
    protected $jsOpenForInit=false;
    protected $cssOpenForInit=false;
    protected $fileCss=array();
    protected $fileCssName=array();
    //var $isChild=false;
    protected $isChildBuild=true;
    protected $isHasBuild=false;
    protected $isChildFoundParent=false;
    //
    //parent
    protected $parentName=null;
    protected $parentObject=null;
    protected $parentScript=null;
    protected $parent_var_for_child=null;
    //
    protected $useAjax=false;
    //
    protected $canAutoEvent=false;
    function __construct() {
        global $ardeaCore;
        $this->typeRun=$ardeaCore->getTypeRun();
    }
    function deliverVar($whatVar) {
        $this->parent_var_for_child=$whatVar;
    }
    //parent
    function isObjectAutoEvent() {
        return $this->canAutoEvent;
    }

    function setParentName($newParentName) {
        $this->parentName=$newParentName;
    }
    function setParent($newParent) {
        $this->parentObject=$newParent;
    }
    function setParentScript($script) {
        $this->parentScript=$script;
    }
    //use ajax
    function setUseAjax() {
        $this->useAjax=true;
    }
    function isUseAjax() {
        return $this->useAjax;
    }
    //smarty

    function setStyleOnObject() {

    }
    function setTooltip($caption) {
        global $ardeaCore;
        if(method_exists($this,"getTooltipObject")) {
            $ardeaCore->addTooltip($this->getTooltipObject(),$caption);
        }else {
            $ardeaCore->addTooltip($this->toJs('object'),$caption);
        }
    }
    function setUseSmarty($boolUsed=true) {
        $this->useSmarty=$boolUsed;
    }
    function setNoPrinted() {
        $this->setProperty("isPrinting",false,"print");
    }
    function isUseSmarty() {
        return $this->useSmarty;
    }
    function setDebugOn() {
        $this->isDebugObject=true;
    }
    function setChildOn() {
        $this->isChild=true;
    }
    function setChildBuildOff() {
        $this->isChildBuild=false;
    }
    //for js
    function addJsFile($newFile,$createVirtual=false,$withSecurity=false,$useChild=false) {
        global $ardeaCore;
        $indexOfJsFilName=count($this->fileJsName);
        $this->fileJsName[$indexOfJsFilName]=array();
        $this->fileJsName[$indexOfJsFilName]["name"]=$newFile;
        if($this->typeRun=="cJs"&&$createVirtual) {
            $this->fileJs[$newFile]=new jsFile($newFile,$withSecurity);
            $this->fileJsName[$indexOfJsFilName]["type"]="virtual";
            $this->fileJsName[$indexOfJsFilName]["url"]=$newFile;

        }else {
            if($createVirtual) {
                $url=$this->getURLForJsFile($newFile,$useChild);
                $this->fileJsName[$indexOfJsFilName]["type"]="virtual";
                $ardeaCore->addJsPath($url);
            }else {
                $this->fileJsName[$indexOfJsFilName]["type"]="url";
                $url=$ardeaCore->getURLJS($newFile);
                $ardeaCore->addJsPath($url);
            }

            $this->fileJsName[$indexOfJsFilName]["url"]=$url;
        }

        return $this->fileJs[$newFile];
    }
    function getFileJsName() {
        return $this->fileJsName;
    }
    function mergeFileJsNameChild($jsPathChild) {
        //var_dump($jsPathChild);
        //die(var_dump($this->fileJsName));
        if(is_array($jsPathChild))
            $this->fileJsName=array_merge($this->fileJsName,$jsPathChild);

    }
    function setJsChild($newParent) {
        $this->jsChildOf=$newParent;
    }
    function setCssChild($newParent) {
        $this->cssChildOf=$newParent;
    }
    function isJsChild() {
        global $_VAR_FILE_;
        if($this->jsChildOf=="_ARDEA_CORE_NONE_")
            return false;
        if($_VAR_FILE_!=$this->jsChildOf)
            return false;
        return true;
    }
    function isCssChild() {
        global $_VAR_FILE_;
        if($this->cssChildOf=="_ARDEA_CORE_NONE_")
            return false;
        if($_VAR_FILE_!=$this->cssChildOf)
            return false;
        return true;
    }
    function isHaveJs(&$returnFileJS='',$fileName='_ARDEA_CORE_NONE_') {
        global $_VAR_FILE_;

        if($fileName=='_ARDEA_CORE_NONE_')
            $fileName=$_VAR_FILE_;
        //var_dump($this->fileJs) ;
        if(!array_key_exists($fileName,$this->fileJs))
            return false;
        //die(var_dump($this->fileJs))  ;
        $returnFileJS=$this->fileJs[$fileName];
        //echo "Aasdasdasdsadsa";
        $this->isChildFoundParent=true;
        return true;
    }
    function addCssFile($newFile,$createVirtual=false,$withSecurity=false,$useChild=false) {
        global $ardeaCore;
        $indexOfCssFilName=count($this->fileCssName);
        $this->fileCssName[$indexOfCssFilName]=array();
        $this->fileCssName[$indexOfCssFilName]["name"]=$newFile;
        if($this->typeRun=="cCss"&&$createVirtual) {
            $this->fileCss[$newFile]=new cssFile($newFile,$withSecurity);
            $this->fileCssName[$indexOfCssFilName]["type"]="virtual";
            $this->fileCssName[$indexOfCssFilName]["url"]=$newFile;
        }else {
            if($createVirtual) {
                $url=$this->getURLForCssFile($newFile,$useChild);
                $ardeaCore->addCssPath($url);
                $this->fileCssName[$indexOfCssFilName]["type"]="virtual";
            }else {
                $url=$ardeaCore->getURLCSS($newFile);
                $ardeaCore->addCssPath($url);
                $this->fileCssName[$indexOfCssFilName]["type"]="url";
            }

            $this->fileCssName[$indexOfCssFilName]["url"]=$url;
        }

        return $this->fileJs[$newFile];
    }
    function getFileCssName() {
        return $this->fileCssName;
    }
    function mergeFileCssNameChild($cssPathChild) {
        if(is_array($cssPathChild)) {
            $this->fileCssName=array_merge($this->fileCssName,$cssPathChild);
        }

    }
    function isHaveCss(&$returnFileCSS='',$fileName='_ARDEA_CORE_NONE_' ) {
        global $_VAR_FILE_;
        if($fileName=='_ARDEA_CORE_NONE_')
            $fileName=$_VAR_FILE_;
        if(!array_key_exists($fileName,$this->fileCss))
            return false;
        $returnFileCSS=$this->fileCss[$fileName];
        $this->isChildFoundParent=true;
        return true;
    }
    function getFileJs($nameJs) {
        if(array_key_exists($nameJs,$this->fileJs))
            return $this->fileJs[$nameJs];
    }
    function setJsScriptToTmp() {
        $this->JsScriptToTmp =true;
    }
    function getJsScriptToTmp() {
        return $this->JsScriptToTmp;
    }
    function setBuidJsOnVirtual() {
        $this->buidJsOnBody=true;
    }
    function setNoBuildProperty() {
        $this->noUseBuildProperty=true;
    }
    /*
    function setScriptOn($option="init"){
        this->setProperty("aoption_init")
    }
     *
    */
    //for db
    function setFieldDb($fieldName) {
        $this->setProperty("fieldName",$fieldName,"dbProperty");
    }
    function mainInit() {
        global $ardeaCore;
        //$this->typeRun=$ardeaCore->getTypeRun();
        $this->property=new property();
        $this->buildOnHome=true;
        //smarty
        $this->setUseSmarty($ardeaCore->isUseSmarty());
        $this->smarty=new ardeaSmarty();
    }
    function initOnly($opt="property") {
        global $ardeaCore;
        $this->typeRun=$ardeaCore->getTypeRun();
        switch (strtolower($opt)) {
            case "smarty":
                $this->smarty=new ardeaSmarty();
                break;
            case "property":
                $this->property=new property();
                break;
        }
    }
    function init($defaultThemes=0) {
        global $ardeaCore;
        global $_VAR_LOAD_OBJECT_WITH_CHILD;
        $this->typeRun=$ardeaCore->getTypeRun();
        $this->property=new property();
        $this->buildOnHome=true;
        //smarty
        $this->setUseSmarty($ardeaCore->isUseSmarty());
        $this->smarty=new ardeaSmarty();
        if($_VAR_LOAD_OBJECT_WITH_CHILD) {
            $this->subInit($defaultThemes);
        }
        if($this->typeRun=="default"||$this->typeRun=="pdf") {
            $this->subInit($defaultThemes);
        }

    }
    function subInit($defaultThemes) {
        global $ardeaCore;
        $this->themes=$ardeaCore->getThemes();
        if(!$defaultThemes==0) {
            if($ardeaCore->useThemes)
                $this->initThemes($defaultThemes);
        }
        $this->isDebugObject=false;
        //for label
        $this->labelObjectProperty=new property();
        $this->labelObjectProperty->import($this->themes->getLabelPropertyObject());
        $this->labelObjectProperty->property["style"]["width"]="150px";

        // for layer
        $this->layerProperty=new property();
        $this->layerProperty->property["style"]=array();
        $this->layerProperty->property["style"]["top"]=0;
        $this->layerProperty->property["style"]["left"]=0;
        $this->layerProperty->property["style"]["position"]="absolute";
        //for db
        $this->property->property["dbProperty"]=array();
        $this->property->property["dbProperty"]["fieldName"]="";
        $this->property->property["dbProperty"]["valueDb"]="";

        //for print
        $this->property->property["print"]=array();
        $this->property->property["print"]["isPrinting"]=true;
        $this->property->property["data_object"]=array();
        $this->property->property["data_object"]["defaultData"]="data";
        $this->property->property["labelProperty"]=array();
        $this->property->property["labelProperty"]["labelCaption"]="";
        $this->property->property["labelProperty"]["labelType"]="label_left";
        $this->property->property["containProperty"]=array();
        $this->property->property["containProperty"]["contain"]="";
        $this->property->property["validation"]=array();
        $this->property->property["validation"]["validation_type"]="";
        $this->property->property["validation"]["validation_mask"]="";
    }
    function initThemes($whatThemes) {
        switch($whatThemes) {
            case 1:
                $this->property->import($this->themes->getButtonPropertyObject());
                break;
            case 2:
                $this->property->import($this->themes->getLabelPropertyObject());
                break;
            case 3:
                $this->property->import($this->themes->getInputPropertyObject());
                //die(print_r($this->themes->getInputPropertyObject()));
                break;
        }

    }
    function disabled() {
        $this->property->disabled();
    }
    //label area
    function setLabelCaption($newCaption) {
        $this->property->property["labelProperty"]["labelCaption"]=$newCaption;
    }
    function getLabelCaption() {
        return $this->property->property["labelProperty"]["labelCaption"];
    }
    function setLabelProperty($propertyName,$value="") {
        $this->property->property["labelProperty"][$propertyName]=$value;
    }
    function getLabelProperty($propertyName) {
        return $this->getProperty($propertyName,"labelProperty");
    }
    //themes area
    function setThemes($newThemes) {
        $this->themes=clone $newThemes;
    }

    function setLabelThemesPropertyObject($objectLabelProperty) {
        $this->themes->setLabelPropertyObject($objectLabelProperty);
    }

    function setLabelThemesProperty($propertyName,$value="",$parentProperty="property") {
        $this->themes->setLabelProperty($propertyName,$value,$parentProperty);
    }
    function getLabelThemesProperty($propertyName,$parentProperty="") {
        return $this->themes->getLabelProperty($propertyName,$parentProperty);
    }

    function setInputThemesPropertyObject($objectInputProperty) {
        $this->themes->setInputPropertyObject($objectInputProperty);
    }

    function setInputThemesProperty($propertyName,$value="",$parentProperty="property") {
        $this->themes->setInputProperty($propertyName,$value,$parentProperty);
    }
    function getInputThemesProperty($propertyName,$parentProperty="") {
        return $this->themes->getInputProperty($propertyName,$parentProperty);
    }
    function setButtonThemesPropertyObject($objectButtonProperty) {
        $this->themes->setButtonPropertyObject($objectButtonProperty);
    }

    function setButtonThemesProperty($propertyName,$value="",$parentProperty="property") {
        $this->themes->setButtonProperty($propertyName,$value,$parentProperty);
    }
    function getButtonThemesProperty($propertyName,$parentProperty="") {
        return $this->themes->getButtonProperty($propertyName,$parentProperty);
    }
    function getLabelThemesClass() {
        return $this->themes->getLabelClass();
    }

    function getInputThemesClass() {
        return $this->themes->getInputClass();
    }
    function getButtonThemesClass() {
        return $this->themes->getButtonClass();
    }
    function buildButtonThemesProperty() {
        return $this->themes->buildButtonProperty();
    }
    function buildInputThemesProperty() {
        return $this->themes->buildInputProperty();
    }
    function buildLabelThemesProperty() {
        return $this->themes->buildLabelProperty();
    }
    //untuk keperluan js
    function setAttribute($newAttribute) {
        if(!array_key_exists("ardea_attribute_property",$this->property->property))
            $this->property->property["ardea_attribute_property"]=array();
        $args=func_get_args();
        if(count($args)>1) {
            foreach($args as $value) {
                $this->property->property["ardea_attribute_property"]["attribute"].=",\"".$value."\"";
            }
            $this->property->property["ardea_attribute_property"]["attribute"]=substr($this->property->property["ardea_attribute_property"]["attribute"],1);
        }else {
            $this->property->property["ardea_attribute_property"]["attribute"]="\"".$newAttribute."\"";
        }

    }
    function getAttribute() {
        if(!array_key_exists("ardea_attribute_property",$this->property->property))
            return false;
        return $this->property->property["ardea_attribute_property"]["attribute"];
    }
    function toJs($opt='value') {
        $args=func_get_args();
        switch(strtolower($opt)) {
            case "value":
                return "getObject(\"".$this->name."\").value";
                break;
            case "id":
                return "\"".$this->name."\"";
                break;
            case "object":
                return "getObject(\"".$this->name."\")";
                break;
            case "innerhtml":
                return "getObject(\"".$this->name."\").innerHTML";
                break;
            case "innertext":
                return "getObject(\"".$this->name."\").innerText";
                break;
            case "autoevent":
                return "ardeaObject.registerObject(\"".$this->name."\")";
                break;
            default:
                if(method_exists($this,"toJsObject"))
                    return $this->toJsObject($opt,$args);
                break;
        }

    }
    //data area

    function getData() {
        return $this->data;
    }

    function importData($newData) {
        $this->data=$newData;
    }

    function addData($newData) {
        $this->data[]=$newData;
    }
    function addObject($ardeaObject,$useBR=false) {
        if(!isArdeaObject($ardeaObject))
            return;
        $ardeaObject->build();
        //die(var_dump($ardeaObject->getHTML()));
        if($useBR) {
            $this->property->property["containProperty"]["contain"]=$this->property->property["containProperty"]["contain"]."<br/>".$ardeaObject->getHTML();
        }else {
            $this->property->property["containProperty"]["contain"]=$this->property->property["containProperty"]["contain"].$ardeaObject->getHTML();
        }
    }
    //property area
    function setNoUsedBuild() {
        $this->noUseBuild=true;
    }
    function exportProperty() {
        return $this->property;
    }
    function isPropertyHasExist($propertyName,$parentName="property") {
        $this->property->isPropertyHasExist($propertyName,$parentName);
    }
    function importProperty($propertyObject) {
        global $ardeaCore;
        if(compareClassName("property",$propertyObject) or compareClassName("ardeaExtendProperty",$propertyObject)) {
            $this->property=$propertyObject;
        }else {
            $ardeaCore->setError("importObjectProperty","Object not initialized","objectObject/ardeaObject.php");
        }


    }

    function setProperty($propertyName,$value="",$parentProperty="property") {
        $this->property->setProperty($propertyName,$value,$parentProperty);
    }
    function addDBProperty($DBPropertyName,$DBPropertyStr) {
        $this->property->addDBProperty($DBPropertyName,$DBPropertyStr);
    }
    function getDBProperty($DBPropertyName) {
        return $this->property->getDBProperty($DBPropertyName);
    }

    function getProperty($propertyName,$parentName="property") {
        return $this->property->getProperty($propertyName,$parentName);
    }
    function buildProperty($option="style,property,event",$parentName=null) {
        return $this->property->buildProperty($option,$parentName);
    }

    // build area
    function getHTML() {
        return $this->strHTML;
    }

    function setContain($newHTML) {
        //$this->property->property["ardea_attribute_property"]["attribute"]=substr($this->property->property["ardea_attribute_property"]["attribute"],1);
        $this->property->property["containProperty"]["contain"]=$newHTML;

    }
    function addContain($newHTML) {
        $this->property->property["containProperty"]["contain"]=$this->property->property["containProperty"]["contain"].$newHTML;
        //        $newHTML
        //      $this->setProperty("contain",$this->getProperty("contain","containProperty").$newHTML,"containProperty");
    }
    function getUrlFile($type,$fileName,$useChild=false,$optex="") {
        global $ardeaKM;
        global $ardeaCore;
        global $_ARDEA_CONFIG;
        $childParam="";
        if($useChild)
            $childParam="&cld=Y";
        if($_ARDEA_CONFIG["security_on"]) {
            $key=$ardeaKM->getKey($ardeaCore->getURL('name'),$type,false);
            return $ardeaCore->getURL()."?optsc=a_s_c_r_".$key."&fl=".$fileName."&ob=Y".$childParam."&optex=".$optex;
        }else {
            return $ardeaCore->getURL()."?optsc=".$type."&fl=".$fileName."&ob=Y".$childParam."&optex=".$optex;
        }
    }
    function getURLForJsFile($fileName,$useChild=false,$optex="") {
        return $this->getUrlFile('cJs',$fileName,$useChild,$optex);
    }
    function getURLForCssFile($fileName,$useChild=false,$optex="") {
        return $this->getUrlFile('cCss',$fileName,$useChild,$optex);
    }
    function getURLForXMLFile($fileName,$useChild=false,$optex="") {
        return $this->getUrlFile('xml',$fileName,$useChild,$optex);
    }
    function hasBuild() {
        return $this->isHasBuild;
    }

    function build() {
        /*  Please use this format
         * function buildObject(){
         * $this->strHTML=
         * }
        */

        global $ardeaCore;
        global $_VAR_LOAD_OBJECT_;
        //if(!$this->secondLoop){
        if($this->isHasBuild)
            return;
        $this->isHasBuild=true;
        //echo $this->typeRun."CCCC";
        //$typeRun=$ardeaCore->getTypeRun();

        if($this->typeRun=="cCss"||$this->typeRun=="cJs"||$this->typeRun=="xml") {
            if($this->typeRun=="xml") {
                if(method_exists($this,"buildXML")) {
                    $this->buildXML();
                }
            }
            if($this->typeRun=="cCss") {

                if(method_exists($this,"buildCss")) {
                    $this->buildCss();
                }
                if($this->isCssChild()) {
                    if(!$this->isChildBuild)
                        return;
                }else {
                    return;
                }
            }
            if($this->typeRun=="cJs") {
                //if($this->name=='recnav')die("MASUK");
                //global $mvcReg;
                //$mvcReg->set("bug",$mvcReg->get("bug").":".get_class($this));
                //global $_funcLoad;
                //$_funcLoad->addScript($this->name);
                if(method_exists($this,"buildJs")) {
                    //if(!$this->secondLoop)
                    $this->buildJs();
                }

                if($this->isJsChild()) {
                    if(!$this->isChildBuild)
                        return;
                }else {
                    return;
                }

            }
            // used for virtual ardeaBaseInit.js
            if(!$_VAR_LOAD_OBJECT_)
                return;
            //check is child

            if($this->isChildFoundParent==true)
                die();
        }

        //}
        //if u not use build
        // var_dump($this->name);
        if($this->noUseBuild)
            return ;

        if($this->buildOnHome) {
            if(!method_exists($this,"buildObject"))
                $ardeaCore->setError("build","Function buildObject on Object Not found","objectObject/ardeaObject.php");
            $this->buildObject();

        }else {
            if(!method_exists($this,"buildPlugin"))
                $ardeaCore->setError("build","Function buildPlugin on Object Not found","objectObject/ardeaObject.php");
            $this->buildPlugin();
        }
        //if u not build properpty

        if($this->noUseBuildProperty) {
            if($this->property!=null)
                $labelCaption=$this->getProperty("labelCaption","labelProperty");
            if($labelCaption!=""){
                $this->smarty=new ardeaSmarty();
                $type=$this->getProperty("labelType","labelProperty");
                if($type=="")$type="label_left"	;
                $this->smarty->assign("type",$type);
                $this->smarty->assign("labelCaption",$labelCaption);
                if($this->getProperty("labelCaption","labelProperty")!="")
                    $this->smarty->assign("id",$this->getProperty("id"));
                $this->smarty->assign("obj","<#ardeacore#contain#>");
                $completeHTML=$this->smarty->fetch("object.tpl");
                //die(var_dump($completeHTML));
                $completeHTML=ereg_replace("<#ardeacore#contain#>",$this->strHTML,$completeHTML);
                $this->strHTML=$completeHTML;
            }
        }
        if($this->noUseBuildProperty)
            return  $this->strHTML;
        $labelCaption=$this->getProperty("labelCaption","labelProperty");
        $this->smarty->assign("type",$this->getProperty("labelType","labelProperty"));

        /*
          if(!$this->styleOnObject){
           $ardeaCore->getCss()->regStyle("masterLabel",$this->labelObjectProperty->buildProperty("style"));
          }else{
          $this->smarty->assign("labelStyle",$this->labelObjectProperty->buildProperty("style"));
          }
           *
        */

        if(!$this->getProperty("isPrinting","print")) {
            $ardeaCore->getCss()->regNotPrinted("tb_".$this->getProperty("id"));
            $ardeaCore->getCss()->regNotPrinted($this->getProperty("id"));
        }

        if($this->useValidation) {
            $this->smarty->assign("withValidation","true");
            $ardeaCore->addCssPath($ardeaCore->getURLCSS('validation.css'));
        }else {
            $this->smarty->assign("withValidation","false");
        }

        //$this->smarty->assign("labelCaption",$this->getProperty("labelCaption","labelProperty"));
        $this->smarty->assign("labelCaption",$labelCaption);
        if($labelCaption!="")
            $this->smarty->assign("id",$this->getProperty("id"));
        //old style
        //$this->smarty->assign("obj",$this->strHTML);
        //$this->strHTML=$this->smarty->fetch("object.tpl");

        //new style
        $this->smarty->assign("obj","<#ardeacore#contain#>");
        $completeHTML=$this->smarty->fetch("object.tpl");
        $completeHTML=ereg_replace("<#ardeacore#contain#>",$this->strHTML,$completeHTML);
        $this->strHTML=$completeHTML;

        if($this->getProperty("withDiv","main")==1) {

            $this->smarty->assign("id",$this->getProperty("id"));
            $this->layerProperty->setProperty("width","auto","style");
            if(!$this->styleOnObject) {
                $ardeaCore->getCss()->regStyle("layer_fly_".$this->getProperty("id"),$this->layerProperty->buildProperty('style'));
                $this->smarty->assign("property",$this->layerProperty->buildProperty("property"));
            }else {

                $this->smarty->assign("property",$this->layerProperty->buildProperty());
            }
            $this->smarty->assign("strHTML",$this->strHTML);
            $this->strHTML=$this->smarty->fetch("withDiv.tpl");
        }
        return $this->strHTML;
    }

    function write() {
        echo $this->strHTML;
    }
    function addStrHTML($str) {
        $this->strHTML=$this->strHTML==""?$str:$this->strHTML."\n".$str;
    }

    // for setting caption or text
    function setCaption($newCaption) {
        $this->property->property["main"]["caption"]=$newCaption;
    }
    function setText($newCaption) {
        $this->property->property["property"]["value"]=$newCaption;
    }
    function setValue($newValue) {
        $this->property->property["property"]["value"]=$newValue;
    }

    function getCaption() {
        return $this->property->property["main"]["caption"] ;
    }
    function getText($newCaption) {
        return $this->property->property["property"]["value"];
    }

    function getContain() {
        return $this->property->property["containProperty"]["contain"];
    }

    //for form
    function setFormName($newFormName) {
        $this->formParent=$newFormName;
    }
    function getFormName() {
        return $this->formParent;
    }

    //
    function setBuildOnPlugin() {
        $this->buildOnHome=false;
    }



    // make free object
    function  setToFreeObject() {
        $this->property->property["main"]["withDiv"]=1;
    }

    function setPos($x,$y) {
        $this->property->property["main"]["withDiv"]=1;
        $this->layerProperty->property["style"]["top"]=$y;
        $this->layerProperty->property["style"]["left"]=$x;
    }

    //use validation
    function setValidation($validationType,$validationMask="") {
        $this->useValidation=true;
        $this->property->property["validation"]["validation_type"]=$validationType;
        $this->property->property["validation"]["validation_mask"]=$validationMask;
    }
    function setMinimumChar($intCharLength) {
        $this->minCharValidation=$intCharLength;
    }

}

?>
