<?php
/*======================================================
 * %%%%%%%%%%%%%PHPArdea CORE 2.0%%%%%%%%%%%%%%%%%%%%%%%
 * =====================================================
 * Author  : Maulana Al Matien.
 * Email   : ardea.core.php@gmail.com
 * Name    : ardeaVar.php
 * Date    : 
 * Used for: Basic library for Variable in ArdeaCore
 * ======================================================
 * Copyright Ardea Workshop. http://ardea-workshop.co.cc/ardeaCore.php
 * You allowed to use this component or parts of it under LGPLv3 terms
 * To use it on other terms or get Professional edition of the component 
 * please contact us at ardea.core.php@gmail.com
*/
/**
 * @version		2.0
 * @package		lib
 * @subpackage	core
 * @author	Maulana al matien
 * @copyright Ardea-Workshop/Maulana Al Matien (2008-2009). All rights reserved.
 * @license http://www.gnu.org/licenses/lgpl-3.0.txt GNU Lesser General Public License (LGPLv3)
 */
class _ardeaVar {
    private $badWord="";
    private $record="";
    private $vars=array();
    function _ardeaVar() {
        $this->badWord="(delete)|(update)|(union)|(insert)|(drop)|(http)|(--)";
        $this->record=array();
    }
    function init($optionInit="default") {
        global $ardeaCore;
        switch($optionInit) {
            case "default":
                foreach($_POST as $key=> $value ) {
                    $value=$this->fixVar($value);
                    $ardeaCore->setProperty($key,cleanQuery($value),"var_post");
                }
                foreach($_GET as $key=> $value ) {
                    $value=$this->fixVar($value);
                    $ardeaCore->setProperty($key,cleanQuery($value),"var_get");
                }

                break;
            case "db":
                $rs=$ardeaCore->executeSQL("select * from ard_var ");
                if($rs) {
                    foreach($rs->fields as $key => $value) {
                        $ardeaCore->setProperty($key,cleanQuery($value),"var_db");
                    }
                }
                break;
            case "db+default":
                foreach($_POST as $key=> $value ) {
                    $value=$this->fixVar($value);
                    $ardeaCore->setProperty($key,cleanQuery($value),"var_post");
                }
                foreach($_GET as $key=> $value ) {
                    $value=$this->fixVar($value);
                    $ardeaCore->setProperty($key,cleanQuery($value),"var_get");
                }

                break;
            case "get":
                foreach($_GET as $key=> $value ) {
                    $value=$this->fixVar($value);
                    $ardeaCore->setProperty($key,cleanQuery($value),"var_get");
                }
                break;
            case "post":
                foreach($_POST as $key=> $value ) {
                    $value=$this->fixVar($value);
                    $ardeaCore->setProperty($key,cleanQuery($value),"var_post");
                }
                break;
            case "cookies":
                foreach($_COOKIE as $key=> $value ) {
                    $value=$this->fixVar($value);
                    $ardeaCore->setProperty($key,cleanQuery($value),"var_cookies");
                }
                break;
            case "session":
                foreach($_SESSION as $key=> $value ) {
                    $value=$this->fixVar($value);
                    $ardeaCore->setProperty($key,cleanQuery($value),"var_session");
                }
                break;
        }

    }
    function getAllVar($parentName="var",$hasCleanQuery=false) {
        global $ardeaCore;
        $tmpArr=array();
        //die(print_r($ardeaCore->exportProperty()));
        $tmpArr=get_defined_vars();
        if($parentName=="var") {
            return $tmpArr;
        }elseif($parentName=="var_server_vars") {
            return $HTTP_SERVER_VARS;
        }elseif($parentName=="var_server") {
            return $_SERVER;
        }elseif($parentName=="var_cookie_var") {
            return $HTTP_COOKIE_VARS;
        }elseif($parentName=="var_cookie") {
            return $COOKIE;
        }elseif($parentName=="var_env_var") {
            return $HTTP_ENV_VARS;
        }elseif($parentName=="var_env") {
            return $_ENV;
        }elseif($parentName=="var_request") {
            return $_REQUEST;
        }elseif($parentName=="var_file") {
            return $_FILES;
        }elseif($parentName=="var_post") {
            if($hasCleanQuery) {
                foreach($ardeaCore->exportProperty() as $key => $value) {
                    if($key==$parentName) {
                        $tmpArr[$key]=$value;
                    }
                }
            }else {
                return $_POST;
            }
        }elseif($parentName=="var_get") {
            if($hasCleanQuery) {
                foreach($ardeaCore->exportProperty() as $key => $value) {
                    if($key==$parentName) {
                        $tmpArr[$key]=$value;
                    }
                }
            }else {
                return $_GET;
            }
        }
        return  $tmpArr;
    }
    function getVar($varName,$parentName="var",$hasCleanQuery=false) {
        global $ardeaCore;

        //die("A".$ardeaCore->isPropertyHasExist($varName,$parentVar));
        $tmpArr=get_defined_vars();
        if($parentName=="var") {
            return $tmpArr[$varName];
        }elseif($parentName=="var_server_vars") {
            return $HTTP_SERVER_VARS[$varName];
        }elseif($parentName=="var_server") {
            return $_SERVER[$varName];
        }elseif($parentName=="var_cookie_var") {
            return $HTTP_COOKIE_VARS[$varName];
        }elseif($parentName=="var_cookie") {
            return $COOKIE[$varName];
        }elseif($parentName=="var_env_var") {
            return $HTTP_ENV_VARS[$varName];
        }elseif($parentName=="var_env") {
            return $_ENV[$varName];
        }elseif($parentName=="var_request") {
            return $_REQUEST[$varName];
        }elseif($parentName=="var_file") {
            return $_FILES[$varName];
        }elseif($parentName=="var_session") {
            return $_SESSION[$varName];
        }elseif($parentName=="var_post") {
            if($hasCleanQuery) {
                if($ardeaCore->isPropertyHasExist($varName,$parentName)) {
                    return $ardeaCore->getProperty($varName,$parentName);
                }else {
                    return "";
                }
            }else {
                return $_POST[$varName];
            }
        }elseif($parentName=="var_get") {

            if($hasCleanQuery) {
                if($ardeaCore->isPropertyHasExist($varName,$parentName)) {
                    return $ardeaCore->getProperty($varName,$parentName);
                }else {
                    return "";
                }
            }else {
                return $_GET[$varName];
            }
        }


    }
    function setReg($varName,$varValue) {
        $this->vars[$varName]=$varValue;
    }
    function getReg($varName) {
        return $this->vars[$varName];
    }
    function setVarInDB($varName,$varValue,$parentVar="default") {
        global $ardeaCore;
        $rec=array();
        $rec["varName"]=$varName;
        $rec["varData"]=$varValue;
        $rec["parentVar"]=$parentVar;
        $rec["parentVar"]=$parentVar;
        $rec["datecreated"]=date('Y-m-d G:i:s');

        //dbInsert($tableName,$arrayRecord)
        $varValue=$this->fixVar($varValue);
        $varValue=cleanQuery($varValue);
        $sql="select * from ard_var where varName='$varName' and parentVar='$parentVar'" ;
        $rs=$ardeaCore->executeSQL($sql);
        if($rs&&$rs->recordCount()) {
            $ardeaCore->dbUpdate("ard_var",$rec,"where varName='$varName' and parentVar='$parentVar'");
        }else {
            $ardeaCore->dbInsert("ard_var",$rec);
        }
    }
    function setVarRecords($newVarRecord) {
        global $ardeaCore;
        if(is_array($newVarRecord)) {
            foreach($newVarRecord as $key => $value) {
                if($ardeaCore->isPropertyHasExist($value,"var_post")) {
                    $this->record[$value]=$ardeaCore->getProperty($value,"var_post");
                }
            }
        }else {
            $this->record[$newVarRecord]=$ardeaCore->getProperty($newVarRecord,"var_post");
        }
    }
    function getVarRecord() {
        return $this->record;
    }
    function getVarInDB($varName,$parentVar="default",$deleteRecordBool=true) {
        global $ardeaCore;
        $sql="select * from ard_var where varName='$varName' and parentVar='$parentVar'";
        $rs=$ardeaCore->executeSQL($sql);
        if($rs&&$rs->RecordCount()!=0) {
            if($deleteRecordBool)
                $this->deleteVar($varName,$parentVar);
            return $rs->fields["varData"];
        }
        return ;
    }
    function getAllVarInDB($parentVar="default",$deleteRecordBool=true) {
        global $ardeaCore;
        $tmpArr=array();
        $sql="select varData,varName from ard_var where parentVar='$parentVar'";
        $rs=$ardeaCore->executeSQL($sql,1);
        if($rs&&$rs->recordCount()) {
            if($deleteRecordBool)
                $this->deleteAllVar($parentVar);
            // var_dump($rs);
            while(!$rs->EOF) {
                $tmpArr[$rs->fields["varName"]]=$rs->fields["varData"];
                //echo "A".$rs->fields["varName"];
                $rs->next();
            }
        }
        return $tmpArr;
    }
    function deleteVar($varName,$parentVar) {
        global $ardeaCore;
        $sql="select * from ard_var where varName='$varName' and parentVar='$parentVar'";
        $rs=$ardeaCore->executeSQL($sql);
        if($rs&&$rs->RecordCount()!=0) {
            $sql="delete from ard_var where varName='$varName' and parentVar='$parentVar'";
            $ardeaCore->executeSQL($sql);
        }
    }
    function deleteAllVar($parentVar) {
        global $ardeaCore;
        $sql="delete  from ard_var where parentVar='$parentVar'";
        $ardeaCore->executeSQL($sql);
    }
    function issetVar($varName,$parentVar) {
        global $ardeaCore;
        $sql="select * from ard_var where varName='$varName' and parentVar='$parentVar'";
        $rs=$ardeaCore->executeSQL($sql);
        if($rs->RecordCount()!=0) {
            return "hasset";
        }
    }
    function addBadWord($newBadWord) {
        if(is_array($newBadWord)) {
            foreach($newBadWord as $key =>$value) {
                $this->badWord.="|(".$value.")";
            }
        }else {
            $this->badWord.="|(".$newBadWord.")";
        }
    }
    function fixVar($varName) {
        return eregi_replace($this->badWord, "", $varName);
    }

}
function getPostVar($varName) {
    return $_POST[$varName];
}
function addURLGET() {
    $strTmp="";
    foreach($_GET as $key => $value) {
        $strTmp.="&".$key."=".$value;
    }
    return substr($strTmp,1);
}
function getGetVar($varName) {
    return $_GET[$varName];
}
function convertData($str) {
    $rep="TANDAMIRING";
    $str=str_replace('\\', $rep, $str);
    $rep="PETIKDUA";
    $str=preg_replace('/[\"]/', $rep, $str);
    $rep="PETIKSATU";
    $str=preg_replace('/[\']/', $rep, $str);
    return $str;
}
function revertData($str) {
    $rep="\\";
    $str=str_replace('TANDAMIRING', $rep, $str);
    $rep="\"";
    $str=str_replace('PETIKDUA', $rep, $str);
    $rep="'";
    $str=str_replace('PETIKSATU', $rep, $str);
    return $str;
}
function cleanQuery($string) {
    if(get_magic_quotes_gpc()) {
        $string = stripslashes($string);
    }
    if (phpversion() >= '4.3.0') {
        $string = mysql_real_escape_string($string);
    }
    else {
        $string = mysql_escape_string($string);
    }
    return $string;
}

?>
