<?php
/**
 * @version		2.0
 * @package		lib.core
 * @subpackage	blog
 * @author	Maulana al matien
 * @copyright Ardea-Workshop/Maulana Al Matien (2008-2009). All rights reserved.
 * @license http://www.gnu.org/licenses/lgpl-3.0.txt GNU Lesser General Public License (LGPLv3)
 */
function createArticleTable($ardeaDBConfClass) {
    global $ardeaCore;
    $db=$ardeaCore->getDB($ardeaDBConfClass);

    $SQL=<<<SQL
CREATE TABLE IF NOT EXISTS article (
  id int(11) unsigned NOT NULL auto_increment,
  title varchar(255) NOT NULL default '',
  introtext mediumtext NOT NULL,
  completetext mediumtext NOT NULL,
  state tinyint(3) NOT NULL default '0',
  secid int(11) unsigned NOT NULL default '0',
  catid int(11) unsigned NOT NULL default '0',
  front tinyint(3) NOT NULL default '0',
  created datetime NOT NULL default '0000-00-00 00:00:00',
  created_by int(11) unsigned NOT NULL default '0',
  modified datetime NOT NULL default '0000-00-00 00:00:00',
  modified_by int(11) unsigned NOT NULL default '0',
  publish_up datetime NOT NULL default '0000-00-00 00:00:00',
  publish_down datetime NOT NULL default '0000-00-00 00:00:00',
  parentid int(11) unsigned NOT NULL default '0',
  ordering int(11) NOT NULL default '0',
  access int(11) unsigned NOT NULL default '0',
  hits int(11) unsigned NOT NULL default '0',
  PRIMARY KEY  (id)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8 AUTO_INCREMENT=1 ;
SQL;

    $db->execute($SQL);

    $SQL=<<<SQL
CREATE TABLE IF NOT EXISTS comments (
  ID bigint(20) unsigned NOT NULL auto_increment,
  post_ID bigint(20) unsigned NOT NULL default '0',
  author tinytext NOT NULL,
  author_email varchar(100) NOT NULL default '',
  author_url varchar(200) NOT NULL default '',
  author_IP varchar(100) NOT NULL default '',
  date datetime NOT NULL default '0000-00-00 00:00:00',
  date_gmt datetime NOT NULL default '0000-00-00 00:00:00',
  content text NOT NULL,
  karma int(11) NOT NULL default '0',
  approved varchar(20) NOT NULL default '1',
  agent varchar(255) NOT NULL default '',
  type varchar(20) NOT NULL default '',
  parent bigint(20) unsigned NOT NULL default '0',
  user_id bigint(20) unsigned NOT NULL default '0',
  PRIMARY KEY  (ID)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8 AUTO_INCREMENT=1 ;
SQL;

    $db->execute($SQL);
    $SQL=<<<SQL
CREATE TABLE IF NOT EXISTS article_log (
  id int(11) NOT NULL auto_increment,
  date_created datetime NOT NULL,
  date_modified datetime default NULL,
  article_id int(11) NOT NULL,
  PRIMARY KEY  (id)
) ENGINE=MyISAM DEFAULT CHARSET=latin1 AUTO_INCREMENT=1 ;
SQL;

    $db->execute($SQL);
}
?>