<?php
/*======================================================
 * %%%%%%%%%%%%%PHPArdea CORE 2.0%%%%%%%%%%%%%%%%%%%%%%%
 * =====================================================
 * Author  : Maulana Al Matien.
 * Email   : ardea.core.php@gmail.com
 * Name    : ardeaAbout.php
 * Date    : 
 * Used for:
 * ======================================================
 * Copyright Ardea Workshop. http://ardea-workshop.co.cc/ardeaCore.php
 * You allowed to use this component or parts of it under LGPLv3 terms
 * To use it on other terms or get Professional edition of the component 
 * please contact us at ardea.core.php@gmail.com
*/
/**
 * @version		2.0
 * @package		lib.core
 * @subpackage	db
 * @author	Maulana al matien
 * @copyright Ardea-Workshop/Maulana Al Matien (2008-2009). All rights reserved.
 * @license http://www.gnu.org/licenses/lgpl-3.0.txt GNU Lesser General Public License (LGPLv3)
 */
//include("config.inc.php");
include("abstractdb.php");
//include("ardeaLibrary.php") ;
include("aIterator.php") ;

function _get_auto_select_sql($tableName,$arrField=null,$extendQuery=null) {
    $tmpStr='';
    if(!is_array($tableName)) {
        $tableName=explode(",",$tableName);
    }
    if($extendQuery==null)
        $extendQuery='';
    $tmpStr='';
    while ($arr = current($tableName)) {
        if(is_numeric(key($tableName))) {
            if(is_array($arr)) {
                $tmpStr.=",'".$arr[key($arr)]."' as '".key($arr)."' ";
            }else {
                $tmpStr.=",'".$arr."' ";
            }
        }else {
            $tmpStr.=",'".$arr."' as '".key($tableName)."' ";
        }
        next($tableName);
    }
    $tableName=substr($tmpStr,1);
    $tmpStr='';
    if($arrField!=null) {
        if(!is_array($arrField)) {
            $arrField=explode(",",$arrField);
        }
        while ($arr = current($arrField)) {

            if(is_numeric(key($arrField))) {
                if(is_array($arr)) {
                    $tmpStr.=",'"._change_quotes($arr[key($arr)])."' as '"._change_quotes(key($arr))."' ";
                }else {
                    $tmpStr.=",'"._change_quotes($arr)."' ";
                }
            }else {
                $tmpStr.=",'"._change_quotes($arr)."' as '"._change_quotes(key($arrField))."' ";
            }
            next($arrField);
        }
        $tmpStr=substr($tmpStr,1);
        $sqlStr="SELECT ".$tmpStr." FROM "._change_quotes($tableName)." ".$extendQuery;
        return $sqlStr;
    }else {
        $sqlStr="SELECT * FROM "._change_quotes($tableName)." ".$extendQuery;
        return $sqlStr;
    }
}
function _change_quotes($str,$quotesType="'",$quotesChange='`') {
    return str_replace($quotesType,$quotesChange,$str);
}

function _get_auto_insert_sql($aThis,$table=null,$arrField_values=null,$extendQuery=null) {
    if($table!=null) {
        $nameField=$aThis->getPropertyField(_get_auto_select_sql($table),'name');
        $table=_fixVar($table,true);
    }
    //if($extendQuery!=null)
    //$extendQuery=_fixVar($extendQuery);
    $fields='';
    $values='';
    if($arrField_values!=null) {
        if(is_array($arrField_values)) {
            $element0 = reset($arrField_values);
            $array_2d = is_array($element0) && !is_object(reset($element0));
            if($array_2d)
                die("arrField_values tidak bole 2 dimensi");
            foreach($arrField_values as $key => $value) {
                if(in_array(strtolower($key),$nameField)) {
                    $fields.=","._fixVar($key,true);
                    $values.=","._fixVar($value,true);
                }
            }
            $fields=substr($fields,1);
            $values=substr($values,1);
        }
    }else {
        $fields='BAD ARRAY';
    }
    if($table!=null&&$fields!=''&&$fields!='BAD ARRAY') {
        $tmpStr=substr($tmpStr,1);
        $sqlStr="INSERT INTO "._change_quotes($table)." ("._change_quotes($fields).") VALUES(".$values.") ".$extendQuery.";";
        $sqlStr=$sqlStr;
        return $sqlStr;
    }else {
        die("field tidak ditemukan");
    }
}
function _get_auto_update_sql($aThis,$table=null,$arrField_values=null,$extendQuery=null) {
    if($table!=null) {
        $nameField=$aThis->getPropertyField(_get_auto_select_sql($table),'name');
        $table=_fixVar($table,true);
    }
    //if($extendQuery!=null)
    //$extendQuery=_fixVar($extendQuery);
    $field_values='';
    if($arrField_values!=null) {
        if(is_array($arrField_values)) {
            $element0 = reset($arrField_values);
            $array_3d = is_array($element0) && !is_object(reset($element0));
            if($array_3d)
                die("arrField_values tidak boleh 3 dimensi");

            foreach($arrField_values as $key => $value) {
                if(in_array(strtolower($key),$nameField)) {
                    $field_values.=","._change_quotes(_fixVar($key,true))."="._fixVar($value,true);
                }
            }
            $field_values=substr($field_values,1);
        }
    }else {
        $field_values='BAD ARRAY';
    }
    if($table!=null&&$field_values!=''&&$field_values!='BAD ARRAY')
        return "UPDATE "._change_quotes($table)." SET ".$field_values ." ".$extendQuery.";";
}
class ardeaDB {
    var $dbType;
    var $conn=null;
    var $result_type=3;
    var $sqlStr='';
    function ardeaDB($typeDb='mysql',$dbName=null,$result_type=ars::FETCH_BOTH) {
        try {
            switch(strtolower($typeDb)) {
                case 'mysql':
                    $this->dbType='mysql';

                    include_once('driver/aMysql.php');
                    //die("XX");
                    $this->conn=new aMysql($dbName);
                    break;
                case 'mssql':
                    $this->dbType='mssql';
                    include_once('driver/aMssql.php');
                    break;
                case 'odbc':
                    $this->dbType='odbc';
                    include_once('driver/aODBC.php');
                    break;
                case 'oracle':
                    $this->dbType='oracle';
                    include_once('driver/aOracle.php');
                    break;
                case 'sqllite':
                    $this->dbType='sqllite';
                    include_once('driver/aSqlLite.php');
                    break;
            }
        }catch(Exception $e) {
            echo "Koneksi tidak berhasil".$e->getMessage();
        }
        $this->result_type=$result_type;
    }
    function connect($hostName,$userName,$password,$dbName) {
        $this->conn->connect($dbName,$hostName,$userName,$password);
    }
    function connectWithConf($confClass=null) {
        if($confClass!=null)
            $this->conn->connect($confClass->dbname,$confClass->host,$confClass->user,$confClass->pass);
    }
    function setSQL($sqlStr) {
        $this->sqlStr=$sqlStr;
    }
    function hasConnect() {
        $this->conn->hasConnect();
    }
    function getSQL() {
        return $this->sqlStr;
    }
    function setResultMode($result_type=ars::FETCH_BOTH) {
        $this->result_type=$result_type;
    }

    function execute($queryStr,$inputArr=null) {
        if($queryStr=='auto'||$queryStr=='') {
            $queryStr=$this->sqlStr;
        }
        if(strpos($queryStr,'?')>-1) {
            if($inputArr==null)
                die("Execute Gagal, ada kesalaha yaitu: inputArr null");
            $strArr=explode('?',$queryStr);
            $sql='';
            $i=0;
            $element0 = reset($inputArr);
            $array_2d = is_array($element0) && !is_object(reset($element0));
            if(!$array_2d) {
                if((count($inputArr)-1)!=count($inputArr))
                    die("Execute Gagal, ada kesalaha yaitu: jumlah array inputArr tidak sama");
                foreach($strArr as $value) {
                    if($i>=(count($strArr)-1)) {
                        $sql.=$value;
                    }else {
                        $sql.=$value.$inputArr[$i];
                    }
                    $i++;
                }
                return $this->_query($sql);
            }else {
                //untuk insert
                $arrField=reset($arrField);
                foreach($arrField as $value ) {
                    return $this->execute($queryStr,$value);
                }
            }
        }else {
            return $this->_query($queryStr);
        }
    }
    private function _query($sql) {
        if($this->conn->hasConnect()) {
            try {
                //die($sql." ".$this->result_type);
                return $this->conn->query($sql, $this->result_type);

            }catch(Exception $e) {
                die("Execute Gagal, ada kesalaha yaitu:".$e->getMessage()."<br/>".mysql_error());
            }
        }else {
            die("DB not Connected");
        }
    }
    function autoExecute($table, $mode = 'SELECT',$inputArr=null,  $extendQuery = null ) {
        if(is_array($inputArr)) {
            $element0 = reset($inputArr);
            $array_2d = is_array($element0) && !is_object(reset($element0));
        }
        switch(strtolower($mode)) {
            case "select":
            //echo _get_auto_select_sql($table,$inputArr,$extendQuery);
                $tmpRs=$this->execute(_get_auto_select_sql($table,$inputArr,$extendQuery));
                if(!$tmpRs)
                    return false;
                break;
            case "insert":
                if($inputArr==null)
                    return false;
                if($array_2d) {
                    if($inputArr==null)
                        return false;
                    $inputArr=reset($inputArr);
                    foreach($inputArr as $value) {
                        $sql=_get_auto_insert_sql($this,$table,$value,$extendQuery);
                        $tmpRs=$this->execute($sql, $inputArr);
                        if(!$tmpRs)
                            return false;
                    }
                }else {
                    $sql=_get_auto_insert_sql($this,$table,$inputArr,$extendQuery);
                    //die($sql.var_dump($inputArr));
                    return $this->execute($sql, $inputArr);
                }
                break;
            case "update":
                if($inputArr==null)
                    return false;
                if($array_2d) {
                    $inputArr=reset($inputArr);
                    foreach($inputArr as $value) {
                        $sql=_get_auto_update_sql($this,$table,$value,$extendQuery);
                        $tmpRs=$this->execute($sql, $inputArr);
                        if(!$tmpRs)
                            return false;
                    }
                }else {
                    $sql=_get_auto_update_sql($this,$table,$inputArr,$extendQuery);
                    // echo   $sql;
                    return $this->execute($sql, $inputArr);
                }
                break;
            case "delete":
                if(is_array($inputArr)) {
                    if($table!=null) {
                        $nameField=$this->getPropertyField(_get_auto_select_sql($table),'name');
                        $table=_fixVar($table,true);
                    }
                    foreach($inputArr as $key => $value) {
                        if(in_array(strtolower($key),$nameField)) {
                            $field_values.=","._change_quotes(_fixVar($key,true))."="._fixVar($value,true);
                        }
                    }
                    if($field_values!="")
                        $field_values=substr($field_values,1);
                    if($field_values!="")
                        return $this->execute("delete from $table where $field_values");
                }
                break;
        }
        return $tmpRs;
    }
    function getPropertyField($sql,$resultType='default') {
        $tmpRs=$this->conn->_query($sql);
        if(is_null($tmpRs)) {
            echo "ERROR ".mysql_error();
            return null;
        }
        $jmlField=mysql_num_fields($tmpRs);
        $fieldSet=array();
        for($i=0;$i<$jmlField;$i++) {
            $tmp=mysql_fetch_field($tmpRs,$i);
            $fieldSet[$tmp->name]=$tmp;
            $fieldSet[$i]=$tmp;
        }
        $tmpArr=array();
        switch($resultType) {
            case 'name':
                for($i=0;$i<$jmlField;$i++) {
                    $tmpArr[$i]=strtolower($fieldSet[$i]->name);
                }
                return $tmpArr;
                break;
            case 'null':
                for($i=0;$i<$jmlField;$i++) {
                    $tmpArr[$i]=$fieldSet[$i]->not_null?0:1;
                }
                break;
            case 'null_name':
                for($i=0;$i<$jmlField;$i++) {
                    if(!$fieldSet[$i]->not_null)
                        $tmpArr[$i]=strtolower($fieldSet[$i]->name);
                }
                break;
            case 'not_null':
                for($i=0;$i<$jmlField;$i++) {
                    $tmpArr[$i]=$fieldSet[$i]->not_null;
                }
                break;
            case 'not_null_name':
                for($i=0;$i<$jmlField;$i++) {
                    if($fieldSet[$i]->not_null)
                        $tmpArr[$i]=strtolower($fieldSet[$i]->name);
                }
                break;
            case 'primary':
                for($i=0;$i<$jmlField;$i++) {
                    if($fieldSet[$i]->primary_key)
                        $tmpArr[$i]=strtolower($fieldSet[$i]->name);
                }
                break;
            case 'unique':
                for($i=0;$i<$jmlField;$i++) {
                    if($fieldSet[$i]->unique_key)
                        $tmpArr[$i]=strtolower($fieldSet[$i]->name);
                }
                break;
            case 'not_unique':
                for($i=0;$i<$jmlField;$i++) {
                    if($fieldSet[$i]->multiple_key)
                        $tmpArr[$i]=strtolower($fieldSet[$i]->name);
                }
                break;
            case 'numeric':
                for($i=0;$i<$jmlField;$i++) {
                    if($fieldSet[$i]->numeric)
                        $tmpArr[$i]=strtolower($fieldSet[$i]->name);
                }
                break;
            case 'not_numeric':
                for($i=0;$i<$jmlField;$i++) {
                    if(!$fieldSet[$i]->numeric)
                        $tmpArr[$i]=strtolower($fieldSet[$i]->name);
                }
                break;
            case 'blob':
                for($i=0;$i<$jmlField;$i++) {
                    if($fieldSet[$i]->blob)
                        $tmpArr[$i]=strtolower($fieldSet[$i]->name);
                }
                break;
            case 'not_blob':
                for($i=0;$i<$jmlField;$i++) {
                    if(!$fieldSet[$i]->blob)
                        $tmpArr[$i]=strtolower($fieldSet[$i]->name);
                }
                break;
            case 'type':
                for($i=0;$i<$jmlField;$i++) {
                    $tmpArr[$i]=$fieldSet[$i]->type;
                }
                break;
            case 'unsigned':
                for($i=0;$i<$jmlField;$i++) {
                    if($fieldSet[$i]->unsigned)
                        $tmpArr[$i]=$fieldSet[$i]->type;
                }
                break;
            case 'not_unsigned':
                for($i=0;$i<$jmlField;$i++) {
                    if(!$fieldSet[$i]->unsigned)
                        $tmpArr[$i]=$fieldSet[$i]->type;
                }
                break;
            case 'zerofill':
                for($i=0;$i<$jmlField;$i++) {
                    if($fieldSet[$i]->zerofill)
                        $tmpArr[$i]=$fieldSet[$i]->type;
                }
                break;
            case 'not_zerofill':
                for($i=0;$i<$jmlField;$i++) {
                    if(!$fieldSet[$i]->zerofill)
                        $tmpArr[$i]=$fieldSet[$i]->type;
                }
                break;
            default:
                return $fieldSet;
        }
    }


}
class _ardeaDbTools {
    function sumif($rs,$fieldName) {
    }
}
class ardeaDBConf {
    public $host;
    public $pass;
    public $user;
    public $dbname;
}
?>
