<?php
/**
 * @version		2.0
 * @package		lib.core
 * @subpackage	mvc
 * @author	Maulana al matien
 * @copyright Ardea-Workshop/Maulana Al Matien (2008-2009). All rights reserved.
 * @license http://www.gnu.org/licenses/lgpl-3.0.txt GNU Lesser General Public License (LGPLv3)
 */
class controller {
    protected $reg;
    public $ROUTE_DIE_ON_ERROR=true;
    protected $appName="local";
    protected $data;
    protected $urlErrorRedirect="error.php";
    protected $__hasload=false;
    protected $loadOpt="";
    function __construct() {
        global $mvcReg;
        $this->reg=&$mvcReg;
        $this->reg->set("error","");
        $this->reg->set("error_type","");
    }
    public function __constructhasload() {
        return $this->__hasload;
    }
    protected function initConstruct() {
        parent::__construct();
    }
    function setURLErrorRedirect($newURL) {
        $this->urlErrorRedirect=$newURL;
    }
    function isInit() {
        if(!is_object($this->reg)) {
            $this->__construct();
        }
    }
    function setOpt($newOpt="opt") {
        $this->loadOpt=$newOpt;
    }
    function setAppName($newAppName) {
        global $mvcReg;
        $this->appName=$newAppName;
        $this->__constructhasload();

    }
    function setPath($absolutePath) {
        $this->reg->set("ardea:mvc:path",$absolutePath);
    }
    function doRoute($routerName=null) {
        //die($this->reg->get($this->reg->get("default")));
        global $mvcReg;
        $this->isInit();
        if($routerName==null) {
            //die($this->reg->get($this->reg->get("default")));
            if($this->reg->get($this->reg->get("default"))=="") {

                $roadMap=$this->getRoadMap('first','controller');

                if(!$roadMap) {
                    if($this->ROUTE_DIE_ON_ERROR) {
                        $this->gotoErrorPage();
                    }else {
                        return $this->gotoErrorPage();
                    }
                }
                include_once($roadMap);
                $myClass="first_controller";
                //die(var_dump(class_exists($myClass)));
                if(class_exists($myClass)) {
                    //die("xx");
                    $funcName=$myClass;

                    $myClass=new $myClass;
                    //die($myClass->__constructhasload());
                    $myClass->setAppName($this->appName);
                    if(!$myClass->__constructhasload())
                        $myClass->$funcName();
                    return $myClass;
                }
            }else {
                $routerName=$this->reg->get($this->reg->get("default"));
                $roadMap=$this->getRoadMap($routerName,'controller');
                //die($roadMap);
                if(!$roadMap) {
                    if($this->ROUTE_DIE_ON_ERROR) {
                        $this->gotoErrorPage();
                    }else {
                        return $this->gotoErrorPage();
                    }
                }

                include_once($roadMap);
                $myClass=$mvcReg->get($mvcReg->get("default"))."_controller";
                if(class_exists($myClass)) {
                    $funcName=$myClass;
                    $myClass=new $myClass;
                    $myClass->setAppName($this->appName);
                    if(!$myClass->__constructhasload())
                        $myClass->$funcName();
                    $myClass->$funcName();
                    return $myClass;
                }
            }
        }else {

            $roadMap=$this->getRoadMap($routerName,'controller');
            //echo $routerName;
            if(!$roadMap) {
                if($this->ROUTE_DIE_ON_ERROR) {
                    $this->gotoErrorPage();
                }else {
                    return $this->gotoErrorPage();
                }
            }
            //echo $roadMap;
            include_once($roadMap);
            $myClass=$routerName."_controller";
            if(class_exists($myClass)) {
                $funcName=$myClass;
                $myClass=new $myClass;
                $myClass->setAppName($this->appName);
                if(!$myClass->__constructhasload())
                    $myClass->$funcName();
                return $myClass;
            }
        }
    }
    function getData() {
        return $this->data;
    }
    function &getModel($modelName='default') {
        $this->isInit();
        if($modelName=='default') {
            $roadMap=$this->reg->get($this->reg->get("default_model"));
            if($roadMap=="")
                $this->reg->set($this->reg->get("default_model"),"first");
            $roadMap=$this->getRoadMap(($roadMap=="")?'first':$roadMap,'model');

            //echo $roadMap;
            if(!$roadMap) {
                if($this->ROUTE_DIE_ON_ERROR) {
                    $this->gotoErrorPage();
                }else {
                    return $this->gotoErrorPage();
                }
            }

            include_once($roadMap);
            $class=$this->reg->get($this->reg->get("default_model"))."_model";
            if(strrpos($class,".")) {
                $class=substr($class,strrpos($class,".")+1);
            }
            if (class_exists($class)) {
                return new $class;
            }else {
                return null;
            }


        }else {
            $roadMap=$this->getRoadMap($modelName,'model');

            if(!$roadMap) {
                if($this->ROUTE_DIE_ON_ERROR) {
                    $this->gotoErrorPage();
                }else {
                    return $this->gotoErrorPage();
                }
            }
            include_once($roadMap);
            $modelName.="_model";
            if(strrpos($modelName,".")) {
                $modelName=substr($modelName,strrpos($class,".")+1);
            }
            return new $modelName;
        }


    }
    function &runModel($modelName,$functionName,$paramArray=array()) {
        $modelTmp=$this->getModel($modelName);
        if($modelTmp) {
            return $this->runCommand($modelTmp, $functionName,$paramArray);
        }
    }
    function &getView($viewName='default') {
        $this->isInit();
        //die("AAA".$this->appName);
        if($viewName=='default') {
            $roadMap=$this->reg->get($this->reg->get("default"));
            if($roadMap=="")
                $this->reg->set($this->reg->get("default"),"first");
            $roadMap=$this->getRoadMap(($roadMap=="")?'first':$roadMap);


            if(!$roadMap) {
                if($this->ROUTE_DIE_ON_ERROR) {
                    $this->gotoErrorPage();
                }else {
                    return $this->gotoErrorPage();
                }
            }

            include_once($roadMap);
            //var_dump($roadMap.$this->reg->get($this->reg->get("default")));
            $class=$this->reg->get($this->reg->get("default"));
            //if()
            $class=new $class;
            //die("view".$this->appName);
            if($this->appName!=null) {
                $class->setAppName($this->appName);
                $class->setPath($this->reg->get("ardea:mvc:path"));
            }
            return $class;
        }else {
            $roadMap=$this->getRoadMap($viewName);
            if(!$roadMap) {
                if($this->ROUTE_DIE_ON_ERROR) {
                    $this->gotoErrorPage();
                }else {
                    return $this->gotoErrorPage();
                }
            }
            include_once($roadMap);
            $class=new $viewName;
            if($this->appName!=null) {
                $class->setAppName($this->appName);
                $class->setPath($this->reg->get("ardea:mvc:path"));
            }
            return $class;
        }


    }
    function &runCommand($classObject,$functionName,$param=array()) {
        //die("AAA".$this->appName);
        if(is_object($classObject)) {
            if(method_exists($classObject,$functionName)) {
                return call_user_method_array ($functionName,$classObject,$param);
            }else {
                return "ERROR COMMAND NOT FOUND";
            }
        }
    }

    function getTemplate($templateName) {
        $roadMap=$this->getRoadMap('template');
    }
    function setErrorFile($fileName='default') {
        $this->isInit();
        if (is_readable($this->reg->get("ardea:mvc:path")."/errors/".$fileName.".php")) {
            $this->reg->set("error",$this->reg->get("ardea:mvc:path")."/errors/".$fileName.".php");
        }
    }
    function gotoErrorPage() {
        $this->isInit();
        if($this->reg->get("error")=="") {
            if($this->ROUTE_DIE_ON_ERROR) {
                include($this->urlErrorRedirect);
                die();
                //die("ERROR FILE NOT FOUND (".$this->reg->get("error_type").")");
            }else {
                return false;
            }
        }else {
            include($this->reg->get("error"));
        }

    }

    function getRoadMap($nameMap,$typeMap='view') {
        //echo $nameMap." ".$typeMap." ".$this->appName." ;";
        global $mvcReg;
        $this->isInit();
        $extName=".php";
        switch($typeMap) {
            case 'view':
            //die(var_dump($this->appName));
                $typeMap=$mvcReg->get("app_path_view:".$this->appName);
                //die($typeMap);
                break;
            case 'model':
                $typeMap=$mvcReg->get("app_path_model:".$this->appName);
                //$nameMap.="_model";
                //var_dump($this->appName);
                break;
            case 'form':
                $typeMap=$mvcReg->get("app_window_path_form:".$this->appName);
                //$nameMap.="_model";
                break;
            case 'script':
                $typeMap=$mvcReg->get("app_window_path_script:".$this->appName);
                $extName=".js";
                break;
            case 'form':
                $typeMap=$mvcReg->get("app_window_path_form:".$this->appName);
                break;
            case 'form_setting':
                $typeMap=$mvcReg->get("app_window_path_form:".$this->appName);
                $extName=".xml";
                break;
            case 'module':
                $typeMap=$mvcReg->get("app_window_path_module:".$this->appName);
                break;
            case 'template':
                $typeMap="templates";
                $extName=".tpl";
                break;
            case 'controller':
                $typeMap=$mvcReg->get("app_path_controller:".$this->appName);
                //die($typeMap);
                break;
            case 'error':
                $typeMap="errors";
                break;
        }
        //echo "XXX".$nameMap." ".$typeMap;

        $nameMap=str_replace(".","/",$nameMap);

        if($this->loadOpt=="frm") {
            //var_dump($typeMap);
            if (is_readable($mvcReg->get("app_window_path:".$this->appName).$typeMap.$nameMap.$extName) == false) {
                //die($this->reg->get("ardea:mvc:path")."/".$typeMap."/".$nameMap.$extName);
                $this->reg->set("error_type",$typeMap);
                $this->setErrorFile($nameMap);
                return false;
            }
            return 	$mvcReg->get("app_window_path:".$this->appName).$typeMap.$nameMap.$extName;
        }else {
            //echo($this->reg->get("ardea:mvc:path").$typeMap."/".$nameMap.$extName);

            if (is_readable($this->reg->get("ardea:mvc:path").$typeMap.$nameMap.$extName) == false) {
                //var_dump($mvcReg);
                //die($this->reg->get("ardea:mvc:path").$typeMap.$nameMap.$extName." ".$this->appName);
                $this->reg->set("error_type",$typeMap);
                $this->setErrorFile($nameMap);
                return false;
            }
            return 	$this->reg->get("ardea:mvc:path").$typeMap.$nameMap.$extName;
        }
    }
    protected function go() {
    }
}
class router extends controller {
}
?>
