<?php
/*======================================================
 * %%%%%%%%%%%%%PHPArdea CORE 2.0%%%%%%%%%%%%%%%%%%%%%%%
 * =====================================================
 * Author  : Maulana Al Matien.
 * Email   : ardea.core.php@gmail.com
 * Name    : ardeaTemplate.php
 * Date    : 
 * Used for: Basic library for Variable in ArdeaCore
 * ======================================================
 * Copyright Ardea Workshop. http://ardea-workshop.co.cc/ardeaCore.php
 * You allowed to use this component or parts of it under LGPLv3 terms
 * To use it on other terms or get Professional edition of the component 
 * please contact us at ardea.core.php@gmail.com
*/

loadLib("lib.core.mvc.ardeaMVC");
//loadLib("lib.core.blog.ardeaBlog");
global $mvcReg;
$mvcReg->set("default_themes","thm");
global $template_path;
/**
 * @version		2.0
 * @package		lib.core
 * @subpackage	template
 * @author	Maulana al matien
 * @copyright Ardea-Workshop/Maulana Al Matien (2008-2009). All rights reserved.
 * @license http://www.gnu.org/licenses/lgpl-3.0.txt GNU Lesser General Public License (LGPLv3)
 */
class template {
    protected $router=null;
    protected $path;
    protected $folderPath;
    protected $templateName;
    protected $mvcPath="";
    protected $data="";
    protected $stateForObject=false;
    protected $titlePage="";
    protected $useGetData=true;
    protected $useRouterPage=true;
    protected $useFinishingData=true;
    protected $useRouter=true;
    protected $extendedData=array();
    protected $isProcessData=true;
    protected $isFinishProcess=false;
    protected $appName="";
    protected $keyData="<ext:page:";
    //protected $urlErrorRedirect="error.php";
    protected $dieOnError=false;
    protected $routerResult=false;
    function __construct() {
        $this->folderPath="themes/";

    }
    function setDieOnError() {
        $this->dieOnError=true;
    }
    function setURLErrorRedirect($newURL) {
        $this->router->setURLErrorRedirect($newURL);
        //$this->urlErrorRedirect=$newURL;
    }
    function setRoute($routeObject) {
        $this->router=$routeObject;
    }
    function & getRouter() {
        return $this->router;
    }
    function setKeyData($newKeyData) {
        $this->keyData=$newKeyData;
    }
    function setMVCPath($MVCAbsolutePath) {
        if(is_object($this->router)) {
            $this->router->setPath($MVCAbsolutePath);
        }
        $this->mvcPath=$MVCAbsolutePath;
    }
    function setFolderThemes($newFolderPath) {
        $this->folderPath=$newFolderPath."/";
    }
    function setNoFolderThemes() {
        $this->folderPath="";
    }
    function setAppName($newAppName) {
        $this->appName=$newAppName;

        if($this->router!=null) {
            //die("SSS".$newAppName);
            $this->router->setAppName($newAppName);
        }
    }
    public static function getVar($varName) {
        global $mvcReg;
        return $mvcReg->getContain($varName);
    }
    public static function setVar($varName,$value) {
        global $mvcReg;
        $mvcReg->setContain($value,$varName);
    }

    function setTitlePage($newTitlePage) {
        $this->titlePage=$newTitlePage;
    }
    function setUseController($pathOfMvc=null) {
        $this->router=new controller;
        if($this->appName!="")
            $this->router->setAppName($this->appName);
        if($pathOfMvc!=null)
            $this->router->setPath($pathOfMvc);
    }
    function &runModel($modelName,$functionName,$paramArray=array()) {
        return $this->router->runModel($modelName,$functionName,$paramArray);
    }
    function &getModel($modelName) {
        return $this->router->getModel($modelName);
    }
    function &getModule($modelName) {
        return $this->router->getModel($modelName);
    }
    function &runCommand($classObject,$functionName,$paramArray=array()) {
        return $this->router->runCommand($classObject,$functionName,$paramArray);
    }
    function &runModule($modelName,$functionName,$paramArray=array()) {
        return $this->router->runModel($modelName,$functionName,$paramArray);
    }
    function setUseMVC($pathOfMvc=null) {
        $this->setUseController($pathOfMvc);
    }
    function setPath($URLPath) {
        $this->path=fixRealPath($URLPath);
        //die($this->path);
        //define('CURRENT_TEMPLATE_PATH',$URLPath);
    }
    function setTemplateName($newTemplateName) {
        $this->templateName=$newTemplateName;
    }

    function loadTemplate($TemplateName) {
        global $ardeaCore;
        if($this->path=="") {
            die("ERROR path not defined");
        }
        //echo $this->path.$TemplateName."/index.php";
        //die($this->path.$TemplateName."/index.php");
        if ( file_exists( $this->path.$TemplateName."/index.php" ) ) {
            global $template_path;
            $template_path=$this->folderPath.$TemplateName."/";
            ob_start();
            if($ardeaCore->isPageStillConstruct()) {
                include($this->path.$TemplateName."/under_construct.php");
            }else {
                include($this->path.$TemplateName."/index.php");
            }
            $contents = ob_get_contents();
            ob_end_clean();

            return $contents;
        }

    }
    function parseTemplate($data,$regexString,$callForAttribute='nothing',$callForReplace='nothing') {
        $replace = array();
        $matches = array();

        if(preg_match_all($regexString, $data, $matches)) {
            return $matches;
        }else {
            return false;
        }

    }
    function parseTemplateA($data,$regexString,$callForAttribute='nothing',$callForReplace='nothing') {
        $replace = array();
        $matches = array();

        if(preg_match_all($regexString, $data, $matches)) {

            if($callForAttribute=='nothing'&&$callForReplace=='nothing') {
                $result=$this->_generateAttribute($matches);
                die($result);
            }else {
                if($callForAttribute!='nothing') {
                    if(is_array($callForAttribute)) {
                        $methodName=$callForAttribute[0];
                        $callForAttribute[0]=$matches;
                        $result=call_user_func_array($methodName,$callForAttribute);
                    }else {
                        $result=call_user_func($callForAttribute,$matches);
                    }

                    if(is_array($callForReplace)) {
                        $methodName=$callForReplace[0];
                        $callForReplace[0]=$result;
                        $result=call_user_func_array($methodName,$callForReplace);
                    }else {
                        $result=call_user_func($callForReplace,$result);
                    }
                }
            }
            $data = str_replace($matches, $result, $data);
        }

        return $data;
    }

    private function _generateAttribute($arrResult) {
        $regexString='/([\w:-]+)[\s]?=[\s]?"([^"]*)"/i';
        $matches = array();

        preg_match_all($regexString, $arrResult, $matches);

        $tmpArr=array();
        $count=count($matches[0]);
        for($i=0;$i<$count;$i++) {
            //echo "<-".$matches[1][$i]." - " .$matches[2][$i] ."->";

            if(strtolower($matches[1][$i])=="arg") {
                //echo "D)".$matches[1][$i]."(D";
                if(!array_key_exists("arg",$tmpArr)) {
                    $tmpArr["arg"]=array();
                }
                $tmpArr["arg"][]=$matches[2][$i];
                //echo "(".$matches[2][$i].")";
            }else {
                $tmpArr[strtolower($matches[1][$i])]=$matches[2][$i];
            }
        }
        //echo "<br/>";
        //var_dump($tmpArr["arg"]);
        //echo "<br/>";
        // var_dump($tmpArr);
        return 	$tmpArr;
    }
    function getThemesName() {
        if($this->templateName=="") {
            $this->templateName="default";
        }
        return $this->templateName;
    }
    function getThemesPath() {
        return $this->folderPath.$this->getThemesName();
    }
    public function noUseGetData() {
        $this->useGetData=false;
    }
    public function noUseRouterPage() {
        $this->useRouterPage=false;
    }
    public function noUseFinishingData() {
        $this->useFinishingData=false;
    }
    public function noUseRouter() {
        $this->useRouter=false;
    }
    public function noProcessData() {
        $this->isProcessData=false;
    }
    public function setBreakBeforeWrite() {
        $this->isFinishProcess=true;
    }
    public function run($write=true) {
        global $mvcReg;
        global $template_title;
        global $ardeaCore;
        loadLib("lib.core.ardeaCookies");
        $typeRun=$ardeaCore->getRunType();
        $this->templateName=$mvcReg->get($mvcReg->get("default_themes"));
        $ck=new ardeaCookieSession();
        //$ck->setCookies("testAh","berhasil!!!");
//echo $ck->getCookies("testAh");

        if($this->templateName=="") {
            $thm=$ck->getCookies("ardea_application_thm");
            if($thm=="") {
                $this->templateName="default";
            }else {
                $this->templateName=$thm;
            }
        }else {
            $url=$mvcReg->get("app_path:".$this->appName).$mvcReg->get("app_path_themes:".$this->appName).$this->templateName;
            if(is_readable($url)) {
                $ck->setCookies("ardea_application_thm",$this->templateName);
            }else {
                $this->templateName="default";
            }
        }
        $mvcReg->set($mvcReg->get("default_themes"),$this->templateName);
        if($this->appName!=null) {
            $mvcReg->set("app_tmpl_folder:".$this->appName,$this->templateName);
            //$mvcReg->set("app_path_themes:".$this->name,$this->templateName);
        }else {
            $mvcReg->set("app_tmpl_folder",$this->templateName);
        }
        //die(var_dump($this->useRouter));
        if($this->useRouter) {
            $this->router->ROUTE_DIE_ON_ERROR=$this->dieOnError;
            $this->routerResult=$this->router->doRoute();
            if(!$this->routerResult&&function_exists("extendedRouting"))
                call_user_func_array( "extendedRouting",array($this->router));

            //global  $_funcLoad;
            //var_dump($_funcLoad);
        }
        $template_title=$this->titlePage;
        $data="";
        if($this->useGetData)
            $this->getDataTemplate(&$data);

        if($this->isProcessData)
            $this->runProcess($data);

        if($this->useRouterPage)
            $this->routerPage();

        if($this->useFinishingData)
            $this->finishingData(&$data);
        $this->data=$data;
        if($this->isFinishProcess)
            return;
//var_dump(get_class($this));


        if($typeRun!="pdf") {
            if($write) {
                if($typeRun=="cJs") {
                    echo $ardeaCore->getJsFileScriptTmp();
                }elseif($typeRun=="cCss") {
                    echo $ardeaCore->getCssFileScriptTmp();
                }elseif($typeRun=="xml") {
                    echo $ardeaCore->getXMLFileScriptTmp();
                }else {
                    echo $data;
                }
            }
        }else {
            $_pdf->addPage();
            $_pdf->WriteHTML($data);
        }

    }
    function addData($data) {
        $this->extendedData[]=$data;
    }
    function getData() {
        return $this->data;
    }
    protected function getDataTemplate(&$data) {
        global $mvcReg;
        $this->templateName=$mvcReg->get($mvcReg->get("default_themes"));
        $data=$this->loadTemplate($this->templateName);
        //var_dump($mvcReg->getArea());

        //var_dump($data);
        //die();
        foreach($mvcReg->getArea() as $key => $value) {
            $data = str_replace($this->keyData."$key/>",$value,$data);
        }
        $data_extend= "<!--window application data -->\n" ;
        foreach($this->extendedData as $value) {
            $data_extend .= $value ."\n" ;
        }
        $data_extend.= "<!--End window application data -->\n" ;

        $regexString="<ext:data_extended/>";
        $data = str_replace( $regexString,$data_extend, $data);

        $made="\n<!--";
        $made.="\nBuild by PHP ardeaCore Ver 2.0";
        $made.="\n-->";
        $data.=$made;
    }
    protected function routerPage() {
        global $ardeaCore;
        global $ardeaVar;
        global $_VAR_FILE_;
        global $_ARDEA_CONFIG;
        global  $_funcLoad;
        //var_dump($_funcLoad);


        $typeRun=$ardeaCore->getRunType();
        if($typeRun=="cCss"||$typeRun=="cJs"||$typeRun=="xml") {
            if($ardeaCore->getInitUseObject()!="N") {
                die();
            }
            if($typeRun=="xml") {
                echo $ardeaCore->getXMLFileScriptTmp();
                die();
            }
            if($typeRun=="cCss") {
                $fl_Name=$ardeaVar->getVar("fl","var_get",true);
                $ardeaTmpVar=&$ardeaCore->getCssFile();
                if(array_key_exists($fl_Name,$ardeaTmpVar))
                    $ardeaTmpVar[$fl_Name]->create();
                echo $ardeaCore->getCssFileScriptTmp();
                die();
            }
            if($typeRun=="cJs") {
                if($_VAR_FILE_=='ardeaBaseInit') {
                    //var_dump($_funcLoad);
                    $ardeaTmpVar=&$ardeaCore->getTooltip();
                    if($ardeaTmpVar!=null) {
                        $ardeaTmpVar->build();
                    }
                    $ardeaTmpVar=&$ardeaCore->getMenu();
                    if($ardeaTmpVar!=null) {
                        $ardeaTmpVar->build();
                    }
                    $allVar=$ardeaCore->getParentProperty("ardea_core_main");

                    if($allVar["background"]!=null)
                        $_funcLoad->addScript("document.body.style.backgroundColor='".$allVar["background"]."';");
                    if($allVar["background_image"]!=null)
                        $_funcLoad->addScript("document.body.style.backgroundImage='url(".$allVar["background_image"].")';");
                    if($ardeaCore->autoJsEventHandler) {
                        $_funcLoad->addScriptTmp("ardeaObject.init();");
                        $_funcLoad->addScriptTmp("ardeaInitObject();");
                    }
                }//else{
                //global $mvcReg;
                //echo $mvcReg->get("bug")."((OBJECT))";
                echo $ardeaCore->getJsFileScriptTmp();
                //}
                $fl_Name=$ardeaVar->getVar("fl","var_get",true);
                $ardeaTmpVar=&$ardeaCore->getJsFile();
                if(array_key_exists($fl_Name,$ardeaTmpVar)) {
                    $ardeaTmpVar[$fl_Name]->create();

                }

                die();
            }
        }
        //finishing
        //--init header
        if($_ARDEA_CONFIG["load_init_js"]) {
            if($_ARDEA_CONFIG["security_on"])
                $ardeaCore->createJsFile('ardeaBaseInit',true);
            else
                $ardeaCore->createJsFile('ardeaBaseInit');
        }
    }
    protected function finishingData(&$data) {
        global $_pdf;
        global $ardeaCore;

        $tmpStr="";
        $headResult="";
        $ardeaTmpVar=&$ardeaCore->getJs();
        //die(var_dump($ardeaTmpVar));

        $ardeaTmpVar->buildJs();
        $arrScriptName=$ardeaTmpVar->getScriptName();
        $arrScriptVer=$ardeaTmpVar->getVersion();
        $arrScriptVal=$ardeaTmpVar->getValue();
        $arrJsPath=$ardeaCore->getJsPath();
        $arrCssPath=$ardeaCore->getCssPath();

        foreach($arrJsPath as $key => $value) {
            $tmpStr.="<script language='javascript' src='$value'></script>\n";
        }
        $headResult.=$tmpStr;
        unset($arrJsPath);
        $tmpStr="";

        foreach($arrCssPath as $key => $value) {
            $tmpStr.="<link href='$value' rel='stylesheet' type='text/css' />\n";
        }
        $headResult.=$tmpStr;
        unset($arrCssPath);

        $ardeaTmpVar=$ardeaCore->getCss();
        $arrTmpA=$ardeaTmpVar->buildStyleForPrint();
        $tmpStr="";
        if($arrTmpA!="") {
            $tmpStr="<style media='print'>\n";
            $tmpStr.="$arrTmpA\n";
            $tmpStr.="</style>\n";
        }
        $headResult.=$tmpStr;
        $tmpStr="";
        $arrTmpA=$ardeaTmpVar->buildStyle();
        if($arrTmpA!="") {
            $tmpStr="<style>\n";
            $tmpStr.="$arrTmpA\n";
            $tmpStr.="</style>\n";
        }
        $headResult.=$tmpStr;

        foreach($arrScriptName as $key => $value) {
            $tmpStr=($arrScriptVer[$key]=="")?"":" ver='".$arrScriptVer[$key]."'";
            $tmpStr="<script language='".$arrScriptName[$key]."' ".$tmpStr.">\n";
            $tmpStr.=$arrScriptVal[$key];
            $tmpStr.="</script>\n";
        }
        $headResult.=$tmpStr;

        unset($arrScriptName);
        unset($arrScriptVer);
        unset($arrScriptVal);
        //$
        //$headResult
        $data = str_replace("<ext:page:header/>", $headResult, $data);
        $data = str_replace("<ext:page:event_on_body/>", $ardeaCore->buildProperty("eventBody"), $data);

        //init script
        $headResult="";
        $ardeaTmpVar=&$ardeaCore->getJs();
        $arrInitScriptJs=$ardeaTmpVar->getInitJs();
        $arrInitScriptVb=$ardeaTmpVar->getInitVbs();
        if($arrInitScriptJs) {
            foreach($arrInitScriptJs as $key => $value) {
                $tmpStr="<script language='javascript'>\n";
                $tmpStr.=$value."\n";
                $tmpStr.="</script>\n";
            }
        }
        $headResult.=$tmpStr;
        if($arrInitScriptVb) {
            foreach($arrInitScriptVb as $key => $value) {
                $tmpStr="<script language='vbscript'>\n";
                $tmpStr.=$value."\n";
                $tmpStr.="</script>\n";
            }
        }
        $headResult.=$tmpStr;

        unset($arrInitScriptJs);
        unset($arrInitScriptVb);

        $data = str_replace("<ext:ardeacore:init_script/>", $headResult, $data);
    }
    protected function runProcess(&$data) {
        global $ardeaCore;
        $regexString='#<ext:lib\ path="(.*)"\/>#iU';
        $result=$this->parseTemplate($data,$regexString);
        $arrResult=array();
        if($result) {
            foreach($result[1] as $key => $value ) {
                loadLib($value);
                $arrResult[$key]="<!--loading lib-->";
            }
            $data = str_replace($result[0], $arrResult, $data);
        }

        $regexString='#<ext:include\ (.*)>\s+(.[*,\s,\S]+)\s+<\/ext:include>#iU';
        $result=$this->parseTemplate($data,$regexString);
        //var_dump($result);
        $arrResult=array();
        if($result) {
            $i_y=0;
            foreach($result[1] as $key => $value ) {
                $att=$this->_generateAttribute($value);
                $this->procesRun($key,$att,$arrResult,$result[2][$i_y]);
                $i_y++;
            }
            //var_dump($arrResult);
            $data = str_replace($result[0], $arrResult, $data);
        }


        //var_dump($data);
        $regexString='#<ext:include\ (.*)\/>#iU';
        $result=$this->parseTemplate($data,$regexString);
        $arrResult=array();
        $i=0;
        if($result) {
            foreach($result[1] as $key => $value ) {
                $att=$this->_generateAttribute($value);
                $this->procesRun($key,$att,$arrResult,$result[1][$i]);
                $i++;
            }
            //var_dump($arrResult);
            $data = str_replace($result[0], $arrResult, $data);
        }

        //var_dump($data);
        $regexString='#<ext:var\ (.*)\/>#iU';
        $result=$this->parseTemplate($data,$regexString);
        $arrResult=array();
        $i=0;
        if($result) {
            foreach($result[1] as $key => $value ) {
                $att=$this->_generateAttribute($value);
                $this->procesRun($key,$att,$arrResult,$result[1][$i]);
                $i++;
            }
            //var_dump($arrResult);
            $data = str_replace($result[0], $arrResult, $data);
        }


    }
    protected function subProcesRun(&$data,&$ardeaObject,&$result) {
        $this->stateForObject=true;
        $arrResult=array();
        $i=0;
        if($result) {
            //die(var_dump($result));
            foreach($result[1] as $key => $value ) {
                $att=$this->_generateAttribute($value);
                $this->procesRun($key,$att,$arrResult,$result[1][$i],$ardeaObject);
                $i++;
            }
            //var_dump($arrResult);
            $data = str_replace($result[0], $arrResult, $data);
        }
        $this->stateForObject=false;
    }

    protected function procesRun($key,$att,&$arrResult,$innerTag="",&$ardeaObject=null) {
        if(!array_key_exists("type",$att)) {
            $arrResult[$key]="<!--ERROR TYPE ATTRIBUTE NOT EXISTS-->";
            return false;
        }
        switch (strtolower($att["type"])) {
            case 'model':
            //die(var_dump($att)."MASUK");
                $objResult=&$this->router->getModel($att["name"]);
                //die(var_dump($objResult).$att["name"]."MASUK");
                if(!$objResult) {
                    $arrResult[$key]="<!--ERROR MODEL COMMAND NOT FOUND-->";
                }else {
                    if($att["command"]!="") {
                        if($this->stateForObject) {
                            if(isArdeaObject($ardeaObject)) {
                                $ardeaObject->addContain($this->router->runCommand($objResult,$att["command"]));
                            }
                            $arrResult[$key]="";
                        }else {
                            $arrResult[$key]=$this->router->runCommand($objResult,$att["command"]);
                        }
                    }else {
                        $arrResult[$key]="<!--ERROR MODEL COMMAND NOT FOUND-->";
                    }
                }
                break;
            case 'route':
                global $mvcReg;
                if(strtolower($att["name"])=="_var"||strtolower($att["name"])=="auto") {
                    $requestRoute=$mvcReg->get($mvcReg->get("default"));
                    if($requestRoute=="")
                        $att["name"]="first";
                    else
                        $att["name"]=$requestRoute;
                }

                $cls=&$this->router->doRoute($att["name"]);
                //global $ardeaCore;
                //echo"a:";
                //echo $att["name"];//." ".$ardeaCore->getTypeRun();
                if(!$cls) {
                    $arrResult[$key]="<!--ERROR ROUTE PAGE NOT FOUND-->";
                }else {
                    $arrResult[$key]=$cls->getData();
                }

                break;
            case "registry":
                if($att["name"]=="") {
                    $arrResult[$key]="<!--ERROR NAME OF VAR ATTRIBUTE NOT EXISTS-->";
                    return;
                }
                global $mvcReg;
                $arrResult[$key]=$mvcReg->get($att["name"]);
                break;
            case "global":
                if($att["name"]=="") {
                    $arrResult[$key]="<!--ERROR NAME OF VAR ATTRIBUTE NOT EXISTS-->";
                    return;
                }
                $varName=$att["name"];
                eval("global \$".$varName.";");
                $arrResult[$key]=eval("return  \$".$varName.";");
                break;
            case 'view':

                $objResult=&$this->router->getView($att["name"]);
                if(!$objResult) {
                    $arrResult[$key]="<!--ERROR VIEW NOT FOUND-->";
                }else {

                    if($att['model']!="") {

                        if(strpos($att['model'],",")>-1) {

                            $arr=explode(',',$value);
                            foreach($arr as $key_1 => $value) {
                                $tmpModel=&$this->router->getModel($value);
                                $objResult->setModel($tmpModel,$value);
                            }
                        }else {
                            //die($att['model']);
                            $tmpModel=&$this->router->getModel($att['model']);
                            $objResult->setModel($this->router->getModel($att['model']),$att['model']);
                        }
                    }
                    if($this->stateForObject) {
                        if(isArdeaObject($ardeaObject)) {
                            $ardeaObject->addContain($objResult->display());
                        }
                        $arrResult[$key]="";
                    }else {
                        $arrResult[$key]=$objResult->display();
                    }

                }

                break;
            case 'object':
                if($att['objecttype']!="") {
                    $attObject=$this->getAttObject($att);
                    //var_dump($attObject);
                    $obj=new $att['objecttype']($attObject);
                    if($innerTag!="") {
                        //function
                        //var_dump("AA".$innerTag);
                        //var_dump($att);
                        $regexString='#<function\ name="(.*)" (.*)\/>#iU';
                        $result=$this->parseTemplate($innerTag,$regexString);
                        //var_dump($result);
                        $arrResultB=array();
                        $i_x=0;
                        if($result) {
                            foreach($result[2] as $key => $value ) {
                                //var_dump($result[1]);
                                $att=$this->_generateAttribute($value);
                                ///echo("MASUK".var_dump($att).":".$result[1][$key].":");
                                //echo $value;

                                $arg=$this->getAttFuncObject($att);
                                //var_dump($arg);
                                //echo ":".$value;
                                call_user_method_array($result[1][$i_x],$obj,$arg);
                                $i_x++;
                                $arrResultB[]="";
                            }
                            $innerTag = str_replace($result[0], $arrResultB, $innerTag);
                        }

                        //property
                        $regexString='#<property\ (.*)\/>#iU';
                        $result=$this->parseTemplate($innerTag,$regexString);
                        $arrResultB=array();
                        $i_x=0;
                        if($result) {
                            foreach($result[1] as $key => $value ) {
                                $att=$this->_generateAttribute($value);
                                $arg=$this->getAttPropObject($att);
                                call_user_method_array("setProperty",$obj,$arg);
                                $i_x++;
                                $arrResultB[]="";
                            }
                            $innerTag = str_replace($result[0], $arrResultB, $innerTag);
                        }
                        //if inner lib
                        //$regexString='#<ext:lib\ path="(.*)"\/>#iU';

                        //die(var_dump(trim($innerTag)));
                        $innerTag=trim($innerTag);
                        $regexString='#<ext:include\ (.*)\/>#iU';
                        $result=$this->parseTemplate($innerTag,$regexString);
                        if($result) {
                            //die(var_dump($obj));
                            $this->subProcesRun(&$innerTag, &$obj,&$result);
                            //var_dump($innerTag);
                        }

                        if($this->stateForObject) {
                            //die(var_dump($ardeaObject));
                            if(isArdeaObject($ardeaObject)) {
                                if(array_key_exists("nobr",$att)) {
                                    if($att["nobr"]=="false") {
                                        $ardeaObject->addObject($obj);
                                    }else {
                                        $ardeaObject->addObject($obj,true);
                                    }
                                }else {
                                    $ardeaObject->addObject($obj,true);
                                }
                            }
                            $arrResult[$key]="";
                            //var_dump($arrResult);
                            //echo $key;
                        }else {
                            $obj->build();
                            $arrResult[$key]=$obj->getHTML();
                        }

                    }
                }else {
                    $arrResult[$key]="<!--Object Not Found-->";
                }

                break;
            case 'widget':
                if($att['objecttype']!="") {
                    $myWidget=loadWidget($att['objecttype']);
                    $myWidget->pack();
                    $arrResult[$key]=$myWidget->getHTML();
                }else {
                    $arrResult[$key]="<!--widget Not Found-->";
                }
                break;
            case 'lib':
                if($att['lib']!="") {
                    loadlib($att['lib']);
                    $arrResult[$key]="<!--loading lib-->";
                }
                break;
            case 'head':
                break;
            case 'body':
                break;
        }
    }
    function getAttPropObject($arr) {
        $arrTmp=array();
        $arrTmp[]=$arr["name"];
        if(array_key_exists("value",$arr)) {
            $arrTmp[]=$arr["value"];
        }
        if(array_key_exists("parent",$arr)) {
            $arrTmp[]=$arr["parent"];
        }
        return $arrTmp;
    }
    function getAttFuncObject($arr) {
        $arrTmp=array();
        //var_dump($arr);

        if(array_key_exists("arg",$arr)) {
            foreach($arr["arg"] as $key => $value) {
                $arrTmp[]=$value;
            }
        }
        //var_dump($arrTmp);
        return $arrTmp;
    }
    function getAttObject($arr,$except="objecttype") {
        $arrTmp=array();
        foreach($arr as $key => $value) {
            if($except!=$key && strtolower($key)!="type" && strtolower($key)!="nobr") {
                //$key
                $arrTmp[]=$key."=".$value;
            }
        }
        return $arrTmp;
    }

}
?>