<?php
/*======================================================
 * %%%%%%%%%%%%%PHPArdea CORE 2.0%%%%%%%%%%%%%%%%%%%%%%%
 * =====================================================
 * Author  : Maulana Al Matien.
 * Email   : ardea.core.php@gmail.com
 * Name    : 
 * Date    : 
 * Used for:
 * ======================================================
 * Copyright Ardea Workshop. http://ardea-workshop.co.cc/ardeaCore.php
 * You allowed to use this component or parts of it under LGPLv3 terms
 * To use it on other terms or get Professional edition of the component 
 * please contact us at ardea.core.php@gmail.com
*/
/**
 * @version		2.0
 * @package		object.core
 * @subpackage	application
 * @author	Maulana al matien
 * @copyright Ardea-Workshop/Maulana Al Matien (2008-2009). All rights reserved.
 * @license http://www.gnu.org/licenses/lgpl-3.0.txt GNU Lesser General Public License (LGPLv3)
 */
loadLib("lib.core.ardeaObject");
loadLib("object.core.application.ardeaApplicationLib");
loadLib("lib.core.template.ardeaTemplate");
//if(!defined(USE_MVC)){
//    define("USE_MVC",true);
//}
global $mvcReg;
$mvcReg->set("app_path_themes:default","themes/");
$mvcReg->set("app_path_view:default","views/");
$mvcReg->set("app_path_model:default","models/");
$mvcReg->set("app_path_controller:default","controllers/");
$mvcReg->set("app_path_public:default","www/");
$mvcReg->set("app_path_mvc:default","mvc/");
class application extends objectObject {
    protected $tmpl="";
    protected $app_template_write=true;
    function __construct() {
        //$this->defContructApplication();
        global $mvcReg;
        parent::__construct();
        $this->name=get_class($this);
        $this->tmpl=new template;
        $this->tmpl->setUseController();
        $this->tmpl->setAppName($this->name);
        //if(defined(APPLICATION_PATH))
        //  $this->setApplicationPath(APPLICATION_PATH);
        $mvcReg->set("app_path_themes:".$this->name,$mvcReg->get("app_path_themes:default"));
        $mvcReg->set("app_path_mvc:".$this->name,$mvcReg->get("app_path_mvc:default"));
        $mvcReg->set("app_path_view:".$this->name,$mvcReg->get("app_path_view:default"));
        $mvcReg->set("app_path_model:".$this->name,$mvcReg->get("app_path_model:default"));
        $mvcReg->set("app_path_controller:".$this->name,$mvcReg->get("app_path_controller:default"));
        $mvcReg->set("app_path_public:".$this->name,$mvcReg->get("app_path_public:default"));
        $mvcReg->set("app_name:".$this->name,$this->name);
        $mvcReg->set("app_tmpl_folder:".$this->name,$this->name);
        //echo "MASUK";
    }
    function setApplicationPath($newPath) {
        global $mvcReg;
        $mvcReg->set("app_path:".$this->name,fixRealPath($newPath));
        $this->tmpl->setMVCPath(fixRealPath($newPath).$mvcReg->get("app_path_mvc:default"));
        $this->tmpl->setPath(fixRealPath($newPath).$mvcReg->get("app_path_themes:default"));
    }

    function getCurrentPath() {
        global $mvcReg;
        return $mvcReg->get("app_path:".$this->name);
    }
    function getAppName() {
        return $this->name;
    }
    function setAppName($newAppName) {
        $this->name=$newAppName;
    }
    function setTitlePage($newTitlePage) {
        global $ardeaCore;
        $ardeaCore->setTitlePage($newTitlePage);
    }
    function setTemplateNoWrite() {
        $this->app_template_write=false;
    }
    function setFolderThemes($folderName) {
        global $mvcReg;
        $mvcReg->set("app_path_themes:".$this->name,$folderName."/");
    }
    function setFolderMVC($folderName) {
        global $mvcReg;
        $mvcReg->set("app_path_mvc:".$this->name,$folderName."/");
    }
    function setMVCfolderName($newFolderName) {
        $this->tmpl->setUseMVC($mvcReg->get("app_path:".$appName).$newFolderName);
    }
    function setThemesfolderName($newFolderName) {
        $this->tmpl->setPath($mvcReg->get("app_path:".$appName).$newFolderName);
    }
    public static function getAdminPath($appName) {
        global $mvcReg;
        return $mvcReg->get("app_path:".$appName)."admin/";
    }
    public static function getPath($appName) {
        global $mvcReg;
        return $mvcReg->get("app_path:".$appName);
    }
    public static function publicPath($appName=null) {
        global $mvcReg;
        global $ardeaCoreinitVar;
        if($appName!=null)
            return ARDEA_CORE_DOMAIN.$ardeaCoreinitVar["public"]."application/".$mvcReg->get("app_name:".$appName)."/";
        else
            return ARDEA_CORE_DOMAIN.$ardeaCoreinitVar["public"];
    }
    public static function localPublicPath($appName) {
        global $mvcReg;
        return application::loadingPath(false).$mvcReg->get("app_path_public:".$appName);
    }
    public static function appThemePath($appName) {
        global $mvcReg;
        return $mvcReg->get("app_path:".$appName).$mvcReg->get("app_path_themes:".$appName).$mvcReg->get("app_name:".$appName)."/";
    }
    public static function appPath($appName) {
        global $mvcReg;
        //return ARDEA_CORE_DOMAIN.$_SERVER['PHP_SELF'];
        return $mvcReg->get("app_path:".$appName).$mvcReg->get("app_path_themes:".$appName).$mvcReg->get("app_name:".$appName)."/";
    }
    public static function loadingPath($withFile=true) {
        global $mvcReg;
        if($withFile)
            return "http://".$_SERVER['HTTP_HOST'].$_SERVER['PHP_SELF'];
        else {
            $url="http://".$_SERVER['HTTP_HOST'].$_SERVER['PHP_SELF'];
            $url=substr($url,0,strrpos($url,"/"));
            return $url."/";
        }
        //return $mvcReg->get("app_path:".$appName).$mvcReg->get("app_path_themes:".$appName).$mvcReg->get("app_name:".$appName)."/";
    }
    public static function appMVCPath($appName) {
        global $mvcReg;
        return $mvcReg->get("app_path:".$appName).$mvcReg->get("app_path_mvc:".$appName)."/";
    }
    public static function urlPath($appName,$folder=null) {
        global $mvcReg;
        if($folder==null)
            return ardeaURL::URL("folder").$mvcReg->get("app_path_themes:".$appName).$mvcReg->get("app_tmpl_folder:".$appName)."/";
        else {
            return ardeaURL::URL("folder").$folder."/".$mvcReg->get("app_path_themes:".$appName).$mvcReg->get("app_tmpl_folder:".$appName)."/";
        }
    }
    function loadAdmin() {
        global $ardeaSession;
        if($ardeaSession->loginValid) {

        }
    }
    function setThemes($newThemesName) {
        global $mvcReg;
        $mvcReg->set($mvcReg->get("default_themes"),$newThemesName);
    }
    function setThemesName($newThemesName) {
        global $mvcReg;
        $mvcReg->set($mvcReg->get("default_themes"),$newThemesName);
    }
    function run() {

        global $mvcReg;
        if($mvcReg->get("app_path:".$this->name)=="")
            die("application path not set");

        if(method_exists($this,"runExtendedBefore"))
            $this->runExtendedBefore();
        //die(var_dump($this->tmpl));

        $this->tmpl->run($this->app_template_write);
        //if(get_class($this)=="admin")
        //  die();
        if(method_exists($this,"runExtendedAfter"))
            $this->runExtendedAfter();
    }

} 
?>
