<?php
/*======================================================
 * %%%%%%%%%%%%%PHPArdea CORE 2.0%%%%%%%%%%%%%%%%%%%%%%%
 * =====================================================
 * Author  : Maulana Al Matien.
 * Email   : ardea.core.php@gmail.com
 * Name    : 
 * Date    : 
 * Used for:
 * ======================================================
 * Copyright Ardea Workshop. http://ardea-workshop.co.cc/ardeaCore.php
 * You allowed to use this component or parts of it under LGPLv3 terms
 * To use it on other terms or get Professional edition of the component 
 * please contact us at ardea.core.php@gmail.com
*/
/**
 * @version		2.0
 * @package		object.core
 * @subpackage	application
 * @author	Maulana al matien
 * @copyright Ardea-Workshop/Maulana Al Matien (2008-2009). All rights reserved.
 * @license http://www.gnu.org/licenses/lgpl-3.0.txt GNU Lesser General Public License (LGPLv3)
 */
loadLib("lib.core.ardeaObject");
loadLib("object.core.application.ardeaApplicationLib");
loadLib("lib.core.template.ardeaTemplate");
loadLib("lib.core.template.ardeaWindowForm");
//if(!defined(USE_MVC)){
//    define("USE_MVC",true);
//}
global $mvcReg;
$mvcReg->set("default_form","frm");
$mvcReg->set("app_window_path_themes:default","themes/");
$mvcReg->set("app_window_path_www:default","www/");
$mvcReg->set("app_window_path_script:default","scripts/");
$mvcReg->set("app_window_path_module:default","modules/");
$mvcReg->set("app_window_path_form:default","forms/");
$mvcReg->set("app_window_path_mvc:default","mvc/");
class windowApplication extends objectObject {
    protected $tmpl="";
    protected $useTemplate=false;
    protected $app_template_write=true;
    protected $windowForm=null;
    function __construct() {
        //$this->defContructApplication();
        global $mvcReg;
        global $ardeaCore;
        parent::__construct();
        $this->name=get_class($this);
        $this->tmpl=new template;
        $this->tmpl->setUseController();
        $this->tmpl->setAppName($this->name);
        $this->windowForm=new windowForm;
        $this->setNoUsedBuild();
        //if(defined(APPLICATION_PATH))
        //  $this->setApplicationPath(APPLICATION_PATH);
        $mvcReg->set("app_window_path_themes:".$this->name,$mvcReg->get("app_window_path_themes:default"));
        $mvcReg->set("app_window_path_script:".$this->name,$mvcReg->get("app_window_path_script:default"));
        $mvcReg->set("app_window_path_module:".$this->name,$mvcReg->get("app_window_path_module:default"));
        $mvcReg->set("app_window_path_form:".$this->name,$mvcReg->get("app_window_path_form:default"));
        $mvcReg->set("app_window_path_www:".$this->name,$mvcReg->get("app_window_path_www:default"));
        $mvcReg->set("app_window_path_mvc:".$this->name,$mvcReg->get("app_window_path_mvc:default"));
        $mvcReg->set("default_form:".$this->name,$mvcReg->get("default_form"));
        $mvcReg->set("app_name:".$this->name,$this->name);
        $mvcReg->set("app_tmpl_folder:".$this->name,$this->name);
        $ardeaCore->addJsPath($ardeaCore->getURLJS('windowApplicationLib.js'));
        $ardeaCore->addJsPath($ardeaCore->getURLJS('ardeaTimer.js'));
        //echo "MASUK";
    }
    function setApplicationPath($newPath) {
        global $mvcReg;
        $mvcReg->set("app_window_path:".$this->name,fixRealPath($newPath));
        $this->tmpl->setPath(fixRealPath($newPath).$mvcReg->get("app_window_path_themes:default"));
        $this->tmpl->setMVCPath(fixRealPath($newPath).$mvcReg->get("app_window_path_mvc:default"));
        $this->windowForm->setAppName($this->name,$newPath);
    }

    function getCurrentPath() {
        global $mvcReg;
        return $mvcReg->get("app_window_path:".$this->name);
    }
    function getAppName() {
        return $this->name;
    }
    function setAppName($newAppName) {
        $this->name=$newAppName;
    }
    function setTemplateNoWrite() {
        $this->app_template_write=false;
    }
    function setFolderThemes($folderName) {
        global $mvcReg;
        $mvcReg->set("app_window_path_themes:".$this->name,$folderName."/");
    }
    function setTitlePage($newTitlePage) {
        global $ardeaCore;
        $ardeaCore->setTitlePage($newTitlePage);
    }
    function setWindowThemes($newThemes) {
        $this->windowForm->setWindowThemes($newThemes);
    }
    function setFolderScripts($folderName) {
        global $mvcReg;
        $mvcReg->set("app_window_path_script:".$this->name,$folderName."/");
    }
    function setFolderModules($folderName) {
        global $mvcReg;
        $mvcReg->set("app_window_path_module:".$this->name,$folderName."/");
    }
    function setFolderForms($folderName) {
        global $mvcReg;
        $mvcReg->set("app_window_path_form:".$this->name,$folderName."/");
    }
    function setFolderwww($folderName) {
        global $mvcReg;
        $mvcReg->set("app_window_path_www:".$this->name,$folderName."/");
    }
    function setMVCfolderName($newFolderName) {
        $this->tmpl->setUseMVC($mvcReg->get("app_window_path:".$appName).$newFolderName);
    }
    function setThemesfolderName($newFolderName) {
        $this->tmpl->setPath($mvcReg->get("app_window_path:".$appName).$newFolderName);
    }
    public static function getAdminPath($appName) {
        global $mvcReg;
        return $mvcReg->get("app_window_path:".$appName)."admin/";
    }
    public static function getPath($appName) {
        global $mvcReg;
        return $mvcReg->get("app_window_path:".$appName);
    }
    public static function publicPath($appName=null) {
        global $mvcReg;
        global $ardeaCoreinitVar;
        if($appName!=null)
            return ARDEA_CORE_DOMAIN.$ardeaCoreinitVar["public"]."application/".$mvcReg->get("app_name:".$appName)."/";
        else
            return ARDEA_CORE_DOMAIN.$ardeaCoreinitVar["public"];
    }
    public static function localPublicPath($appName) {
        global $mvcReg;
        return windowApplication::loadingPath(false).$mvcReg->get("app_window_path_www:".$appName);
    }
    public static function appThemePath($appName) {
        global $mvcReg;
        return $mvcReg->get("app_window_path:".$appName).$mvcReg->get("app_window_path_themes:".$appName).$mvcReg->get("app_name:".$appName)."/";
    }
    public static function appPath($appName) {
        global $mvcReg;
        //return ARDEA_CORE_DOMAIN.$_SERVER['PHP_SELF'];
        return $mvcReg->get("app_window_path:".$appName).$mvcReg->get("app_window_path_themes:".$appName).$mvcReg->get("app_name:".$appName)."/";
    }
    public static function loadingPath($withFile=true) {
        global $mvcReg;
        if($withFile)
            return "http://".$_SERVER['HTTP_HOST'].$_SERVER['PHP_SELF'];
        else {
            $url="http://".$_SERVER['HTTP_HOST'].$_SERVER['PHP_SELF'];
            $url=substr($url,0,strrpos($url,"/"));
            return $url."/";
        }
        //return $mvcReg->get("app_window_path:".$appName).$mvcReg->get("app_window_path_themes:".$appName).$mvcReg->get("app_name:".$appName)."/";
    }
    public static function appMVCPath($appName) {
        global $mvcReg;
        return $mvcReg->get("app_window_path:".$appName).$mvcReg->get("app_window_path_mvc:".$appName)."/";
    }
    public static function urlPath($appName,$folder=null) {
        global $mvcReg;
        if($folder==null)
            return ardeaURL::URL("folder").$mvcReg->get("app_window_path_themes:".$appName).$mvcReg->get("app_tmpl_folder:".$appName)."/";
        else {
            return ardeaURL::URL("folder").$folder."/".$mvcReg->get("app_window_path_themes:".$appName).$mvcReg->get("app_tmpl_folder:".$appName)."/";
        }
    }
    function loadAdmin() {
        global $ardeaSession;
        if($ardeaSession->loginValid) {

        }
    }
    function setThemes($newThemesName) {
        global $mvcReg;
        $mvcReg->set($mvcReg->get("default_themes"),$newThemesName);
    }
    function setThemesName($newThemesName) {
        global $mvcReg;
        $mvcReg->set($mvcReg->get("default_themes"),$newThemesName);
    }
    function buildJs() {
        global $_VAR_FILE_;
        global $_initJs;
        global $mvcReg;
        if($_VAR_FILE_=='ardeaBaseInit') {
            $_initJs->addScript("var URL4AJAXRUNNER=\"".windowApplication::loadingPath()."\"");
            $_initJs->addScript("aCodeFrm=\"".$mvcReg->get("default_form:".$this->name)."\"");
            $_initJs->addScript("windowApplicationInit()");
            $_initJs->addScript("ardeaObject.init()");
        }
    }

    function run() {
        global $mvcReg;
        global $ardeaCore;
        $this->build();

        $type=$ardeaCore->getTypeRun();


        if(method_exists($this,"runExtendedBefore"))
            $this->runExtendedBefore();
        if(!$this->windowForm->ajax->isRequest()) {

            if($mvcReg->get("app_window_path:".$this->name)=="")
                die("application path not set");
            //$this->tmpl->noUseGetData()			$this->tmpl->noUseRouterPage();
            //$this->tmpl->noUseFinishingData();
            if(($type=="cJs"||$type=="cCss")&&$_GET[$mvcReg->get("default_form:".$this->name)]!="") {
                $this->windowForm->loadForm($_GET[$mvcReg->get("default_form:".$this->name)],&$this->tmpl);
                return;
            }
            $this->tmpl->setBreakBeforeWrite();
            $this->tmpl->run(false);
            if($type=="default"||$type=="")
                echo $this->tmpl->getData();


        }else {

            $request=$this->windowForm->ajax->getRequest();
            $request=get_object_vars($request);
            //var_dump($request[$mvcReg->get("default_form:".$this->name)]);
            if($request[$mvcReg->get("default_form:".$this->name)]!="") {
                $this->windowForm->loadForm($request[$mvcReg->get("default_form:".$this->name)],&$this->tmpl);
            }
        }

        if(method_exists($this,"runExtendedAfter"))
            $this->runExtendedAfter();


    }

} 
?>
