<?php
/**
 * @version		2.0
 * @package		object
 * @subpackage	core
 * @author	Maulana al matien
 * @copyright Ardea-Workshop/Maulana Al Matien (2008-2009). All rights reserved.
 * @license http://www.gnu.org/licenses/lgpl-3.0.txt GNU Lesser General Public License (LGPLv3)
 */
loadLib("lib.plugin.JSON.JSON");    
class tableDynamic extends objectObject {
    private $SQLSTR="ARDEA_CORE_NONE";
    private $dataArray="";
    private $showHeader=false;
    private $header=array();
    private $headerColor="#444";
    private $headerClassName="";
    private $useSorter=false;
    function  tableDynamic($id) {
        global $ardeaCore;
        $this->name=fixVarNameJS($id);
        $this->initOnly();
        $this->property->property["ardea_td_property"]=array();
        $this->property->property["ardea_td_property"]["color1"]="#E5E5E5";
        $this->property->property["ardea_td_property"]["color2"]="#D5D5D5";
        $this->property->property["ardea_td_property"]["mouseOver"]="#F4D174";
        $this->property->property["ardea_td_property"]["onclick"]="null";
        $this->property->property["ardea_td_property"]["tableOnclick"]="null";
        $this->property->property["ardea_td_property"]["formOuterFunction"]="null";
        $this->property->property["ardea_td_property"]["parentOuterName"]="null";
        $this->property->property["ardea_td_property"]["colsCount"]=2;
        $this->property->property["ardea_td_property"]["data"]="null";
        $this->property->property["ardea_td_property"]["attribute"]="null";
        $ardeaCore->addJSPath($ardeaCore->getURLJS('json.js'));
        $ardeaCore->addJSPath($ardeaCore->getURLJS('ardeaTableDynamic.js'));
        $ardeaCore->addJSPath($ardeaCore->getURLJS('table_tbDin.js'));
        $this->property->property["ardea_td_property"]["homebase"]="null";
        $this->property->property["ardea_td_property"]["themes"]="default";
        $this->setNoBuildProperty();
    }
    function setHomeBase($ardeaObjectId) {
        $this->property->property["ardea_td_property"]["homebase"]=$ardeaObjectId;
    }
    function setUseSorter() {
        $this->useSorter=true;
    }
    function setColor($color1,$color2,$mouseOverColor="#F4D174") {
        $this->property->property["ardea_td_property"]["color1"]=$color1;
        $this->property->property["ardea_td_property"]["color2"]=$color2;
        $this->property->property["ardea_td_property"]["mouseOver"]=$mouseOverColor;
    }
    function showHeader($headerArray=null) {
        $this->showHeader=true;
        if(is_array($headerArray)) {
            $this->header=$headerArray;
        }
    }
    function setThemesName($newThemesName) {
        $this->property->property["ardea_td_property"]["themes"]=$newThemesName;
    }
    function setHeaderClassName($headerClassName) {
        $this->headerClassName=$headerClassName;
    }
    function setHeader($headerArray) {
        $this->header=$headerArray;
    }
    function setFunctionOnclick($jsFunction) {
        $this->property->property["ardea_td_property"]["onclick"]=$jsFunction;
    }
    function setFunctionTableOnclick($jsFunction) {
        $this->property->property["ardea_td_property"]["tableOnclick"]=$jsFunction;
    }
    function setFormOuterFunction($jsFunction) {
        $this->property->property["ardea_td_property"]["formOuterFunction"]=$jsFunction;
    }
    function setParentOuterName($parentId) {
        $this->property->property["ardea_td_property"]["parentOuterName"]=$parentId;
    }
    function setColumnCount($newColumnCount) {
        $this->property->property["ardea_td_property"]["colsCount"]=$newColumnCount;
    }
    function setData($dataArray) {
        $this->dataArray=$dataArray;
    }
    function addData($dataArray,$position='after') {
        if($position=='after') {
            $this->dataArray=array_merge($this->dataArray,$dataArray);
        }else {
            $this->dataArray=array_merge($dataArray,$this->dataArray);
        }
    }
    private function loadCss() {
        global $ardeaCore;
        switch($this->property->property["ardea_td_property"]["themes"]) {
            case "default":
                $ardeaCore->addCssPath($ardeaCore->getURLCSS('sorter/default.css'));
                break;
        }
    }
    protected function buildObject() {
        $this->loadCss();
    }
    function buildData() {
        $JSON=new JSON();
        $this->property->property["ardea_td_property"]["data"]=$JSON->encode($this->dataArray);
    }

    protected  function toJsObject($opt,$arg) {
        switch(strtolower($opt)) {
            case "movedata":
                if(count($arg)==3)
                    return $this->name."moveData(".$arg[1].",".$arg[2].")";
                else
                    return "";
                break;
            case "keyMove":
                if(count($arg)==2)
                    return $this->name."keyMove(".$arg[1].")";
                else
                    return "";
                break;
        }
    }

    function setSQL($sqlString) {
        $this->SQLSTR=$sqlString;
    }

    protected  function buildJs() {
        global $_VAR_FILE_;
        if($_VAR_FILE_=="ardeaBaseInit") {
            global $_funcLoad;
            global $ardeaCore;
            global $_initJs;

            if($this->SQLSTR!="ARDEA_CORE_NONE") {
                $rs=$ardeaCore->executeSQL($this->SQLSTR,2);
                $this->setData($rs->toArray());
                if($this->showHeader) {
                    if(is_array($this->header)) {
                        $tmp=$rs->getFieldSet();
                        if(count($tmp)>count($this->header)) {
                            for($i=count($this->header);$i<count($tmp);$i++) {
                                $this->header[$i]=$tmp[$i];
                            }
                            $this->addData(array($this->header),'before');
                        }else if(count($tmp)<count($this->header)) {
                            $tmp=array();
                            for($i=count($this->header);$i<count($tmp);$i++) {
                                $tmp[i]=$this->header[$i];
                            }
                            $this->addData(array($tmp),'before');
                        }else {
                            $this->addData(array($this->header),'before');
                        }
                    }else {
                        $this->addData(array($rs->getFieldSet()),'before');
                    }
                }
                $this->property->property["ardea_td_property"]['colsCount']=$rs->fieldsCount();
            }else {

            }

            $this->buildData();
            $allVar=$this->property->property["ardea_td_property"];
            $id=$this->name;
            $_funcLoad->addScript("var td_".$this->name."=new tableDynamic(\"".$this->name."\",".$allVar['colsCount'].")");
            if($this->useSorter) {
                $_funcLoad->addScript("td_".$this->name.".useSorter=true;");
                $_funcLoad->addScript("td_".$this->name.".className='".$this->property->property["ardea_td_property"]["themes"]."';");
            }
            $_funcLoad->addScript("td_".$this->name.".colorRow1=\"".$allVar["color1"]."\";");
            $_funcLoad->addScript("td_".$this->name.".colorRow2=\"".$allVar["color2"]."\";");
            $_funcLoad->addScript("td_".$this->name.".mouseOverColor=\"".$allVar["mouseOver"]."\";");
            if($allVar["onclick"]!="null")
                $_funcLoad->addScript("td_".$this->name.".onclick=".$allVar["onclick"].";");
            $_funcLoad->addScript("td_".$this->name.".tableOnclick=".$allVar["tableOnclick"].";");
            $_funcLoad->addScript("td_".$this->name.".fromOuterFunction=".$allVar["formOuterFunction"].";");
            $_funcLoad->addScript("td_".$this->name.".parentOuterName=\"".$allVar["parentOuterName"]."\";");
            if($this->showHeader) {
                $_funcLoad->addScript("td_".$this->name.".showHeaderFormat=true;");
                $_funcLoad->addScript("td_".$this->name.".headerColor=\"".$this->headerColor."\";");
                $_funcLoad->addScript("td_".$this->name.".headerClass=\"".$this->headerClassName."\";");

            }
            $att=$this->getAttribute();
            if($att)
                $_funcLoad->addScript("set_attribute(td_".$this->name.".home,".$att.")");
            if($allVar["homebase"]=="null")
                $_funcLoad->addScript("td_".$this->name.".init()");
            else
                $_funcLoad->addScript("td_".$this->name.".init('".$allVar["homebase"]."');");

            if($allVar["data"]!="null")
                $_funcLoad->addScript("td_".$this->name.".setDataFromJSON('".$allVar["data"]."');");
            if($this->useSorter) {
                $_initJs->addScript("var sorter_".$id."=''");
                $_funcLoad->addScript("sorter_".$id."=new tableSorter.sorter('".$id."')");
                $_funcLoad->addScript("sorter_".$id.".setObjTbDin(td_".$id.")");
                $_funcLoad->addScript("sorter_".$id.".init('".$id."',1)");
            }
        }

    }
    protected function buildCss() {
        if($this->isHaveCss()) {
            $this->smarty->assign("color1",$this->themes['color1']);
            $this->smarty->assign("color2",$this->themes['color2']);
            $this->smarty->assign("bgHead",$this->themes['bgHeader_src']);
            $this->smarty->assign("bgHeadWidth",$this->themes['bgHeader_width']);
            $this->smarty->assign("bgDsc",$this->themes['bgDsc_src']);
            $this->smarty->assign("bgDscWidth",$this->themes['bgDsc_width']);
            $this->smarty->assign("bgAsc",$this->themes['bgAsc_src']);
            $this->smarty->assign("bgAscWidth",$this->themes['bgAsc_width']);
            $this->smarty->assign("colorOver",$this->themes['colorOver']);
            $this->smarty->setTemplateDirectoryToCore("table");
            echo fixTplJsOrCss($this->smarty->fetch("tablecss.tpl"));
        }
    }
}
?>