<?php
/*======================================================
 * %%%%%%%%%%%%%PHPArdea CORE 2.0%%%%%%%%%%%%%%%%%%%%%%%
 * =====================================================
 * Author  : Maulana Al Matien.
 * Email   : ardea.core.php@gmail.com
 * Name    :
 * Date    :
 * Used for:
 * ======================================================
 * Copyright Ardea Workshop. http://ardea-workshop.co.cc/ardeaCore.php
 * You allowed to use this component or parts of it under LGPLv3 terms
 * To use it on other terms or get Professional edition of the component
 * please contact us at ardea.core.php@gmail.com
*/
/**
 * @version		2.0
 * @package		object
 * @subpackage	core
 * @author	Maulana al matien
 * @copyright Ardea-Workshop/Maulana Al Matien (2008-2009). All rights reserved.
 * @license http://www.gnu.org/licenses/lgpl-3.0.txt GNU Lesser General Public License (LGPLv3)
 */
class _window extends objectObject {
    protected $themes='xp';
    protected $width=200;
    protected $height=200;
    protected $title="";
    protected $contain="";
    protected $scriptJS="";
    protected $on_show_url="";
    protected $on_show_use_json=true;
    //protected $url="";
    public $maxButton=true;
    public $minButton=true;
    public $closeButton=true;
    public $titleBar=true;
    public $visible=true;
    protected $getChildJsPath=false;
    protected $getChildCssPath=false;
    protected $menu=null;
    protected $scriptTmp=array();
    protected $useAutoEventObject=false;
    function _window($name,$title="",$themes="xp",$width="",$height="") {
        global $ardeaCore;
        $this->initOnly();
        $this->setNoBuildProperty();
        $this->setNoUsedBuild();
        if($name!="")
            $this->name=$name;
        if($width!="")
            $this->width=$width;
        if($height!="")
            $this->height=$height;
        if($themes!="")
            $this->themes=$themes;
        if($title!="")
            $this->title=$title;
        $this->name=fixVarNameJS($name);
    }
    function setWidth($newWidth) {
        $this->width=$newWidth;
    }
    function setAutoEventObject() {
        $this->useAutoEventObject=true;
    }
    function addScriptTmp($scriptStr) {
        $this->scriptTmp[count($this->scriptTmp)]=$scriptStr;
    }
    function setURL($newURL,$useJSON=true) {
        $this->on_show_url=$newURL;
        $this->on_show_use_json=$useJSON;
    }
    function setScriptJs($newJs) {
        $this->scriptJS=$newJs;
    }
    function getScriptJs() {
        return $this->scriptJS;
    }
    function setHeight($newHeight) {
        $this->height=$newHeight;
    }
    function setThemes($newThemes) {
        $this->themes=$newThemes;
    }
    function setTitle($newTitle) {
        $this->title=$newTitle;
    }
    function setNoCloseButton() {
        $this->closeButton=false;
    }
    function setVisible($boolVisibility) {
        $this->visible=$boolVisibility;
    }
    function setNoMaxButton() {
        $this->maxButton=false;
    }
    function setNoMinButton() {
        $this->minButton=false;
    }
    function setNoTitleBar() {
        $this->titleBar=false;
    }
    function setNoMaxMinButton() {
        $this->minButton=false;
        $this->maxButton=false;
    }
    function setUseJSPathChild() {
        $this->getChildJsPath=true;
    }
    function setUseCSSPathChild() {
        $this->getChildCssPath=true;
    }
    function addMenu($menuId,$caption) {
        if($this->menu==null) {
            loadLib("object.core.ardeaMenu");
            $this->menu=new menu("_ardea_wmenu_".$this->name."_");
        }
        $this->menu->addMenu($menuId,$caption);
    }
    function addMenuItem($parentId,$itemId,$caption) {
        if($this->menu==null) {
            loadLib("object.core.ardeaMenu");
            $this->menu=new menu("_ardea_menu_");
        }
        $option=argToOption(func_get_args(),"onclick,icon_a,icon_b");
        $onclick=getOption($option,"onclick",3);
        $icon_a=getOption($option,"icon_a",4);
        $icon_b=getOption($option,"icon_b",5);
        $this->menu->addItem($parentId,$itemId,$caption,$onclick,$icon_a,$icon_b);
    }

    function addObject($object) {
        if(!isArdeaObject($object))
            return;
        $object->setJsScriptToTmp();
        $object->setJsChild('windowInit.js');
        $tmpArr=array();
        $tmpArr['body_object']=$this->toJsObject('contain_object');
        $tmpArr['body_name']=$this->toJsObject('contain_name');
        $object->setParent($this);
        $object->setParentName($this->name);
        $object->deliverVar($tmpArr);


        if($this->useAjax) {
            $object->setUseAjax();
            if($this->useAutoEventObject) {
                if($object->isObjectAutoEvent())
                    $this->addScriptTmp($object->toJs("autoEvent"));
            }
        }

        $object->build();
        if($this->getChildJsPath) {
            $this->mergeFileJsNameChild($object->getFileJsName());
        }
        if($this->getChildCssPath) {
            $this->mergeFileCssNameChild($object->getFileCssName());
            //var_dump($object->getFileCssName());
            //die(var_dump($object->getFileCssName()));
        }
        //die("AAA");
        //die("A".var_dump($object->getHTML()));
        $this->property->property["containProperty"]["contain"].=$object->getHTML();
    }
    function toJsObject($opt,$arg=null) {
        switch($opt) {
            case 'contain_object':
                return "getObject(\"".$this->name."_ar_window_content\")";
                break;
            case 'contain_name':
                return "\"".$this->name."_ar_window_content\"";
                break;
            case 'contain_menu':
                return "\"".$this->name."_ar_window_content_menu\"";
                break;
            case 'show':
            case 'open':
                if(count($arg)==2) {
                    if($arg[1]&&$arg[1]!=null)
                        return $this->name.".show(true);";
                    else
                        return $this->name.".show();";
                }
                else
                    return $this->name.".show();";
                break;
            case 'close':
            case 'hide':
                return $this->name.".hide();";
                break;

        }
    }
    function setProperty() {
        $option=argToOption(func_get_args(),"name,themes,title,width,height");
        $name=getOption($option,"name");
        $title=getOption($option,"title",1);
        $themes=getOption($option,"themes",2);
        $width=getOption($option,"width",3);
        $height=getOption($option,"height",4);
        if($name!="")
            $this->name=$name;
        if($width!="")
            $this->width=$width;
        if($height!="")
            $this->height=$height;
        if($themes!="")
            $this->themes=$themes;
        if($title!="")
            $this->title=$title;
    }
    function getName() {
        return $this->name;
    }
    function  & getMenu() {
        return $this->menu;
    }
    function buildJs() {
        global $_funcLoad;
        global $ardeaCore;
        global $_VAR_FILE_;
        global  $_initJs;
        if($this->on_show_url!="") {
            if($_VAR_FILE_=='ardeaBaseInit') {
                $nm="var data_".$this->name;
                $_initJs->addScript($nm."=new dataShow;");
                $_initJs->addScript($nm.".useJSON=".$this->on_show_use_json);
                $_initJs->addScript($nm.".url=".$this->on_show_url);
            }
        }
        if($_VAR_FILE_=='windowInit.js') {
            $this->scriptJS->addScript("ardeaWindow.addWindow('".$this->name."','".$this->title."','".$this->themes."',".$this->width.",".$this->height.")");
            $this->scriptJS->addScript("ardeaWindow.create('".$this->name."')");
            if($this->useAjax)
                $this->scriptJS->addScript("ardeaWindow.addContain('".$this->name."',formData[\"".$this->name."\"])");
            else
                $this->scriptJS->addScript("ardeaWindow.addContain('".$this->name."',contain_window_".$this->name.")");
            //$this->scriptJS->addScript("ardeaWindow.addContain('".$this->name."','".$this->getContain()."')");
            foreach($this->scriptTmp as $value) {
                $this->scriptJS->addScript($value);
            }
            if($this->useAjax) {

                $this->buildJsMenu();
            }

        }

    }
    function buildJsMenu() {
        if($this->menu!=null) {
            $tmpArr=array();
            if($this->useAjax) {
                $tmpArr=$this->parent_var_for_child;
                $this->menu->setUseAjax();
            }
            $tmpArr['body_object']=$this->toJsObject('contain_object');
            $tmpArr['body_name']=$this->toJsObject('contain_name');
            $tmpArr['body_menu']=$this->toJsObject('contain_menu');
            $tmpArr['window_name']=$this->name;
            $this->menu->deliverVar($tmpArr);
            $this->menu->setJsScriptToTmp();
            $this->menu->build();
        }
    }

}
class ardeaWindowManager extends objectObject {
    protected $window=array();
    private $showAll=true;
    protected $noFinish=false;
    public $loadScriptInit=true;
    //protected $useAjax=false;
    protected $useChildJsPath=false;
    protected $useChildCssPath=false;
    function __construct() {
        global $ardeaCore;
        $this->initOnly();
        $ardeaCore->addJsPath($ardeaCore->getURLJS('ardeaEvent.js'));
        $ardeaCore->addJsPath($ardeaCore->getURLJS('ardeaLayer.js'));
        $ardeaCore->addJsPath($ardeaCore->getURLJS('ardeaWindow.js'));
        $this->setNoBuildProperty();
    }
    /*function  setUseAjax(){
		$this->useAjax=true;
	}
    */
    function setUseChildJsPath() {
        $this->useChildJsPath=true;
    }
    function setUseChildCssPath() {
        $this->useChildCssPath=true;
    }
    function ardeaWindowManager() {
        global $ardeaCore;
        $this->initOnly();
        $ardeaCore->addJsPath($ardeaCore->getURLJS('ardeaEvent.js'));
        $ardeaCore->addJsPath($ardeaCore->getURLJS('ardeaLayer.js'));
        $ardeaCore->addJsPath($ardeaCore->getURLJS('ardeaWindow.js'));
        $this->setNoBuildProperty();
    }
    function setNoAllWindowLoad() {
        $this->showAll=false;
    }
    function setNoFinish() {
        $this->noFinish=true;
    }
    function addWindow() {
        $option=argToOption(func_get_args(),"name,title,themes,width,height");
        $name=getOption($option,"name");
        if($name=="")
            return;
        $title=getOption($option,"title",1);
        $themes=getOption($option,"themes",2);
        $width=getOption($option,"width",3);
        $height=getOption($option,"height",4);
        $this->window[$name]=&new _window($name,$title,$themes,$width,$height);
        if($this->useAjax)
            $this->window[$name]->setUseAjax();
        return $this->window[$name];
    }
    public static function JS($name,$opt='name') {
        switch($opt) {
            case 'contain_object':
                return "getObject(\"".$name."_ar_window_content\")";
                break;
            case 'contain_name':
                return $name."_ar_window_content";
                break;
            case 'contain_menu':
                return "\"".$name."_ar_window_content_menu\"";
                break;
            case 'name':
                return fixVarNameJS($name);
                break;
        }
    }
    function buildObject() {
        /*
        foreach($this->window as $obj){
            $obj->build();
        }
         * *
        */
        //die($this->noUseBuildProperty?"TRUE":"FALSE");
        foreach($this->window as $obj) {
            $menu=&$obj->getMenu();
            if($this->useChildJsPath) {
                $this->mergeFileJsNameChild($obj->getFileJsName());
                if($menu!=null)
                    $this->mergeFileJsNameChild($menu->getFileJsName());
            }
            if($this->useChildCssPath) {
                $this->mergeFileCssNameChild($obj->getFileCssName());
                if($menu!=null)
                    $this->mergeFileCssNameChild($menu->getFileCssName());
            }


        }
        if($this->loadScriptInit) {
            $this->addJsFile('windowInit.js',true,false,true);
        }

    }
    function buildJs() {
        global $ardeaCore;
        global $_funcLoad;
        global $_VAR_FILE_;
        if($this->loadScriptInit) {
            $this->addJsFile('windowInit.js',true,false,true);
        }
        if($this->isHaveJs($script,$_VAR_FILE_)) {
            //die(var_dump($script));
            if($this->useAjax)
                $func=$script;
            else
                $func=$script->addFunction("runWindow");
            $func->addScript("ardeaWindow.setPathOfThemes(\"".$ardeaCore->getURLCSS("window/")."\")");
            foreach($this->window as $obj) {
                //die(var_dump($obj));
                $contain=$obj->getContain();
                $contain=($contain=="")?'':$contain;
                $idWindow=$obj->getName();
                $func->addScript(tplToVarJs($contain,"contain_window_".$idWindow));
                if(!$obj->maxButton)
                    $func->addScriptTmp("ardeaWindow.noMaxButton('$idWindow')");
                ///die(var_dump($obj->maxButton)) ;
                if(!$obj->minButton)
                    $func->addScriptTmp("ardeaWindow.noMinButton('$idWindow')");
                if(!$obj->closeButton)
                    $func->addScriptTmp("ardeaWindow.noCloseButton('$idWindow')");
                if(!$obj->titleBar)
                    $func->addScriptTmp("ardeaWindow.noStatusBar('$idWindow')");
                if(!$obj->visible)
                    $func->addScriptTmp("ardeaWindow.setHidden('$idWindow')");

                $obj->setScriptJs($func);
                if($this->useAjax) {
                    $tmpArr=array();
                    $tmpArr["fl_js_name"]=$_VAR_FILE_;
                    $tmpArr["script_object"]=&$func;
                    $obj->deliverVar($tmpArr);
                    $obj->setUseAjax();

                }
                $obj->buildJs();



            }
            if(!$this->noFinish) {
                if($this->showAll) {
                    $func->addScriptTmp("ardeaWindow.finished()");
                }else {
                    $func->addScriptTmp("ardeaWindow.finished(false)");
                }
            }
            $script->create();
            $this->isChildFoundParent=true;
        }elseif($_VAR_FILE_=='ardeaBaseInit') {
            foreach($this->window as $obj) {
                $obj->buildJsMenu();
            }
            $_funcLoad->addScript("runWindow();");
        }
    }

}



?>
