<?php
/*======================================================
 * %%%%%%%%%%%%%PHPArdea CORE 2.0%%%%%%%%%%%%%%%%%%%%%%%
 * =====================================================
 * Author  : Maulana Al Matien.
 * Email   : ardea.core.php@gmail.com
 * Name    : 
 * Date    : 
 * Used for: 
 * ======================================================
 * Copyright Ardea Workshop. http://ardea-workshop.co.cc/ardeaCore.php
 * You allowed to use this component or parts of it under LGPLv3 terms
 * To use it on other terms or get Professional edition of the component 
 * please contact us at ardea.core.php@gmail.com
*/
/**
 * @version		2.0
 * @package		object.core
 * @subpackage	basic
 * @author	Maulana al matien
 * @copyright Ardea-Workshop/Maulana Al Matien (2008-2009). All rights reserved.
 * @license http://www.gnu.org/licenses/lgpl-3.0.txt GNU Lesser General Public License (LGPLv3)
 */
define("PAGE_HEADER_ONLY","headeronly");
define("PAGE_HEADER_FOOTER","headerfooter");
define("PAGE_FOOTER_ONLY","footeronly");
define("PAGE_MAIN_ONLY","mainonly");
loadLib("object.core.basic.ardeaTable");
class titleForm extends objectObject {
    protected $title="Ardea Form Title";
    protected $titleAlign="center" ;
    protected $titleVAlign="center" ;
    protected $titleFonstSize="16px" ;
    protected $titleClass="16px" ;
    function titleForm($newTitle) {
        $this->title=$newTitle;

    }

    function setAlign($newAlign) {
        $this->titleAlign=$newAlign;
    }
    function setVAlign($newAlign) {
        $this->titleVAlign=$newAlign;
    }
    function getAlign() {
        return $this->titleAlign;
    }
    function getVAlign() {
        return $this->titleVAlign;
    }
    function setFontSize($newSizeOnPx) {
        $this->titleFonstSize=$newSizeOnPx;
    }
    function setTitle($newTitle) {
        $this->title= $newTitle;
    }
    function getTitle($withHTML=true) {
        if($withHTML) {
            return "<label class='master_form_title' style='font-size:".$this->titleFonstSize ."px'><b>$this->title</b></label>";
        }else {
            return $this->title    ;
        }
    }
    function setPositionContain($default="bottom") {

    }
    function setHeight($newHeight=100) {
        $this->setProperty("height",$newHeight,"style");
        $this->setProperty("height",$newHeight,"custom");
    }
}
class formHeader extends titleForm {
    function formHeader() {
        $arg=func_get_args();
        $this->init(0);
        if(count($arg)==1) {
            $this->title=$arg[0];
            ;
        }
        $this->titleAlign="center" ;
        $this->titleVAlign="center" ;
        $this->titleFonstSize="30" ;
        $this->title="Ardea Page Title-Header";
        $this->setHeight(100);
    }
}
class formFooter extends titleForm {
    function formFooter() {
        $arg=func_get_args();
        if(count($arg)==1) {
            $this->title=$arg[0];
            ;
        }
        $this->init(0);
        $this->titleAlign="center" ;
        $this->titleFonstSize="12" ;
        $this->titleVAlign="bottom" ;
        $this->title="Ardea Page Title-Footer";
        $this->setHeight(10);

    }
}
class ardeaPage extends objectObject {
    protected $header;
    protected $footer;
    protected $noHeader=0;
    protected $noFooter=0;
    protected $strFooter;
    protected $strHeader;
    protected $tblMaster;
    protected $borderForm=0;
    protected $widthPage;
    protected $strContain="";
    protected $alignHBodyPage;
    protected $alignVBodyPage;
    protected $align;
    protected $formatPage;

    function ardeaPage($formatPage="headerFooter") {
        global $ardeaCore;
        $this->init();
        $this->setFormatPage($formatPage);
        $ardeaCore->addJsPath($ardeaCore->getURLJS("ardeaForm.js"));
        $ardeaCore->addCssPath($ardeaCore->getURLCSS("ardeaPage.css"));
        $ardeaCore->addInitScript("bodyPage=getBodyObject()");
        $this->header=new formHeader();
        $this->footer=new formFooter();
        $this->tblMaster=new table("form_$formName");
        $this->tblMaster->setMaxRow(1);
        $this->tblMaster->setMaxCol(1);
        $this->tblMaster->setProperty(array("border:".$this->borderForm));
        $this->alignHBodyPage="left";
        $this->alignVBodyPage="top";
        $this->align="center";
        $this->widthPage="100%";
    }
    function setFormatPage($formatName) {
        global $ardeaCore;

        $this->formatPage=$formatName;
        switch(strtolower($formatName)) {
            case "headeronly":
                $this->noHeader=0;
                $this->noFooter=1;
                break;
            case "headerfooter":
                $this->noHeader=0;
                $this->noFooter=0;
                break;
            case "footeronly":
                $this->noHeader=1;
                $this->noFooter=0;
                break;
            case "mainonly":
                $this->noHeader=1;
                $this->noFooter=1;
                break;
        }

    }
    function setPageProperty($newProperty,$contain) {
        $this->tblMaster->setProperty($newProperty,$contain);
    }
    function setPageBorder($bordercontain) {
        $this->borderForm=$bordercontain;
        $this->tblMaster->setProperty("border",$bordercontain);
    }
    function setPageWidth($newWidth) {
        $this->widthForm=$newWidth;
        $this->tblMaster->setProperty("width",$newWidth);
    }
    function setPageType($newPageType) {
        $this->typePage = $newPageType;
    }
    function setHeaderTitle($newTitle) {
        $this->header->setTitle($newTitle);
    }
    function setHeaderHeight($newHeight) {
        $this->header->setHeight($newHeight);
    }
    function setHeaderProperty($propertyName,$value="",$parentProperty="property") {
        $this->header->setProperty($propertyName,$value,$parentProperty);
    }
    function setFooterTitle($newTitle) {
        $this->footer->setTitle($newTitle);
    }
    function setFooterHeight($newHeight) {
        $this->footer->setHeight($newHeight);
    }
    function setFooterProperty($propertyName,$value="",$parentProperty="property") {
        $this->footer->setProperty($propertyName,$value,$parentProperty);
    }
    function setTitlePage($newTitle) {
        global $ardeaCore;
        $ardeaCore->setTitlePage($newTitle);
    }

    function setPageVerticalAlign($newAlign) {
        $this->alignVBodyPage=$newAlign;
    }
    function setPageHorizontalAlign($newAlign) {
        $this->alignHBodyPage=$newAlign;
    }

    function addContain($stringContain) {
        $this->strContain.=$stringContain;
    }

    protected function buildObject() {
        global $ardeaCore;
        $this->strContain="<div id=\"main_page_div\" class=\"bodyDiv\" style=\"overflow: auto;\">".$this->strContain."</div>";
        $this->tblMaster->setProperty("width",$this->widthPage)            ;
        $this->tblMaster->setProperty("align",$this->align);
        $this->tblMaster->setProperty("class","pageTable");
        if($this->noFooter==0&&$this->noHeader==0) {
            $this->tblMaster->setMaxRow(3);
            $this->tblMaster->setMaxCol(1);
            $this->tblMaster->range(1,1)->importProperty($this->header->exportProperty());
            $this->tblMaster->range(3,1)->importProperty($this->footer->exportProperty());
            $this->tblMaster->setPropertyOfRow(3,$this->footer->exportProperty());
            $this->tblMaster->range(1,1)->setProperty("id","header_area");
            $this->tblMaster->range(1,1)->setProperty("contain",$this->header->getTitle(),"containProperty");
            $this->tblMaster->range(1,1)->setProperty("valign",$this->header->getVAlign());
            $this->tblMaster->range(1,1)->setProperty("align",$this->header->getAlign());
            $this->tblMaster->range(3,1)->setProperty("id","footer_area");
            $this->tblMaster->range(3,1)->setProperty("contain",$this->footer->getTitle(),"containProperty");
            $this->tblMaster->range(3,1)->setProperty("valign",$this->footer->getVAlign());
            $this->tblMaster->range(3,1)->setProperty("align",$this->footer->getAlign());
            $this->tblMaster->range(2,1)->setProperty("id","main_area");
            $this->tblMaster->range(2,1)->setProperty("contain",$this->strContain,"containProperty");
            $this->tblMaster->range(2,1)->setProperty("valign",$this->alignVBodyPage);
            $this->tblMaster->range(2,1)->setProperty("class","bodyPAGETD");
            $this->tblMaster->range(2,1)->setProperty("align",$this->alignHBodyPage);
        }else if($this->noFooter==0||$this->noHeader==0) {
            $this->tblMaster->setMaxRow(2);
            $this->tblMaster->setMaxCol(1);
            if($this->noFooter==0) {
                //$this->tblMaster->range(2,1)->importProperty($this->footer->exportProperty());
                //$this->tblMaster->setPropertyOfRow(2,)
                $this->tblMaster->range(1,1)->setProperty("id","main_area");
                $this->tblMaster->range(1,1)->setProperty("valign",$this->alignVBodyPage);
                $this->tblMaster->range(1,1)->setProperty("align",$this->alignHBodyPage);
                $this->tblMaster->range(1,1)->setProperty("contain",$this->strContain,"containProperty");
                $this->tblMaster->range(1,1)->setProperty("class","bodyPAGETD");
                $this->tblMaster->range(2,1)->setProperty("id","footer_area");
                $this->tblMaster->range(2,1)->setProperty("contain",$this->footer->getTitle(),"containProperty");
                $this->tblMaster->range(2,1)->setProperty("valign",$this->footer->getVAlign());
                $this->tblMaster->range(2,1)->setProperty("align",$this->footer->getAlign());

            }else {
                //die("MASK");
                $this->tblMaster->range(1,1)->importProperty($this->header->exportProperty());
                $this->tblMaster->range(1,1)->setProperty("id","header_area");
                $this->tblMaster->range(1,1)->setProperty("contain",$this->header->getTitle(),"containProperty");
                $this->tblMaster->range(1,1)->setProperty("valign",$this->header->getVAlign());
                $this->tblMaster->range(1,1)->setProperty("align",$this->header->getAlign());
                $this->tblMaster->range(2,1)->setProperty("id","main_area");
                $this->tblMaster->range(2,1)->setProperty("valign",$this->alignVBodyPage);
                $this->tblMaster->range(2,1)->setProperty("align",$this->alignHBodyPage);
                $this->tblMaster->range(2,1)->setProperty("contain",$this->strContain,"containProperty");
                $this->tblMaster->range(2,1)->setProperty("class","bodyPAGETD");
            }
        }else {
            $this->tblMaster->range(1,1)->setProperty("id","main_area");
            $this->tblMaster->range(1,1)->setProperty("contain",$this->strContain,"containProperty");
            $this->tblMaster->range(1,1)->setProperty("valign",$this->alignVBodyPage);
            $this->tblMaster->range(1,1)->setProperty("align",$this->alignHBodyPage);
            $this->tblMaster->range(1,1)->setProperty("class","bodyPAGETD");
        }
        $ardeaCore->addInitScript("headerHeight=".$this->header->getProperty("height","custom"));
        $ardeaCore->addInitScript("footerHeight=".$this->footer->getProperty("height","custom"));
        switch(strtolower($this->formatPage)) {
            case "headeronly":
                $ardeaCore->addInitScript("setSizePage('headerOnly');");
                $ardeaCore->addEventOnBody("onresize","setSizePage('headerOnly')");
                break;
            case "headerfooter":
                $ardeaCore->addInitScript("setSizePage('headerFooter');");
                $ardeaCore->addEventOnBody("onresize","setSizePage('headerFooter')");
                break;
            case "footeronly":
                $ardeaCore->addInitScript("setSizePage('footerOnly');");
                $ardeaCore->addEventOnBody("onresize","setSizePage('footerOnly')");
                break;
            case "mainonly":
                $ardeaCore->addInitScript("setSizePage('mainOnly');");
                $ardeaCore->addEventOnBody("onresize","setSizePage('mainOnly')");
                break;
        }
        $this->tblMaster->build();
        $this->smarty->assign('title',$ardeaCore->titlePage);
        $this->smarty->assign('jsPath',$ardeaCore->getJsPath());
        $this->smarty->assign('eventonbody',$ardeaCore->buildProperty("eventBody"));
        $this->smarty->assign('cssPath',$ardeaCore->getCssPath());
        $this->smarty->assign('initJs',$ardeaCore->getInitJs());
        $this->smarty->assign('contain',$this->tblMaster->getHTML());
        $this->strHTML=$this->smarty->fetch('default.tpl');
    }
    function showPage() {
        echo $this->strHTML;
    }
}
?>
