<?php
/*======================================================
 * %%%%%%%%%%%%%PHPArdea CORE 2.0%%%%%%%%%%%%%%%%%%%%%%%
 * =====================================================
 * Author  : Maulana Al Matien.
 * Email   : ardea.core.php@gmail.com
 * Name    :
 * Date    :
 * Used for:
 * ======================================================
 * Copyright Ardea Workshop. http://ardea-workshop.co.cc/ardeaCore.php
 * You allowed to use this component or parts of it under LGPLv3 terms
 * To use it on other terms or get Professional edition of the component
 * please contact us at ardea.core.php@gmail.com
*/
/**
 * @version		2.0
 * @package		object.core
 * @subpackage	basic
 * @author	Maulana al matien
 * @copyright Ardea-Workshop/Maulana Al Matien (2008-2009). All rights reserved.
 * @license http://www.gnu.org/licenses/lgpl-3.0.txt GNU Lesser General Public License (LGPLv3)
 */
class radioButton extends objectObject {
    private $tmp_prop=null;
    function radioButton($value) {
        global $ardeaCore;
        $this->init(3);
        if($value=="")
            $ardeaCore->setError("radioButton","Empty value","radioButton/ardeaRadioButton.php");
        $this->tmp_prop=& $this->property->property["property"];
        $this->tmp_prop["type"]="radio";
        $this->tmp_prop["class"]="def_radio";
        if(is_array($value)) {
            $this->setProperty($value);
        }else {
            $this->tmp_prop["name"]=$value;
            $this->tmp_prop["id"]=$value;
        }
        if($this->tmp_prop["id"]=="") {
            $this->tmp_prop["id"]="picture";
        }
        $this->tmp_prop["id"]=fixVarNameJS($this->tmp_prop["id"]);
        if($this->property->property["containProperty"]["contain"]=="")
            $this->property->property["containProperty"]["contain"]=$value;
        $this->name=$this->tmp_prop["id"];
        $this->canAutoEvent=true;
    }
    protected function buildObject() {
        $this->strHTML="<label ".$this->labelObjectProperty->buildProperty("style")." >\n";
        $this->strHTML.="   ".html('input',$this->buildProperty())."\n";
        $this->strHTML.="     ".$this->getContain()."\n";
        $this->strHTML.="</label>\n";
    }
    protected function buildJs() {
        global $ardeaCore;
        if(!$ardeaCore->autoJsEventHandler)
            return;
        global $_ardeaInitObject;
        global $_VAR_FILE_;
        if($_VAR_FILE_=='ardeaBaseInit') {
            $_ardeaInitObject->addScript("ardeaObject.registerObject('".$this->name."')");
        }
    }

}
class radioButtonGroup extends objectObject {
    protected $objectRadios=array();
    private $tmp_prop=null;
    //private $tmp_prop1=null;
    function radioButtonGroup($value) {
        global $ardeaCore;
        $this->init(3);
        if($value=="")
            $ardeaCore->setError("radioButtonGroup","Empty value","radioButtonGroup/ardeaRadioButton.php");
        $this->tmp_prop=& $this->property->property["property"];
        //$this->tmp_prop1=& $this->property->property["main"];
        //$this->setProperty("objectType","radioGroup","main");
        if(is_array($value)) {
            $this->setProperty($value);
        }else {
            $this->tmp_prop["name"]=$value;
            $this->tmp_prop["id"]=$value;
        }
        if($this->tmp_prop["id"]=="") {
            $this->tmp_prop["id"]="radio";
        }
        $this->name=$this->tmp_prop["id"];
    }
    function addRadioButton($radioButtonName,$propertyRadioButton="",$isChekced=false) {
        if($propertyRadioButton=="")
            $propertyRadioButton=$radioButtonName;
        $this->objectRadios[$radioButtonName]=new radioButton($propertyRadioButton);
        $this->objectRadios[$radioButtonName]->setProperty("name",$this->getProperty("name"));
        $this->objectRadios[$radioButtonName]->setProperty("width","","style");
        if($isChekced)
            $this->objectRadios[$radioButtonName]->setProperty("checked","checked");
    }
    function setDataFromDB($sqlString) {
        global $ardeaCore;
        $fieldValueDb="";
        if($this->property->property["dbProperty"]["fieldName"]!="") {
            $fieldValueDb=$ardeaCore->getDataFormArray($this->property->property["dbProperty"]["fieldName"]);
        }
        $rs=$ardeaCore->executeSQL($sqlString, 2);
        if($rs) {
            foreach($rs as $key => $value) {
                if($fieldValueDb!="") {
                    if($fieldValueDb==$value[0]) {
                        $this->addRadioButton($value[0],$value[0],true);
                    }else {
                        $this->addRadioButton($value[0],$value[0]);
                    }
                }else {
                    $this->addRadioButton($value[0],$value[0]);
                }
            }
        }
    }
    function getRatioButton($radioButtonName) {
        if(is_object($this->objectRadios[$radioButtonName])) {
            return $this->objectRadios[$radioButtonName];
        }else {
            return false;
        }
    }
    protected  function buildObject() {
        foreach($this->objectRadios as $objRadio) {
            $objRadio->build();
            $tmpstr.=$objRadio->getHTML()."\n";
        }
        if($this->useSmarty) {
            $this->smarty->assign("radio_name","id=\"".$this->getProperty("name")."\"");
            $this->smarty->assign("labelStyle",$this->labelObjectProperty->buildProperty("style"));
            $this->smarty->assign("contain",$tmpstr);
            $this->strHTML=$this->smarty->fetch("radioGroup.tpl");
        }else {
            $this->strHTML="<div id=\"".$this->getProperty("name")."\">\n";
            $this->strHTML.="   <label ".$this->labelObjectProperty->buildProperty("style").">".$tmpstr."</label>";
            $this->strHTML.="</div>\n";
        }
    }
}

?>