<?php
/*======================================================
 * %%%%%%%%%%%%%PHPArdea CORE 2.0%%%%%%%%%%%%%%%%%%%%%%%
 * =====================================================
 * Author  : Maulana Al Matien.
 * Email   : ardea.core.php@gmail.com
 * Name    :
 * Date    :
 * Used for:
 * ======================================================
 * Copyright Ardea Workshop. http://ardea-workshop.co.cc/ardeaCore.php
 * You allowed to use this component or parts of it under LGPLv3 terms
 * To use it on other terms or get Professional edition of the component
 * please contact us at ardea.core.php@gmail.com
*/
/**
 * @version		2.0
 * @package		object.core
 * @subpackage	basic
 * @author	Maulana al matien
 * @copyright Ardea-Workshop/Maulana Al Matien (2008-2009). All rights reserved.
 * @license http://www.gnu.org/licenses/lgpl-3.0.txt GNU Lesser General Public License (LGPLv3)
 */
class themesTable {
    public $color=array();
    public $colorHeader="";
    public $colorOver="";
    public $bg=array();
    public $bgHeader=array();
    public $bgAsc=array();
    public $bgDsc=array();
    function themesTable() {
        global $ardeaCore;
        $this->color['color1']="#f2f2f2";
        $this->color['color2']="#fff";
        $this->colorOver="#FFFF00";
        $this->colorHeader="#444";
        $this->bg['src']='';
        $this->bgHeader['src']=$ardeaCore->getURLIMAGE("table/sort.gif");
        $this->bgHeader['width']="6px";
        $this->bgAsc['src']=$ardeaCore->getURLIMAGE("table/asc.gif");
        $this->bgAsc['width']="6px";
        //$this->bgAsc['height']=$height;
        $this->bgDsc['src']=$ardeaCore->getURLIMAGE("table/desc.gif");
        $this->bgDsc['width']="6px";
        //$this->bgDsc['height']=$height;
    }
    function setColor() {
        $option=argToOption(func_get_args(),"color1,color2");
        $color1=getOption($option,"color1");
        $color2=getOption($option,"color2",1);
        if($color2=="")
            $color2=$color1;
        $this->color['color1']=$color1;
        $this->color['color2']=$color2;
    }
    function setBgColor() {
        $option=argToOption(func_get_args(),"src,width,height");
        $src=getOption($option,"src");
        if($src=="")
            return;
        $this->bg['src']=$src;
    }
    function setColorHeader() {
        $option=argToOption(func_get_args(),"color");
        $color=getOption($option,"color");
        if($color=="")
            return;
        $this->colorHeader=$color;
    }
    function setColorOver($color) {
        $this->colorOver=$color;
    }
    function setBgHeader() {
        $option=argToOption(func_get_args(),"src,width,height");
        $src=getOption($option,"src");
        if($src=="")
            return;
        $this->bgHeader['src']=$src;
    }
    function setBgAsc() {
        $option=argToOption(func_get_args(),"src,width,height");
        $src=getOption($option,"src");
        $height=getOption($option,"height",1);
        $width=getOption($option,"width",2);
        if($width=="")
            $width=6;
        //if($height=="")
        //$height=6;
        $this->bgAsc['src']=$src;
        $this->bgAsc['width']=$width."px";
        //$this->bgAsc['height']=$height;
    }
    function setBgDsc() {
        $option=argToOption(func_get_args(),"src,width,height");
        $src=getOption($option,"src");
        $height=getOption($option,"height",1);
        $width=getOption($option,"width",2);
        if($width=="")
            $width=6;
        //if($height=="")
        //$height=6;
        $this->bgDsc['src']=$src;
        $this->bgDsc['width']=$width."px";
        //$this->bgDsc['height']=$height;
    }
}
class table extends objectObject {
    public $maxRow=10;
    public $maxCol=5;
    private $_cells=array(array());
    private $_activeCell="";
    private $buildFormData=false;
    private $tmpStr="";
    private $isEmptyDataDb="not init";
    private $defaultValue;
    private $SQLSTR="ARDEA_CORE_NONE";
    private $tmp_prop=null;
    private $tableSorter=false;
    private $recordNav="";
    private $tdWidth="20%";
    private $useHeader=false;
    function table($value,$withSorter=false) {
        global $ardeaCore;
        $this->init();
        if($value=="")
            $ardeaCore->setError("table","Empty value","table/ardeaTable.php");
        $this->tmp_prop=& $this->property->property['property'];
        $this->initTable($value,$withSorter);
        if($withSorter) {
            $tmp=new themesTable();
            $this->generateThemes($tmp);
            $this->addCssFile('table_init.css',true);
            $this->addJsFile('table.js');
            $this->tableSorter=true;
        }
    }
    function setWithSorter() {
        $this->tableSorter=true;
        $tmp=new themesTable();
        $this->generateThemes($tmp);
        $this->addCssFile('table_init.css',true);
        $this->addJsFile('table.js');
    }
    private function generateThemes($thm) {
        $this->themes=array();
        $this->themes['color1']=$thm->color['color1'];
        $this->themes['color2']=$thm->color['color2'];
        $this->themes['colorHeader']=$thm->colorHeader;
        $this->themes['colorOver']=$thm->colorOver;
        $this->themes['src']= $thm->bg['src'];
        $this->themes['bgHeader_src']=$thm->bgHeader['src'];
        $this->themes['bgHeader_width']=$thm->bgHeader['width'];
        $this->themes['bgAsc_src']=$thm->bgAsc['src'];
        $this->themes['bgAsc_width']=$thm->bgAsc['width'];
        $this->themes['bgDsc_src']=$thm->bgDsc['src'];
        $this->themes['bgDsc_width']=$thm->bgDsc['width'];
    }
    function setSQL($sqlString) {
        $this->SQLSTR=$sqlString;
    }
    function setNavigator($navigatorObject) {
        if(get_class($navigatorObject)=='recordNavigator') {
            $this->recordNav=$navigatorObject;
        }
    }
    function setThemes($newThemes) {
        if(!compareClassName("ardeaThemes",$newThemes))
            return;
        $this->generateThemes($newThemes);
    }
    protected function initTable($value,$withSorter) {
        $this->defaultValue="";
        if($withSorter) {
            $this->tmp_prop["class"]="ardeaTable";
        }else {
            $this->tmp_prop["class"]="ardeaTable_basic";
        }
        //$this->setProperty("contain",$value,"containProperty");
        $i=0;
        if(is_array($value)) {
            $this->setProperty($value);
        }else {
            $this->tmp_prop["name"]=$value;
            $this->tmp_prop["id"]=$value;
        }
        if($this->tmp_prop["id"]=="") {
            $this->tmp_prop["id"]="table";
        }
        $this->tmp_prop["id"]=fixVarNameJS($this->tmp_prop["id"]);
        $this->name=$this->tmp_prop["id"];
    }
    function setDefaultValue($newDefaulValue) {
        $this->defaultValue=$newDefaulValue;
    }
    function setMaxCol($newMaxCol) {
        $this->maxCol=$newMaxCol;
    }
    function setUseHeader() {
        $this->useHeader=true;
    }
    function setMaxRow($newMaxRow) {
        $this->maxRow=$newMaxRow;
    }
    function setTDWidth($newTDWidth) {
        $this->tdWidth=$newTDWidth;
    }
    //function setColor
    function activeCell() {
        if(is_object($this->_activeCell)) {
            return $this->_activeCell;
        }else {
            return "";
        }
    }
    function addObject($posRow,$posColumn,$ardeaObject) {
        global $ardeaCore;
        if($posRow<=0||$posColumn<=0||$posRow>$this->maxRow||$posColumn>$this->maxCol)
            $ardeaCore->setError("addObject","posRow Object yang anda masukkan salah","table/ardeaTable.php");
        if(!is_object($this->_cells[$posRow][$posColumn])) {
            $this->_cells[$posRow][$posColumn]=new TD(array("name=".$this->name."_".$posRow."_".$posColumn,"id=".$this->name."_".$posRow."_".$posColumn));
        }
        if(!is_object($ardeaObject))
            $ardeaCore->setError("addObject","object yang anda masukkan salah","table/ardeaTable.php");
        $ardeaObject->build();
        $this->_cells[$posRow][$posColumn]->setProperty("contain",$ardeaObject->getHTML(),"containProperty");
        unset($ardeaObject);
    }

    function range($posRow,$posColumn,$isHeader=false) {
        global $ardeaCore;
        if($posRow<=0||$posColumn<=0||$posRow>$this->maxRow||$posColumn>$this->maxCol)
            $ardeaCore->setError("range","posRow(".$posRow.") atau posCol(".$posCol.") yang anda masukkan salah","table/ardeaTable.php");
        if(!is_object($this->_cells[$posRow][$posColumn])) {
            if(!$isHeader) {
                $this->_cells[$posRow][$posColumn]=new TD(array("name=".$this->name."_".$posRow."_".$posColumn,"id=".$this->name."_".$posRow."_".$posColumn));
                $this->_cells[$posRow][$posColumn]->setProperty("contain",$this->defaultValue,"containProperty");
            }else {
                $this->_cells[$posRow][$posColumn]=new TH(array("name=".$this->name."_".$posRow."_".$posColumn,"id=".$this->name."_".$posRow."_".$posColumn));
                $this->_cells[$posRow][$posColumn]->setProperty("contain",$this->defaultValue,"containProperty");
            }

        }
        return $this->_cells[$posRow][$posColumn];
    }
    function setPropertyOfRow($posRow,$arrayProperties) {
        global $ardeaCore;
        //die($posRow."sd ".$this->maxRow );
        if($posRow<=0||$posRow>$this->maxRow)
            $ardeaCore->setError("setPropertyOfRow","posRow yang anda masukkan salah","table/ardeaTable.php");
        if(!is_object($this->_cells[$posRow]["ROW"])) {
            $this->_cells[$posRow]["ROW"]=new TR($this->name."_".$posRow);
        }
        if(compareClassName("property",$arrayProperties) or compareClassName("ardeaExtendProperty",$arrayProperties)) {
            $this->_cells[$posRow]["ROW"]->importProperty($arrayProperties);
        }else {
            $this->_cells[$posRow]["ROW"]->setProperties($arrayProperties);
        }
    }
    function mergeCells($rowArea,$colArea) {
        global $ardeaCore;
        $tmpArrRow=split(":",$rowArea);
        $tmpArrCol=split(":",$colArea);
        if(count($tmpArrRow)==1)
            $tmpArrRow[1]=$tmpArrRow[0];
        if(count($tmpArrCol)==1)
            $tmpArrCol[1]=$tmpArrCol[0];
        if($tmpArrRow[0]>$tmpArrRow[1]||$tmpArrRow[0]<=0||$tmpArrRow[1]>$this->maxRow)
            $ardeaCore->setError("mergeCells","rowArea yang anda masukkan salah","table/ardeaTable.php");
        if($tmpArrCol[0]>$tmpArrCol[1]||$tmpArrCol[0]<=0||$tmpArrCol[1]>$this->maxCol)
            $ardeaCore->setError("mergeCells","colArea yang anda masukkan salah","table/ardeaTable.php");
        $i=$tmpArrRow[0];
        $j=$tmpArrCol[0];
        do {
            do {
                if(!is_object($this->_cells[$i][$j])) {
                    $this->_cells[$i][$j]=new TD(array("name=".$this->name."_".$i."_".$j,"id=".$this->name."_".$i."_".$j));
                    $this->_cells[$i][$j]->setContain($this->_cells[$i][$j]->getContain());
                    $this->_cells[$i][$j]->setUseSmarty($this->isUseSmarty());
                }
                $this->_cells[$i][$j]->setMerge();
                $j++;
            }while ($j<=$tmpArrCol[1]);
            $i++;
            $j=$tmpArrCol[0];
        }while ($i<=$tmpArrRow[1]);
        if($tmpArrRow[1]-$tmpArrRow[0]!=0) {
            $this->_cells[$tmpArrRow[0]][$tmpArrCol[0]]->setProperty("rowspan",$tmpArrRow[1]-$tmpArrRow[0]+1);
            $this->_cells[$tmpArrRow[0]][$tmpArrCol[0]]->setMerge(false);
        }
        if($tmpArrCol[1]-$tmpArrCol[0]!=0) {
            $this->_cells[$tmpArrRow[0]][$tmpArrCol[0]]->setProperty("colspan",$tmpArrCol[1]-$tmpArrCol[0]+1);
            $this->_cells[$tmpArrRow[0]][$tmpArrCol[0]]->setMerge(false);
        }
    }
    function setDataFromDBOld($sqlString) {
        global $ardeaCore;
        $rs=$ardeaCore->executeSQL($sqlString,1);
        $i=1;
        $j=1;
        if($rs) {
            $this->setMaxRow($rs->RecordCount()+1);
            $this->setMaxCol(count($rs->fields));
            //die("nbanak ".($rs->RecordCount()));

            foreach($rs as $key => $value) {
                if($i==1) {
                    //for header
                    foreach($value as $key_field =>$value_field) {
                        $this->range($i,$j,true)->setContain($key_field);
                        $j++;
                    }
                    $i++;
                    $j=1;
                }
                foreach($value as $key_field =>$value_field) {
                    //echo $i." ".$value_field."  ".$j."<br/>";

                    $this->range($i,$j)->setContain($value_field);
                    //$this->addData($value[0],$value[0],$value[0]);
                    $j++;
                }
                $j=1;
                $i++;
            }
            $this->isEmptyDataDb="no";
        }else {
            $this->isEmptyDataDb="yes";
            //$this->setMaxCol(0);
        }
    }
    function setDataFromDB($sqlString) {
        global $ardeaCore;
        if($this->typeRun=="default"||($this->parentName!=""&&$this->typeRun=="cJs")) {
            //echo "A ";
            $rs=$ardeaCore->executeSQL($sqlString,1);

            $i=1;
            $j=1;
            if(!is_array($this->tdWidth)) {
                $c=$this->tdWidth;
                $this->tdWidth=array();
                for($i=1;$i<$this->maxCol+1;$i++) {
                    $this->tdWidth[$i]=$c;
                }
            }else {
                for($i=1;$i<$this->maxCol+1;$i++) {
                    if(!isset($this->tdWidth[$i]))
                        $this->tdWidth[$i]="*";
                }
            }
            $i=1;
            if($rs) {
                $this->setMaxRow($rs->RecordCount()+1);
                $this->setMaxCol(count($rs->fields));
                //die("nbanak ".($rs->RecordCount()));
                $tmpTR="";
                foreach($rs as $key => $value) {
                    $tmpTD="";
                    if($i==1) {
                        //for header
                        foreach($value as $key_field =>$value_field) {
                            $tmpTdObject=new TD(array("name=".$this->name."_".$i."_".$j,"id=".$this->name."_".$i."_".$j));
                            $tmpTdObject->setProperty("width",$this->tdWidth[$j]);
                            $tmpTdObject->setContain($key_field);
                            $tmpTdObject->setJsChild($this->jsChildOf);
                            $tmpTD.=$tmpTdObject->build();
                            unset($tmpTdObject);
                            //$this->range($i,$j,true)->setContain($key_field);
                            $j++;
                        }
                        $i++;
                        $j=1;
                        $tmpTRObj=new TR(array("name=".$this->name."_".$i,"id=".$this->name."_".$i,"class=head"));
                        $tmpTRObj->setcontainHTML($tmpTD);
                        $tmpTRObj->setJsChild($this->jsChildOf);
                        $tmpTRObj->build();
                        $tmpTR.=$tmpTRObj->getHTML();
                        unset($tmpTRObj);
                        $tmpTD="";

                    }

                    if($i%2==0) {
                        $tmpTRObj=new TR(array("name=".$this->name."_".$i,"id=".$this->name."_".$i,"class=odd"));
                    }else {
                        $tmpTRObj=new TR(array("name=".$this->name."_".$i,"id=".$this->name."_".$i,"class=even"));
                    }
                    foreach($value as $key_field =>$value_field) {
                        //echo $i." ".$value_field."  ".$j."<br/>";
                        $tmpTdObject=new TD(array("name=".$this->name."_".$i."_".$j,"id=".$this->name."_".$i."_".$j));
                        $tmpTdObject->setContain($value_field);
                        $tmpTdObject->setJsChild($this->jsChildOf);
                        $tmpTD.=$tmpTdObject->build();
                        unset($tmpTdObject);
                        //$this->range($i,$j)->setContain($value_field);
                        //$this->addData($value[0],$value[0],$value[0]);
                        $j++;
                    }
                    $tmpTRObj->setcontainHTML($tmpTD);
                    $tmpTRObj->setJsChild($this->jsChildOf);
                    $tmpTRObj->build();
                    $tmpTR.=$tmpTRObj->getHTML();
                    unset($tmpTRObj);
                    $j=1;
                    $i++;
                }
                return $tmpTR;
                $this->isEmptyDataDb="no";
            }else {
                $this->isEmptyDataDb="yes";
                //$this->setMaxCol(0);
            }
        }
    }
    protected function buildObject() {
        global $ardeaCore;
        if($this->SQLSTR!="ARDEA_CORE_NONE") {
            if(is_object($this->recordNav)) {
                $this->recordNav->setSQL($this->SQLSTR);
                $this->recordNav->build();
                $this->SQLSTR.=$this->recordNav->getSQLLIMIT();
                //die($this->SQLSTR);
            }
            $tmpTR=$this->setDataFromDB($this->SQLSTR);
            // die("A".$tmpTR);

        }else {
            //if($this->isEmptyDataDb!="yes"){
            $tmpTD="";
            $tmpTR="";
            $i=1;
            $j=1;
            if(!is_array($this->tdWidth)) {
                $c=$this->tdWidth;
                $this->tdWidth=array();
                for($i=1;$i<$this->maxCol+1;$i++) {
                    $this->tdWidth[$i]=$c;
                }
            }else {
                for($i=1;$i<$this->maxCol+1;$i++) {
                    if(!isset($this->tdWidth[$i]))
                        $this->tdWidth[$i]="*";
                }
            }
            //die(var_dump($this->tdWidth));
            $i=1;
            do {
                do {
                    if($j==1) {
                        if(!is_object($this->_cells[$i]["ROW"]))
                            if($i%2==0) {
                                $this->_cells[$i]["ROW"]=new TR(array("name=".$this->name."_".$i,"id=".$this->name."_".$i,"class=odd"));
                            }else {
                                $this->_cells[$i]["ROW"]=new TR(array("name=".$this->name."_".$i,"id=".$this->name."_".$i,"class=even"));
                            }
                        // $this->_cells[$i]["ROW"]->setUseSmarty($this->isUseSmarty());
                    }
                    //die(var_dump($this->useHeader));
                    if($i==1&&$this->useHeader) {

                        $this->_cells[$i]["ROW"]->setProperty("class","head");
                    }
                    if(!is_object($this->_cells[$i][$j])) {
                        $this->_cells[$i][$j]=new TD(array("name=".$this->name."_".$i."_".$j,"id=".$this->name."_".$i."_".$j));
                        //$this->_cells[$i][$j]->setUseSmarty($this->isUseSmarty());
                    }
                    if($i==1) {
                        $this->_cells[$i][$j]->setProperty("width",$this->tdWidth[$j]);
                    }
                    if($this->_cells[$i][$j]->getContain()=="")
                        $this->_cells[$i][$j]->setContain("&nbsp;");
                    if(!$this->_cells[$i][$j]->isMerge) {
                        $this->_cells[$i][$j]->setContain($this->_cells[$i][$j]->getContain());
                        $this->_cells[$i][$j]->setJsChild($this->jsChildOf);
                        $this->_cells[$i][$j]->build();
                        $tmpTD.=$this->_cells[$i][$j]->getHTML();
                        unset($this->_cells[$i][$j]);
                    }
                    $j++;
                }while ($j<=$this->maxCol);

                $this->_cells[$i]["ROW"]->setcontainHTML($tmpTD);
                $this->_cells[$i]["ROW"]->setJsChild($this->jsChildOf);
                $this->_cells[$i]["ROW"]->build();
                $tmpTR.=$this->_cells[$i]["ROW"]->getHTML();
                unset($this->_cells[$i]["ROW"]);

                $i++;
                $j=1;
                $tmpTD="";
            }while ($i<=$this->maxRow);
            /*
            if($this->useSmarty){
               $this->smarty->assign("property",$this->buildProperty());
               $this->smarty->assign("contain",$tmpTR);
               $this->strHTML=$this->smarty->fetch("table.tpl");
           }else{
              $this->strHTML="<table ".$this->buildProperty()." >\n";
              $this->strHTML.="   ".$tmpTR."\n";
              $this->strHTML.="</table>\n";
           }
           * 
            */

        }
        if(is_object($this->recordNav)) {
            $tmpTdObject=new TD(array("name=".$this->name."_nav","id=".$this->name."_nav","colspan=".$this->maxCol));
            $tmpTdObject->setContain($this->recordNav->getHTML());
            $tmpTdObject->setJsChild($this->jsChildOf);
            $tmpTD=$tmpTdObject->build();
            unset($tmpTdObject);
            $tmpTRObj=new TR(array("name=".$this->name."_nav_row","id=".$this->name."_nav_row"));
            $tmpTRObj->setcontainHTML($tmpTD);
            $tmpTRObj->setJsChild($this->jsChildOf);
            $tmpTRObj->build();
            $tmpTRA.=$tmpTRObj->getHTML();
            ///  die("A".$this->getProperty("width"));
            $tabel=html('table',$this->buildProperty(),$tmpTR);
            $tabelNav=html('table',"border=0 width=".$this->getProperty("width"),$tmpTRA);
            $this->strHTML.=html('div',"",$tabelNav.$tabel.$tabelNav);

        }else {
            $this->strHTML=html('table',$this->buildProperty(),$tmpTR);
        }
    }
    protected function buildCss() {
        if($this->isHaveCss()) {
            $this->smarty->assign("color1",$this->themes['color1']);
            $this->smarty->assign("color2",$this->themes['color2']);
            $this->smarty->assign("bgHead",$this->themes['bgHeader_src']);
            $this->smarty->assign("bgHeadWidth",$this->themes['bgHeader_width']);
            $this->smarty->assign("bgDsc",$this->themes['bgDsc_src']);
            $this->smarty->assign("bgDscWidth",$this->themes['bgDsc_width']);
            $this->smarty->assign("bgAsc",$this->themes['bgAsc_src']);
            $this->smarty->assign("bgAscWidth",$this->themes['bgAsc_width']);
            $this->smarty->assign("colorOver",$this->themes['colorOver']);
            $this->smarty->setTemplateDirectoryToCore("table");
            echo fixTplJsOrCss($this->smarty->fetch("tablecss.tpl"));
        }
        if($this->useAjax)
            die();
    }
    protected function buildJs() {
        global $_funcLoad;
        global $_initJs;
        global $_VAR_FILE_;
        if($this->tableSorter) {
            if($_VAR_FILE_=='ardeaBaseInit') {
                if(is_object($this->recordNav)) {
                    $_funcLoad->addScript("ardeaNavigator.formName='".$this->recordNav->name."'") ;
                }
                $id=$this->getProperty("id");
                $_initJs->addScript("var sorter_".$id."=''");
                if(!$this->JsScriptToTmp) {
                    $_funcLoad->addScript("sorter_".$id."=new table.sorter('".$id."')");
                    $_funcLoad->addScript("sorter_".$id.".init('".$id."',1)");
                    //$_funcLoad->addScript($id.".work(1)");
                }else {
                    $_initJs->addScriptTmp("sorter_".$id."=new table.sorter('".$id."')",$_funcLoad->getName());
                    $_initJs->addScriptTmp("sorter_".$id.".init('".$id."',1)",$_funcLoad->getName());
                }
            }
            elseif($_VAR_FILE_=='windowInit.js') {
                if($this->useAjax) {

                    if(is_object($this->recordNav)) {
                        $this->parentObject->addScriptTmp("ardeaNavigator.formName='".$this->recordNav->name."'") ;
                    }
                    $id=$this->getProperty("id");
                    $this->parentObject->addScriptTmp("var sorter_".$id."=''");
                    $this->parentObject->addScriptTmp("sorter_".$id."=new table.sorter('".$id."')");
                    $this->parentObject->addScriptTmp("sorter_".$id.".init('".$id."',1)");
                    //$_funcLoad->addScript($id.".work(1)");
                }
            }
        }
    }

}
class TR extends objectObject {
    private $tmp_prop=null;
    function TR($value) {
        global $ardeaCore;
        $this->initOnly();
        $this->setNoBuildProperty();
        if($value=="")
            $ardeaCore->setError("TR","Empty value","TR/ardeaTable.php");
        $this->tmp_prop=& $this->property->property["property"];
        $i=0;
        if(is_array($value)) {
            $this->setProperty($value);
        }else {
            $this->tmp_prop["name"]=$value;
            $this->tmp_prop["id"]=$value;
        }
        if($this->tmp_prop["id"]==""&&!is_array($value)) {
            $this->tmp_prop["id"]=$value;
        }elseif($this->tmp_prop["id"]=="") {
            $this->tmp_prop["id"]="tableTR";
        }
        $this->name=$this->tmp_prop["id"];
    }
    function setcontainHTML($newHTML) {
        $this->setProperty("contain",$newHTML,"containProperty");
    }
    protected function buildObject() {
        $this->strHTML=html('tr',$this->buildProperty(),$this->getContain());
    }

}

class TD extends objectObject {
    private $tmp_prop=null;
    public $isMerge=false;
    function TD($value) {
        global $ardeaCore;
        $this->initOnly();
        $this->setNoBuildProperty();
        if($value=="")
            $ardeaCore->setError("TD","Empty value","TD/ardeaTable.php");
        $this->tmp_prop=& $this->property->property["property"];
        $this->tmp_prop["valign"]="top";
        $this->tmp_prop["align"]="left";
        $i=0;
        if(is_array($value)) {
            $this->setProperty($value);
        }else {
            $this->tmp_prop["name"]=$value;
            $this->tmp_prop["id"]=$value;
            $this->property->property["containProperty"]["contain"]=$value;
        }
        if($this->tmp_prop["id"]==""&&!is_array($value)) {
            $this->tmp_prop["id"]=$value;
        }elseif($this->tmp_prop["id"]=="") {
            $this->tmp_prop["id"]="tableTD";
        }
        $this->name=$this->tmp_prop["id"];
    }
    function setMerge($boolMerge=true) {
        $this->isMerge=$boolMerge;
    }
    function isMerge() {
        return $this->isMerge;
    }

    protected function buildObject() {
        $this->strHTML=html('td',$this->buildProperty(),$this->getContain());
    }

}
class TH extends objectObject {
    private $tmp_prop=null;
    public $isMerge=false;
    function TH($value) {
        global $ardeaCore;
        $this->initOnly();
        $this->setNoBuildProperty();
        if($value=="")
            $ardeaCore->setError("TH","Empty value","TD/ardeaTable.php");
        $this->tmp_prop=& $this->property->property["property"];
        $this->tmp_prop["valign"]="top";
        $this->tmp_prop["align"]="left";
        $i=0;
        if(is_array($value)) {
            $this->setProperty($value);
        }else {
            $this->tmp_prop["name"]=$value;
            $this->tmp_prop["id"]=$value;
            $this->property->property["containProperty"]["contain"]=$value;
        }
        if($this->tmp_prop["id"]==""&&!is_array($value)) {
            $this->tmp_prop["id"]=$value;
        }elseif($this->tmp_prop["id"]=="") {
            $this->tmp_prop["id"]="tableTH";
        }
        $this->name=$this->tmp_prop["id"];
    }
    function setMerge($boolMerge=true) {
        $this->isMerge=$boolMerge;
    }
    function isMerge() {
        return $this->isMerge;
    }

    protected function buildObject() {
        $this->strHTML=html('th',$this->buildProperty(),$this->getContain());
    }

}
class testTD {
    var $test="DEF";
    function getData() {
        return $this->test;
    }
    function setData($newdata) {
        $this->test=$newdata;
    }
}

?>
