<?php
/* 
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
*/
/**
 * @version		2.0
 * @package		object.core
 * @subpackage	setup
 * @author	Maulana al matien
 * @copyright Ardea-Workshop/Maulana Al Matien (2008-2009). All rights reserved.
 * @license http://www.gnu.org/licenses/lgpl-3.0.txt GNU Lesser General Public License (LGPLv3)
 */
loadLib("object.core.ardeaAjax");
loadLib("object.core.application.ardeaApplication");
loadLib("object.core.setup.ardeaSetupLib");

class setup extends application {
    public $setup_app_name="";
    public $setup_app_step=array();
    protected $setup_app_path_thm="";
    protected $setup_app_path_mvc="";
    protected $ajax;
    protected $json;
    protected $stepProcess=array();
    protected $currentLayout="standard";
    protected $useAjax=false;
    protected $homeID=false;
    protected $useWindow="NONE";
    protected $layoutPath=array();
    protected $layoutName=array();
    protected $pos=0;
    function __construct() {
        //$this->defContructApplication();
        parent::__construct();
        //$this->name="ardeaSetup";
        $this->setNoBuildProperty();
        //$this->ajax=new ardeaAjax('post');
        $this->ajax=new ardeaAjax('post');
        //$this->ajax->setBuidJsOnVirtual();
        $this->json=new JSON();
        $this->ajax->setDefaultNameFunction("ajaxApplicationSetupProcess");
        $this->layoutPath[0]=fixRealPath(realpath(dirname(__FILE__)))."layout/";
    }
    function setLayoutPath($layoutPath) {
        $this->layoutPath[count($this->layoutPath)]=$layoutPath;
    }
    function setWindowName($windowName) {
        $this->useWindow=$windowName;
    }

    function setUseAjax($htmlDivId=null) {
        $this->useAjax=true;
        if($htmlDivId!=null)
            $this->homeID=$htmlDivId;
    }
    function setHomeDivId($htmlDivId) {
        $this->homeID=$htmlDivId;
    }
    private function loadLayout($layoutName="standard") {
        //die(var_dump($this->layoutName));
        if(array_key_exists($layoutName,$this->layoutName))
            require_once($this->layoutName[$layoutName]["path"].$layoutName.".php");
    }
    public function setLayout($layoutName="standard") {
        $this->currentLayout=$layoutName;
    }
    protected function initPathLayout() {
        foreach($this->layoutPath as $value) {
            foreach(getPropertyOnFolder($value) as $fileName) {
                $fileName=str_replace(".php","",$fileName);
                $this->layoutName[$fileName]=array();
                $this->layoutName[$fileName]["path"]=$value;
            }
        }
    }
    function & addStep() {
        $pos=count($this->stepProcess);
        $this->stepProcess[$pos]=new ardeaSetupStepProcess;
        $this->stepProcess[$pos]->id=$pos;
        return $this->stepProcess[$pos];
    }
    function & getStep($indexOfStep,&$returnVar=null) {
        if($indexOfStep>count($this->stepProcess))
            return null;
        return  $this->stepProcess[$indexOfStep];
    }
    protected function runExtendedBefore() {
        global $mvcReg;
        global $_VAR_FILE_;
        if($this->useAjax&&$this->homeID=="")
            die("You must set home html div id");
        $this->initPathLayout();
        $this->loadLayout($this->currentLayout);
        $mvcReg->setContain($this->setup_app_name,"setup:name");

        $pos=$mvcReg->get("step");

        if($pos==""||$pos==null) {
            $pos=0;
            if(count($this->stepProcess)>0) {
                $mvcReg->set($mvcReg->get("default"),$this->stepProcess[0]->opt);
                $mvcReg->set("setup:layout","first");
                $mvcReg->set("setup:dataProcess",$this->stepProcess[0]->process);
                //$mvcReg->set("setup:processID",0);
            }
        }else {
            $mvcReg->set($mvcReg->get("default"),$this->stepProcess[$pos]->opt);
            $mvcReg->set("setup:layout",$this->stepProcess[$pos]->layout);
            $mvcReg->set("setup:dataProcess",$this->stepProcess[$pos]->process);
            //$mvcReg->set("setup:processID",$pos);
        }
        $this->pos=$pos;
        $this->build();
        //$this->ajax->registerFunction('ajaxApplicationSetupProcess','','ardeaSetupProcess','step='.($pos+1));
        if($this->useAjax) {
            $this->ajax->registerFunction('ajaxApplicationSetupProcess','','',"\"step=\"+ajax_post_next_str");
            $this->ajax->build();
            if($this->ajax->isRequest()) {
                $this->setTemplateNoWrite();
                $this->tmpl->noUseGetData();
                $this->tmpl->noUseRouterPage();
                $this->tmpl->noUseFinishingData();
                $this->tmpl->setBreakBeforeWrite();
            }
        }
        //die($mvcReg->get("bug"));
    }
    protected function buildObject() {
        global $ardeaCore;
        global $ardeaCore;
        $ardeaCore->addJsPath($ardeaCore->getURLJS('ardeaSetup.js'));
    }
    protected function buildJs() {
        global $_VAR_FILE_;
        global $_funcLoad;
        global $_initJs;
        if($_VAR_FILE_=='ardeaBaseInit') {
            $_initJs->addScript("/*Ardea setup  setting*/");
            $_initJs->addScript("progressSetupIndex=0;");
            if($this->useAjax)
                $_initJs->addScript("var setup_use_ajax=true;");
            else
                $_initJs->addScript("var setup_use_ajax=false;");
            if($this->useAjax&&$this->homeID!="") {
                $_initJs->addScript("var setupHome='';");
                $_initJs->addScript("var windowObject='';");
                $_initJs->addScript("var ajax_post_next_str;");

            }

            $_initJs->addScript("posSetupIndex=".$this->pos.";");
            $_initJs->addScript("ajax_post_next_str=".($this->pos+1)."");
            $_initJs->addScript("posRequestSetup=0;");
            $_initJs->addScript("var successStep=[];");
            $_initJs->addScript("var dataResultSetup=[];");
            $_initJs->addScript("var dataResultSetupLayout=[];");
            $_initJs->addScript("maxStep=".count($this->stepProcess).";");
            $_initJs->addScript("urlSetup='".ardeaURL::URL()."';");
            $_initJs->addScript("/*End Ardea setup  setting*/");
            $funcSetup=$_initJs->addFunction('ardeaInitSetup');
            $_funcLoad->addScript("ardeaInitSetup();");
            if($this->useWindow!="NONE")
                $_funcLoad->addScriptTmp("windowObject=ardeaWindow.getWindow('".$this->useWindow."');");
            if($this->useAjax&&$this->homeID!="") {
                $_funcLoad->addScriptTmp("setupHome=getObject('".$this->homeID."');");
                $_funcLoad->addScriptTmp("  if(setupHome){");
                $_funcLoad->addScriptTmp("  dataResultSetupLayout[0]=setupHome.innerHTML");
                $_funcLoad->addScriptTmp("  }");

            }
            //$_funcLoad->addScript("alert(dataSetup[0].opt);");
            //$dataSetup=$this->json->encode($this->stepProcess);
            //$funcSetup->addScript("setupName=eval('$dataSetup')");
            //$funcSetup->addScript("dataSetup=eval('$dataSetup')");
            for($i=1;$i<count($this->stepProcess)+1;$i++) {
                //if($i==1){
                //$funcSetup->addScript("successStep[$i]=true;");
                //}else{
                $funcSetup->addScript("successStep[$i]=false;");
                //}
            }
        }
    }
    protected function runExtendedAfter() {
        global $mvcReg;
        if($this->setup_app_name=="")
            return ;
        if($this->useAjax&&$this->ajax->isRequest()) {
            $mvcReg->set("setup:layoutData",setupParseData(getMainLayout()));
            $this->ajax->addFOC(null,"ajaxApplicationSetupProcess",'ardeaSetupProcess(data)');
            $this->ajax->process(true);
        }

        return true;
    }

}

class ardeaSetupStepProcess {
    public $id;
    public $mod;
    public $opt;
    public $description;
    public $title;
    public $menuValue;
    public $modNext;
    public $optNext;
    public $layout="first";
    public $process=array();
    public function setProcess($mod,$opt) {
        $pos=count($this->process);
        $this->process[$pos]=new ardeaSetupProcess;
        $this->process[$pos]->mod=$mod;
        $this->process[$pos]->opt=$opt;
    }
}
class ardeaSetupProcess {
    public $mod;
    public $opt;
}
class ardeaSetupResult {
    public $id;
    public $succes;
    public $errorMessage;
    public $layoutData;
    public $backupData;
}
?>
