<?php
/*======================================================
 * %%%%%%%%%%%%%PHPArdea CORE 2.0%%%%%%%%%%%%%%%%%%%%%%%
 * =====================================================
 * Author  : Maulana Al Matien.
 * Email   : ardea.core.php@gmail.com
 * Name    : 
 * Date    : 
 * Used for:
 * ======================================================
 * Copyright Ardea Workshop. http://ardea-workshop.co.cc/ardeaCore.php
 * You allowed to use this component or parts of it under LGPLv3 terms
 * To use it on other terms or get Professional edition of the component 
 * please contact us at ardea.core.php@gmail.com
*/
/**
 * @version		2.0
 * @package		object.core
 * @subpackage	widget
 * @author	Maulana al matien
 * @copyright Ardea-Workshop/Maulana Al Matien (2008-2009). All rights reserved.
 * @license http://www.gnu.org/licenses/lgpl-3.0.txt GNU Lesser General Public License (LGPLv3)
 */
loadLib("lib.core.ardeaObject");
loadLib("lib.core.template.ardeaTemplate");

global $mvcReg;
$mvcReg->set("widget_path_themes:default","themes/");
$mvcReg->set("widget_path_mvc:default","mvc/");
$mvcReg->set("widget_path_setup:default","setup/");
$mvcReg->set("widget_path_admin:default","admin/");
$mvcReg->set("app_path_themes:default","themes/");
$mvcReg->set("app_path_view:default","views/");
$mvcReg->set("app_path_model:default","models/");
$mvcReg->set("app_path_controller:default","controllers/");
$mvcReg->set("app_path_mvc:default","mvc/");
class widget extends objectObject {
    protected $tmpl;
    protected $widgetType="NONE";
    protected $widgetProperty=null;
    protected $data;
    function __construct() {
        global $mvcReg;
        parent::__construct();
        $this->initOnly();
        $this->widgetProperty=new ardeaWidgetProperty;
        $this->setNoBuildProperty();
        $this->name=get_class($this);
        $this->tmpl=new template;
        $this->tmpl->setUseController();
        $this->tmpl->setAppName($this->name);
        //die(realpath(dirname(__FILE__)));
        $mvcReg->set("widget_path_themes:".$this->name,$mvcReg->get("widget_path_themes:default"));
        $mvcReg->set("widget_path_mvc:".$this->name,$mvcReg->get("widget_path_mvc:default"));
        $mvcReg->set("widget_path_setup:".$this->name,"setup/");
        $mvcReg->set("widget_path_admin:".$this->name,"admin/");
        $mvcReg->set("widget_themes_name:".$this->name,$this->name);
        $mvcReg->set("app_path_themes:".$this->name,$mvcReg->get("app_path_themes:default"));
        $mvcReg->set("app_path_mvc:".$this->name,$mvcReg->get("app_path_mvc:default"));
        $mvcReg->set("app_path_view:".$this->name,$mvcReg->get("app_path_view:default"));
        $mvcReg->set("app_path_model:".$this->name,$mvcReg->get("app_path_model:default"));
        $mvcReg->set("app_path_controller:".$this->name,$mvcReg->get("app_path_controller:default"));
        //$mvcReg->set("app_name:".$this->name,$this->name);
    }
    function setFolderThemes($folderName) {
        global $mvcReg;
        $mvcReg->set("widget_path_themes:".$this->name,$folderName."/");
    }
    function initDefaultWidgetProperty() {
        if(method_exists($this,"buildObject")) {
            $this->initWidgetProperty();
        }
    }
    function setProperty($newProperty) {
        $this->widgetProperty=$newProperty;
    }
    function getProperty() {
        $this->widgetProperty;
    }
    function setRootPath($realPath) {
        global $mvcReg;
        $mvcReg->set("widget_root_path:".$this->name,fixRealPath($realPath));
        $this->tmpl->setMVCPath(fixRealPath($realPath).$mvcReg->get("widget_path_mvc:default"));
        $this->tmpl->setPath(fixRealPath($realPath).$mvcReg->get("widget_path_themes:default"));
    }

    function setFolderMVC($folderName) {
        global $mvcReg;
        $mvcReg->set("widget_path_mvc:".$this->name,$folderName."/");
    }

    function setMVCfolderName($newFolderName) {
        $this->tmpl->setUseMVC($mvcReg->get("widget_root_path:".$this->name).$newFolderName);
    }
    function setThemesfolderName($newFolderName) {
        $this->tmpl->setPath($mvcReg->get("widget_root_path:".$this->name).$newFolderName);
    }
    public static function publicPath($widgetName) {
        global $mvcReg;
        return ARDEA_CORE_DOMAIN."www/widget/".$widgetName."/";
    }
    public static function appThemePath($widgetName) {
        global $mvcReg;
        return $mvcReg->get("widget_root_path:".$widgetName).$mvcReg->get("widget_path_themes:".$widgetName).$mvcReg->get("widget_themes_name:".$widgetName)."/";
    }
    public static function appPath($widgetName) {
        global $mvcReg;
        return $mvcReg->get("widget_root_path:".$widgetName).$mvcReg->get("widget_path_themes:".$widgetName).$mvcReg->get("widget_themes_name:".$widgetName)."/";
    }
    public static function appMVCPath($widgetName) {
        global $mvcReg;
        return $mvcReg->get("widget_root_path:".$widgetName).$mvcReg->get("widget_path_mvc")."/";
    }
    public static function urlPath($widgetName) {
        global $mvcReg;
        return ardeaURL::URL("folder").$mvcReg->get("widget_path_themes:".$this->name).$mvcReg->get("widget_themes_name:".$widgetName)."/";
    }
    function setType($newWidgetType) {
        $this->widgetType=$newWidgetType;
    }
    function setInput($inputData) {
        $this->data=$inputData;
    }
    function getOutput() {
    }

    function pack($write=false) {
        $this->build();
        if($write) {
            echo $this->strHTML;
        }
    }

}
class ardeaWidgetProperty {
    private $property=array();
    function setProperty($varName,$title,$descriptionProperty="",$widgetType="default") {
        if($varName=="")
            return;
        if(!array_key_exists($widgetType,$this->property))
            $this->property[$widgetType]=array();
        $key=fixVarNameJS($varName);

        $this->property[$widgetType][$key]=array();
        $this->property[$widgetType][$key]["name"]=$varName;
        $this->property[$widgetType][$key]["title"]=$title;
        $this->property[$widgetType][$key]["desc"]=$descriptionProperty;
    }
    function getProperty($varName,$widgetType="default") {
        if($varName=="")
            return null;
        if(!array_key_exists($widgetType,$this->property))
            return null;
        $varName=fixVarNameJS($varName);
        if(!array_key_exists($varName,$this->property[$widgetType]))
            return null;
        return    $this->property[$widgetType][$varName];
    }

}
?>
