<?php
/*======================================================
 * %%%%%%%%%%%%%PHPArdea CORE 2.0%%%%%%%%%%%%%%%%%%%%%%%
 * =====================================================
 * Author  : Maulana Al Matien.
 * Email   : ardea.core.php@gmail.com
 * Name    :
 * Date    :
 * Used for:
 * ======================================================
 * Copyright Ardea Workshop. http://ardea-workshop.co.cc/ardeaCore.php
 * You allowed to use this component or parts of it under LGPLv3 terms
 * To use it on other terms or get Professional edition of the component
 * please contact us at ardea.core.php@gmail.com
 */
 /**
 * @version		2.0
 * @package		object.plugin
 * @subpackage	graph
 * @author	Maulana al matien
 * @copyright Ardea-Workshop/Maulana Al Matien (2008-2009). All rights reserved.
 * @license http://www.gnu.org/licenses/lgpl-3.0.txt GNU Lesser General Public License (LGPLv3)
 */
loadLib("lib.core.ardeaDOM")    ;
class dataSeries extends objectObject{
    private $tmp_Prop;
    function dataSeries(){
      $this->initOnly() ;
      $this->property->property["ardea_data_series"]=array();
      $this->tmp_Prop=& $this->property->property["ardea_data_series"];
      $this->tmp_Prop["cat"]=array();
      $this->tmp_Prop["dat"]=array();
      $this->setNoBuildProperty();
    }
    function setCategory($categoryItemArray){
        $this->tmp_Prop["cat"]=$categoryItemArray;
    }
    function addData($seriesName,$datasetArray){
      if(is_array($seriesName)){
          $this->tmp_Prop["dat"][$seriesName[0]]=array();
          $this->tmp_Prop["dat"][$seriesName[0]]["dat"]=$datasetArray;
          $this->tmp_Prop["dat"][$seriesName[0]]["att"]=null;
          if(count($seriesName)>1){
              $this->tmp_Prop["dat"][$seriesName[0]]["att"]=array();
              for($i=1;$i<count($seriesName);$i++){
                 if(is_array($seriesName[i])){
                  $this->tmp_Prop["dat"][$seriesName[0]]["att"][$seriesName[i][0]]=$seriesName[i][1];                        
                 }
              }
          }
      }else{
         
          $this->tmp_Prop["dat"][$seriesName]=array();
          $this->tmp_Prop["dat"][$seriesName]["dat"]=$datasetArray;
          $this->tmp_Prop["dat"][$seriesName]["att"]=null;          
      }
    }
    function buildObject(){
        $this->buildDefault();
    }
   function buildXML(){
        $this->buildDefault();
    }    
    function buildDefault(){
      $this->data=new node('graph');
      $cats=new node("categories");
      $i=0;
      $m=0;
      if(is_array($this->tmp_Prop)){
          foreach($this->tmp_Prop["cat"] as $key => $value){
              $cat=new node("category");
              $cat->addAttribute("name",$value);
              $cats->addMore($cat);
          }
          $this->data->addChild($cats);
          foreach($this->tmp_Prop["dat"] as $key_dataset => $value_dataset){
            $i=0;
            $dat_st=new node("dataset");
            $dat_st->addAttribute("seriesName",$key_dataset);
            
            if(is_array($value_dataset["dat"])){
                foreach($value_dataset["dat"] as $val_value){
                    $st=new node("set");
                    if(is_array($val_value)){
                        $m=0;
                        $arrTMP=$val_value;
                        while ($val = current($arrTMP)) {
                            if ($m == 0||strtolower(key($arrTMP))=="value") {
                              $st->addAttribute("value",$val);
                            }else{
                              $st->addAttribute(key($arrTMP),$val);
                            }
                            $m++;
                            next($arrTMP);
                        }        
                    }else{
                        $st->addAttribute("value",$val_value);
                    }
                    $dat_st->addMore($st);
                }


            }else{
                
                if($this->tmp_Prop["cat"]!=null){                  
                    for($i=0;$i<count($this->tmp_Prop["cat"]);$i++){
                        $st=new node("set");
                        $st->addAttribute("value",$value_dataset["dat"]);
                        $dat_st->addMore($st);
                    }            
                }
            }
            if($value_dataset["att"]!=null){
                foreach($value_dataset["att"] as $key_att => $val_att){
                  $dat_st->addAttribute($key_att,$val_att);
                }
            }
            $this->data->addMore($dat_st);
          }
       }        
    }
}
?>
